from typing import Tuple, Set, Iterable, List


class GH_EquationFragment:
    @property
    def Bounds(self) -> RectangleF: ...
    @property
    def Description(self) -> str: ...
    @property
    def Icon(self) -> Bitmap: ...
    @property
    def Name(self) -> str: ...
    @property
    def Pivot(self) -> PointF: ...
    @property
    def Size(self) -> SizeF: ...
    def Layout(self, font: Font) -> bool: ...
    def Position(self, location: PointF) -> bool: ...
    def Render(self, graphics: Graphics, font: Font, colour: Color) -> None: ...
    @Pivot.setter
    def Pivot(self, Value: PointF) -> None: ...
    def ToExpression(self) -> str: ...


class GH_SequenceFragment(GH_EquationFragment):
    def __init__(self): ...
    @property
    def Description(self) -> str: ...
    @property
    def Fragments(self) -> List: ...
    @property
    def Name(self) -> str: ...
    def Layout(self, font: Font) -> bool: ...
    def Position(self, location: PointF) -> bool: ...
    def Render(self, graphics: Graphics, font: Font, colour: Color) -> None: ...
    def ToExpression(self) -> str: ...


class GH_TextFragment(GH_EquationFragment):
    def __init__(self): ...
    @property
    def Description(self) -> str: ...
    @property
    def Name(self) -> str: ...
    @property
    def Text(self) -> str: ...
    def Layout(self, font: Font) -> bool: ...
    def Position(self, location: PointF) -> bool: ...
    def Render(self, graphics: Graphics, font: Font, colour: Color) -> None: ...
    @Text.setter
    def Text(self, Value: str) -> None: ...
    def ToExpression(self) -> str: ...


class IGH_EquationFragment:
    @property
    def Bounds(self) -> RectangleF: ...
    @property
    def Description(self) -> str: ...
    @property
    def Icon(self) -> Bitmap: ...
    @property
    def Name(self) -> str: ...
    @property
    def Pivot(self) -> PointF: ...
    @property
    def Size(self) -> SizeF: ...
    def Layout(self, font: Font) -> bool: ...
    def Position(self, location: PointF) -> bool: ...
    def Render(self, graphics: Graphics, font: Font, colour: Color) -> None: ...
    @Pivot.setter
    def Pivot(self, Value: PointF) -> None: ...
    def ToExpression(self) -> str: ...
