from typing import Tuple, Set, Iterable, List


class FileSelectedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: GH_TimeLine, path: str, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: GH_TimeLine, path: str) -> None: ...


class GH_FileEntry:
    def __init__(self, owner: GH_TimeLine, path: str, date: DateTime, name: str): ...
    def CompareTo(self, other: GH_FileEntry) -> int: ...
    @property
    def Bounds(self) -> Rectangle: ...
    @property
    def FileDate(self) -> DateTime: ...
    @property
    def FileName(self) -> str: ...
    @property
    def FilePath(self) -> str: ...
    @property
    def Icon(self) -> Bitmap: ...
    @property
    def ResolvedState(self) -> GH_FileResolveState: ...
    def LayoutWidth(self, width: int) -> None: ...
    def PaintEntry(self, graphics: Graphics) -> None: ...
    def ResolveFileState(self) -> None: ...
    @Bounds.setter
    def Bounds(self, Value: Rectangle) -> None: ...


class GH_FileResolveState:
    Unresolved = 0
    Invalid = 1
    Valid = 2


class GH_MRU_Entry:
    def __init__(self, new_date: DateTime, new_path: str): ...
    def CompareTo(self, other: GH_MRU_Entry) -> int: ...
    @property
    def FileDate(self) -> DateTime: ...
    @property
    def FileName(self) -> str: ...
    @property
    def FilePath(self) -> str: ...
    @FileDate.setter
    def FileDate(self, Value: DateTime) -> None: ...
    @FileName.setter
    def FileName(self, Value: str) -> None: ...
    @FilePath.setter
    def FilePath(self, Value: str) -> None: ...


class GH_MRU_Server:
    def __init__(self): ...
    def add_MRURecordCountChanged(obj: MRURecordCountChangedEventHandler) -> None: ...
    def add_VisibleRecordCountChanged(obj: VisibleRecordCountChangedEventHandler) -> None: ...
    def AppendRecentFileRecord(self, new_date: DateTime, new_path: str) -> None: ...
    def Clear(self) -> None: ...
    def ClearMissingRecords(self) -> None: ...
    @property
    def RecordCount(self) -> int: ...
    @property
    def Records(self) -> List: ...
    @property
    def VisibleRecords() -> int: ...
    def ReadList(self) -> None: ...
    def remove_MRURecordCountChanged(obj: MRURecordCountChangedEventHandler) -> None: ...
    def remove_VisibleRecordCountChanged(obj: VisibleRecordCountChangedEventHandler) -> None: ...
    @VisibleRecords.setter
    def VisibleRecords(Value: int) -> None: ...
    def WriteList(self) -> None: ...


class GH_TimeLine(GH_DoubleBufferedPanel):
    def __init__(self): ...
    def add_FileSelected(self, obj: FileSelectedEventHandler) -> None: ...
    @property
    def ActiveEntry(self) -> GH_FileEntry: ...
    @property
    def Offset(self) -> int: ...
    def remove_FileSelected(self, obj: FileSelectedEventHandler) -> None: ...
    @ActiveEntry.setter
    def ActiveEntry(self, Value: GH_FileEntry) -> None: ...
    @overload
    def SetupTimeline(self) -> None: ...
    @overload
    def SetupTimeline(self, entries: Iterable[GH_MRU_Entry]) -> None: ...


class GH_TimeSpan:
    def __init__(self, owner: GH_TimeLine): ...
    def ContainsDate(self, d: DateTime) -> bool: ...
    @property
    def Bounds(self) -> Rectangle: ...
    @property
    def Entries(self) -> List: ...
    @property
    def SpanEnd(self) -> DateTime: ...
    @property
    def SpanStart(self) -> DateTime: ...
    @property
    def SpanText(self) -> str: ...
    def Layout(self, y: int, width: int) -> None: ...
    def LayoutWidth(self, width: int) -> None: ...
    def PaintSpan(self, graphics: Graphics) -> None: ...
    @Bounds.setter
    def Bounds(self, Value: Rectangle) -> None: ...
    @SpanEnd.setter
    def SpanEnd(self, Value: DateTime) -> None: ...
    @SpanStart.setter
    def SpanStart(self, Value: DateTime) -> None: ...
    @SpanText.setter
    def SpanText(self, Value: str) -> None: ...


class MRURecordCountChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, server: GH_MRU_Server, count: int, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, server: GH_MRU_Server, count: int) -> None: ...


class VisibleRecordCountChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, newCount: int, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, newCount: int) -> None: ...
