from typing import Tuple, Set, Iterable, List


class BufferMode:
    Never = 0
    Always = 1
    Delay = 2


class GH_CleanComponentUpgrader:
    def __init__(self): ...
    @property
    def UpgradeFrom(self) -> Guid: ...
    @property
    def UpgradeTo(self) -> Guid: ...
    @property
    def Version(self) -> DateTime: ...
    def Upgrade(self, target: IGH_DocumentObject, document: GH_Document) -> IGH_DocumentObject: ...


class GH_CleanTreeComponent(GH_Component):
    def __init__(self): ...
    def CanInsertParameter(self, side: GH_ParameterSide, index: int) -> bool: ...
    def CanRemoveParameter(self, side: GH_ParameterSide, index: int) -> bool: ...
    def CreateParameter(self, side: GH_ParameterSide, index: int) -> IGH_Param: ...
    def DestroyParameter(self, side: GH_ParameterSide, index: int) -> bool: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    def VariableParameterMaintenance(self) -> None: ...


class GH_CleanTreeComponent_OBSOLETE(GH_Component):
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...


class GH_CleanTreeComponent_OSBOLETE_AS_WELL(GH_Component):
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...


class GH_CurvatureGraphComponent(GH_Component):
    def __init__(self): ...
    def ClearData(self) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...


class GH_CustomPreviewComponent(GH_Component):
    def __init__(self): ...
    def AppendRenderGeometry(self, args: GH_RenderArgs) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, att: ObjectAttributes, objectIds: List) -> None: ...
    def ClearData(self) -> None: ...
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def DisplayItems(self) -> Iterable[GH_CustomPreviewItem]: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def IncludeInRender(self) -> bool: ...
    @property
    def IsBakeCapable(self) -> bool: ...
    @property
    def ViewportFilter(self) -> str: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    @IncludeInRender.setter
    def IncludeInRender(self, AutoPropertyValue: bool) -> None: ...
    @ViewportFilter.setter
    def ViewportFilter(self, AutoPropertyValue: str) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_CustomPreviewItem:
    def PushToRenderPipeline(self, args: GH_RenderArgs) -> None: ...
    def PushToRhinoDocument(self, doc: RhinoDoc, att: ObjectAttributes) -> Guid: ...


class GH_DataDamAttributes(GH_ComponentAttributes):
    def __init__(self, owner: GH_DataDamComponent): ...
    def RespondToMouseMove(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseUp(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def SetupTooltip(self, canvasPoint: PointF, e: GH_TooltipDisplayEventArgs) -> None: ...


class GH_DataDamComponent(GH_Component):
    def __init__(self): ...
    def AppendMenuItems(self, menu: ToolStripDropDown) -> bool: ...
    def CanInsertParameter(self, side: GH_ParameterSide, index: int) -> bool: ...
    def CanRemoveParameter(self, side: GH_ParameterSide, index: int) -> bool: ...
    def CreateAttributes(self) -> None: ...
    def CreateParameter(self, side: GH_ParameterSide, index: int) -> IGH_Param: ...
    def DestroyParameter(self, side: GH_ParameterSide, index: int) -> bool: ...
    def DocumentContextChanged(self, document: GH_Document, context: GH_DocumentContext) -> None: ...
    def ExpireSolution(self, recompute: bool) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Delay(self) -> TimeSpan: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def Mode(self) -> BufferMode: ...
    @property
    def TransferPossible(self) -> bool: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def RemovedFromDocument(self, document: GH_Document) -> None: ...
    @Delay.setter
    def Delay(self, Value: TimeSpan) -> None: ...
    @Mode.setter
    def Mode(self, Value: BufferMode) -> None: ...
    def VariableParameterMaintenance(self) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_DocExampleComponent(GH_Component):
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...


class GH_ExplodeTreeComponent(GH_Component):
    def __init__(self): ...
    def CanInsertParameter(self, side: GH_ParameterSide, index: int) -> bool: ...
    def CanRemoveParameter(self, side: GH_ParameterSide, index: int) -> bool: ...
    def CreateParameter(self, side: GH_ParameterSide, index: int) -> IGH_Param: ...
    def DestroyParameter(self, side: GH_ParameterSide, index: int) -> bool: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    def VariableParameterMaintenance(self) -> None: ...


class GH_ExplodeTreeComponent_OBSOLETE(GH_Component):
    def __init__(self): ...
    def ConstructVariable(self, e: GH_VarParamEventArgs) -> IGH_Param: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def IsInputVariable(self) -> bool: ...
    @property
    def IsOutputVariable(self) -> bool: ...
    def IsVariableParam(self, e: GH_VarParamEventArgs) -> bool: ...
    def ManagerConstructed(self, side: GH_VarParamSide, manager: GH_VariableParameterManager) -> None: ...
    def ParametersModified(self, side: GH_VarParamSide) -> None: ...


class GH_FlattenComponentUpgrader:
    def __init__(self): ...
    @property
    def UpgradeFrom(self) -> Guid: ...
    @property
    def UpgradeTo(self) -> Guid: ...
    @property
    def Version(self) -> DateTime: ...
    def Upgrade(self, target: IGH_DocumentObject, document: GH_Document) -> IGH_DocumentObject: ...


class GH_FlattenTreeComponent(GH_Component):
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...


class GH_FlattenTreeComponent_OBSOLETE(GH_Component):
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...


class GH_FlipDataMatrixComponent(GH_Component):
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...


class GH_GraftTreeComponent(GH_Component):
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_GraftTreeComponent_OBSOLETE(GH_Component):
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...


class GH_GrasshopperLibraryInfo(GH_AssemblyInfo):
    def __init__(self): ...
    @property
    def AuthorContact(self) -> str: ...
    @property
    def AuthorName(self) -> str: ...
    @property
    def Description(self) -> str: ...
    @property
    def Icon(self) -> Bitmap: ...
    @property
    def Id(self) -> Guid: ...
    @property
    def License(self) -> GH_LibraryLicense: ...
    @property
    def Name(self) -> str: ...
    @property
    def Version(self) -> str: ...


class GH_GroupGeometryComponent(GH_Component):
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...


class GH_IsNullDataComponent_OBSOLETE(GH_Component):
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...


class GH_MatchTreeComponent(GH_Component):
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...


class GH_MergeGroupComponent(GH_Component):
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...


class GH_MetaBallComponent(GH_Component):
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    def SolveMetaBall(component: GH_Component, DA: IGH_DataAccess, context: GH_Context, plane: Plane, threshold: float) -> None: ...


class GH_MetaBallComponentThreshold(GH_Component):
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...


class GH_MetaBallComponentThresholdEx(GH_Component):
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...


class GH_PathCompareComponent(GH_Component):
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...


class GH_PointListComponent(GH_Component):
    def __init__(self): ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, att: ObjectAttributes, obj_ids: List) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def IsPreviewCapable(self) -> bool: ...


class GH_PruneTreeComponent(GH_Component):
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...


class GH_ReadFileComponent(GH_Component):
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, file: str): ...
    def CreateAttributes(self) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def Parser(self) -> GH_LineParser: ...
    @property
    def PerLineParse(self) -> bool: ...
    def IsAcceptableFileFormat(filename: str) -> bool: ...
    def Menu_ParserClicked(self, sender: Object, e: EventArgs) -> None: ...
    def Menu_PerLineClicked(self, sender: Object, e: EventArgs) -> None: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    @Parser.setter
    def Parser(self, AutoPropertyValue: GH_LineParser) -> None: ...
    @PerLineParse.setter
    def PerLineParse(self, Value: bool) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_ReadFileComponentAttributes(GH_ComponentAttributes):
    def __init__(self, owner: GH_ReadFileComponent): ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...


class GH_ReplacePathComponent(GH_Component):
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...


class GH_ShiftDataPathComponent(GH_Component):
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...


class GH_SimplifyComponentUpgrader:
    def __init__(self): ...
    @property
    def UpgradeFrom(self) -> Guid: ...
    @property
    def UpgradeTo(self) -> Guid: ...
    @property
    def Version(self) -> DateTime: ...
    def Upgrade(self, target: IGH_DocumentObject, document: GH_Document) -> IGH_DocumentObject: ...


class GH_SimplifyTreeComponent(GH_Component):
    def __init__(self): ...
    def AddedToDocument(self, document: GH_Document) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    def MovedBetweenDocuments(self, oldDocument: GH_Document, newDocument: GH_Document) -> None: ...
    def RemovedFromDocument(self, document: GH_Document) -> None: ...


class GH_SimplifyTreeComponent_OBSOLETE(GH_Component):
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...


class GH_SmoothNumbersComponent(GH_Component):
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_SplitGroupComponent(GH_Component):
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...


class GH_StreamFilterComponent(GH_Component):
    def __init__(self): ...
    def CanInsertParameter(self, side: GH_ParameterSide, index: int) -> bool: ...
    def CanRemoveParameter(self, side: GH_ParameterSide, index: int) -> bool: ...
    def CreateParameter(self, side: GH_ParameterSide, index: int) -> IGH_Param: ...
    def DestroyParameter(self, side: GH_ParameterSide, index: int) -> bool: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    def VariableParameterMaintenance(self) -> None: ...


class GH_StreamFilterComponent_OBSOLETE(GH_Component):
    def __init__(self): ...
    def ConstructVariable(self, e: GH_VarParamEventArgs) -> IGH_Param: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def IsInputVariable(self) -> bool: ...
    @property
    def IsOutputVariable(self) -> bool: ...
    def IsVariableParam(self, e: GH_VarParamEventArgs) -> bool: ...
    def ManagerConstructed(self, side: GH_VarParamSide, manager: GH_VariableParameterManager) -> None: ...
    def ParametersModified(self, side: GH_VarParamSide) -> None: ...


class GH_StreamGateComponent(GH_Component):
    def __init__(self): ...
    def CanInsertParameter(self, side: GH_ParameterSide, index: int) -> bool: ...
    def CanRemoveParameter(self, side: GH_ParameterSide, index: int) -> bool: ...
    def CreateParameter(self, side: GH_ParameterSide, index: int) -> IGH_Param: ...
    def DestroyParameter(self, side: GH_ParameterSide, index: int) -> bool: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    def VariableParameterMaintenance(self) -> None: ...


class GH_StreamGateComponent_OBSOLETE(GH_Component):
    def __init__(self): ...
    def ConstructVariable(self, e: GH_VarParamEventArgs) -> IGH_Param: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def IsInputVariable(self) -> bool: ...
    @property
    def IsOutputVariable(self) -> bool: ...
    def IsVariableParam(self, e: GH_VarParamEventArgs) -> bool: ...
    def ManagerConstructed(self, side: GH_VarParamSide, manager: GH_VariableParameterManager) -> None: ...
    def ParametersModified(self, side: GH_VarParamSide) -> None: ...


class GH_TextTag3DComponent(GH_Component):
    def __init__(self): ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, obj_ids: List) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, att: ObjectAttributes, obj_ids: List) -> None: ...
    def ClearData(self) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def IsPreviewCapable(self) -> bool: ...


class GH_TextTag3DComponent_OBSOLETE(GH_Component):
    def __init__(self): ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, obj_ids: List) -> None: ...
    def ClearData(self) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def IsPreviewCapable(self) -> bool: ...


class GH_TextTag3DComponent_OBSOLETE_AS_WELL(GH_Component):
    def __init__(self): ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, obj_ids: List) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, att: ObjectAttributes, obj_ids: List) -> None: ...
    def ClearData(self) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def IsPreviewCapable(self) -> bool: ...


class GH_TextTag3DUpgrader:
    def __init__(self): ...
    @property
    def UpgradeFrom(self) -> Guid: ...
    @property
    def UpgradeTo(self) -> Guid: ...
    @property
    def Version(self) -> DateTime: ...
    def Upgrade(self, target: IGH_DocumentObject, document: GH_Document) -> IGH_DocumentObject: ...


class GH_TextTagComponent(GH_Component):
    def __init__(self): ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, obj_ids: List) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, att: ObjectAttributes, obj_ids: List) -> None: ...
    def ClearData(self) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    @property
    def TagHeight(self) -> int: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    @TagHeight.setter
    def TagHeight(self, Value: int) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_TextTagComponent_OBSOLETE(GH_Component):
    def __init__(self): ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, obj_ids: List) -> None: ...
    def ClearData(self) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    @property
    def TagHeight(self) -> int: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    @TagHeight.setter
    def TagHeight(self, Value: int) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_TreeSplitComponent(GH_Component):
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...


class GH_TrimTreeComponent(GH_Component):
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...


class GH_UnflattenTreeComponent(GH_Component):
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...


class GH_UngroupGeometryComponent(GH_Component):
    def __init__(self): ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...


class GH_UpgradeExplodeComponent:
    def __init__(self): ...
    @property
    def UpgradeFrom(self) -> Guid: ...
    @property
    def UpgradeTo(self) -> Guid: ...
    @property
    def Version(self) -> DateTime: ...
    def Upgrade(self, target: IGH_DocumentObject, document: GH_Document) -> IGH_DocumentObject: ...


class Upgrade_StreamGateComponent:
    def __init__(self): ...
    @property
    def UpgradeFrom(self) -> Guid: ...
    @property
    def UpgradeTo(self) -> Guid: ...
    @property
    def Version(self) -> DateTime: ...
    def Upgrade(self, target: IGH_DocumentObject, document: GH_Document) -> IGH_DocumentObject: ...
