__all__ = ['SketchElements']
from typing import Tuple, Set, Iterable, List


class Alignment:
    Default = 0
    Left = 1
    Center = 2
    Right = 3


class GH_BarData:
    def __init__(self, min: float, max: float): ...


class GH_BarGraph:
    def __init__(self): ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    def CreateAttributes(self) -> None: ...
    @property
    def BarCount(self) -> int: ...
    @property
    def Bars(self) -> List: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def GraphColour(self) -> Color: ...
    @property
    def IconCapableUI(self) -> bool: ...
    @property
    def InstanceDescription(self) -> str: ...
    @property
    def Kind(self) -> GH_ParamKind: ...
    @property
    def MaxBar(self) -> GH_BarData: ...
    @property
    def MaxBarIndex(self) -> int: ...
    @property
    def TypeName(self) -> str: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    @BarCount.setter
    def BarCount(self, Value: int) -> None: ...
    @GraphColour.setter
    def GraphColour(self, Value: Color) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_BarGraphAttributes:
    def __init__(self, owner: GH_BarGraph): ...
    @property
    def PathName(self) -> str: ...


class GH_BooleanSwitch_Obsolete:
    def __init__(self): ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    def CreateAttributes(self) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def DataType(self) -> GH_ParamData: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def IconCapableUI(self) -> bool: ...
    @property
    def Kind(self) -> GH_ParamKind: ...
    @property
    def SwitchValue(self) -> bool: ...
    def LoadState(self, state: str) -> None: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def SaveState(self) -> str: ...
    @SwitchValue.setter
    def SwitchValue(self, Value: bool) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_BooleanSwitchAttributesObsolete:
    def __init__(self, owner: GH_BooleanSwitch_Obsolete): ...
    def ExpireLayout(self) -> None: ...
    @property
    def HasInputGrip(self) -> bool: ...
    @property
    def TooltipEnabled(self) -> bool: ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...


class GH_BooleanToggle:
    def __init__(self): ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    def CreateAttributes(self) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def DataType(self) -> GH_ParamData: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def IconCapableUI(self) -> bool: ...
    @property
    def Kind(self) -> GH_ParamKind: ...
    @property
    def Value(self) -> bool: ...
    def LoadState(self, state: str) -> None: ...
    def PublishRcpItem(self) -> IRcpItem: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def SaveState(self) -> str: ...
    @Value.setter
    def Value(self, Value: bool) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_BooleanToggleAttributes:
    def __init__(self, owner: GH_BooleanToggle): ...
    @property
    def HasInputGrip(self) -> bool: ...
    @property
    def TooltipEnabled(self) -> bool: ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def SetupTooltip(self, point: PointF, e: GH_TooltipDisplayEventArgs) -> None: ...


class GH_BooleanTogglePublishProxy:
    def __init__(self, owner: GH_BooleanToggle): ...
    @property
    def DesiredHeight(self) -> int: ...
    def MouseClick(self, e: MouseEventArgs) -> GH_ObjectResponse: ...
    def MouseDoubleClick(self, e: MouseEventArgs) -> GH_ObjectResponse: ...
    def Render(self, G: Graphics) -> None: ...


class GH_ButtonObject:
    def __init__(self): ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    def CreateAttributes(self) -> None: ...
    def EvaluateExpressions(self) -> None: ...
    @property
    def ButtonDown(self) -> bool: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def DataType(self) -> GH_ParamData: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def ExpressionNormal(self) -> str: ...
    @property
    def ExpressionPressed(self) -> str: ...
    @property
    def IconCapableUI(self) -> bool: ...
    @property
    def Kind(self) -> GH_ParamKind: ...
    def PublishRcpItem(self) -> IRcpItem: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    @ButtonDown.setter
    def ButtonDown(self, Value: bool) -> None: ...
    @ExpressionNormal.setter
    def ExpressionNormal(self, Value: str) -> None: ...
    @ExpressionPressed.setter
    def ExpressionPressed(self, Value: str) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_ButtonObjectAttributes:
    def __init__(self, owner: GH_ButtonObject): ...
    @property
    def HasInputGrip(self) -> bool: ...
    @property
    def TooltipEnabled(self) -> bool: ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseMove(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseUp(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def SetupTooltip(self, point: PointF, e: GH_TooltipDisplayEventArgs) -> None: ...


class GH_ButtonPublishProxy:
    def __init__(self, owner: GH_ButtonObject): ...
    @property
    def DesiredHeight(self) -> int: ...
    def MouseDown(self, e: MouseEventArgs) -> GH_ObjectResponse: ...
    def MouseUp(self, e: MouseEventArgs) -> GH_ObjectResponse: ...
    def Render(self, G: Graphics) -> None: ...


class GH_Cluster(GH_Component):
    def __init__(self): ...
    def AddedToDocument(self, document: GH_Document) -> None: ...
    def AssignNewPassword(self, oldPassword: str, newPassword: str) -> bool: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, objectIds: List) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, att: ObjectAttributes, objectIds: List) -> None: ...
    def CanInsertParameter(self, side: GH_ParameterSide, index: int) -> bool: ...
    def CanRemoveParameter(self, side: GH_ParameterSide, index: int) -> bool: ...
    def CreateAttributes(self) -> None: ...
    @overload
    def CreateFromDocument(self, document: GH_Document) -> None: ...
    @overload
    def CreateFromDocument(self, document: GH_Document, location: Point) -> None: ...
    @overload
    def CreateFromFilePath(self, path: str) -> None: ...
    @overload
    def CreateFromFilePath(self, path: str, location: Point) -> None: ...
    def CreateFromSelection(self, sourceDocument: GH_Document, deleteOriginalObjects: bool, reconnectSources: bool, reconnectRecipients: bool) -> None: ...
    def CreateParameter(self, side: GH_ParameterSide, index: int) -> IGH_Param: ...
    def DestroyParameter(self, side: GH_ParameterSide, index: int) -> bool: ...
    def DisplayClusterPropertiesEditor(self) -> None: ...
    def Document(self, password: str) -> GH_Document: ...
    def DocumentClosed(self, document: GH_Document) -> None: ...
    def DocumentContextChanged(self, document: GH_Document, context: GH_DocumentContext) -> None: ...
    def DocumentModified(self, modifiedDocument: GH_Document) -> None: ...
    def DoKeysMatch(key0: Set(Byte), key1: Set(Byte)) -> bool: ...
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    def EditClusterAsSeparateDocument(self) -> None: ...
    def ExplodeCluster(self) -> None: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def DocumentId(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def FilePath(self) -> str: ...
    @property
    def IsBakeCapable(self) -> bool: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    @property
    def Locked(self) -> bool: ...
    @property
    def PreviewContent(self) -> bool: ...
    @property
    def ProtectionLevel(self) -> GH_ClusterProtection: ...
    @property
    def Synchronisation(self) -> GH_Synchronisation: ...
    def InstanceGuidsChanged(self, map: SortedDictionary) -> None: ...
    def IsPasswordValid(self, password: str) -> bool: ...
    def OwnerDocument(self) -> GH_Document: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def ReadGhClusterFile(self, path: str) -> bool: ...
    def RemovedFromDocument(self, document: GH_Document) -> None: ...
    def RequestPassword(self, prompt: str) -> bool: ...
    @DocumentId.setter
    def DocumentId(self, Value: Guid) -> None: ...
    @Locked.setter
    def Locked(self, Value: bool) -> None: ...
    @PreviewContent.setter
    def PreviewContent(self, Value: bool) -> None: ...
    def UpdateDocument(self, document: GH_Document) -> None: ...
    def VariableParameterMaintenance(self) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...
    def WriteGhClusterFile(self, path: str) -> bool: ...


class GH_Cluster_OBSOLETE(GH_Component):
    def __init__(self): ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, obj_ids: List) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, att: ObjectAttributes, obj_ids: List) -> None: ...
    def CreateAttributes(self) -> None: ...
    def CreateFromDocument(self, doc: GH_Document) -> bool: ...
    def CreateFromSelection(self, doc: GH_Document) -> bool: ...
    def DisplayClusterPropertiesEditor(self) -> None: ...
    def DocumentClosed(self, document: GH_Document) -> None: ...
    def DocumentModified(self, document: GH_Document) -> None: ...
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    @property
    def AuthorCompany(self) -> str: ...
    @property
    def AuthorContact(self) -> str: ...
    @property
    def AuthorCopyright(self) -> str: ...
    @property
    def AuthorName(self) -> str: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def InternalDocument(self) -> GH_Document: ...
    @property
    def IsBakeCapable(self) -> bool: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    @property
    def Locked(self) -> bool: ...
    def OwnerDocument(self) -> GH_Document: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    @AuthorCompany.setter
    def AuthorCompany(self, Value: str) -> None: ...
    @AuthorContact.setter
    def AuthorContact(self, Value: str) -> None: ...
    @AuthorCopyright.setter
    def AuthorCopyright(self, Value: str) -> None: ...
    @AuthorName.setter
    def AuthorName(self, Value: str) -> None: ...
    @Locked.setter
    def Locked(self, Value: bool) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_ClusterAttributes(GH_ComponentAttributes):
    def __init__(self, owner: GH_Cluster): ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def SetupTooltip(self, point: PointF, e: GH_TooltipDisplayEventArgs) -> None: ...


class GH_ClusterAttributes_OBSOLETE(GH_ComponentAttributes):
    def __init__(self, owner: GH_Cluster_OBSOLETE): ...
    @property
    def Selected(self) -> bool: ...
    @property
    def TooltipEnabled(self) -> bool: ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    @Selected.setter
    def Selected(self, Value: bool) -> None: ...
    def SetupTooltip(self, point: PointF, e: GH_TooltipDisplayEventArgs) -> None: ...


class GH_ClusterDocumentIdAction(GH_ObjectUndoAction):
    def __init__(self, cluster: GH_Cluster): ...


class GH_ClusterFileType:
    #None = 0
    Gh = 1
    Ghx = 2
    GhCluster = 3
    Unknown = 4


class GH_ClusterHook:
    def __init__(self, tag: IGH_InstanceDescription): ...
    def AppendMenuItems(self, menu: ToolStripDropDown) -> bool: ...
    @property
    def CustomDescription(self) -> str: ...
    @property
    def CustomName(self) -> str: ...
    @property
    def CustomNickName(self) -> str: ...
    @property
    def Description(self) -> str: ...
    @property
    def Kind(self) -> GH_ParamKind: ...
    @property
    def Name(self) -> str: ...
    @property
    def NickName(self) -> str: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    @CustomDescription.setter
    def CustomDescription(self, Value: str) -> None: ...
    @CustomName.setter
    def CustomName(self, Value: str) -> None: ...
    @CustomNickName.setter
    def CustomNickName(self, Value: str) -> None: ...
    @Description.setter
    def Description(self, Value: str) -> None: ...
    @Name.setter
    def Name(self, Value: str) -> None: ...
    @NickName.setter
    def NickName(self, Value: str) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...




class GH_ClusterInputHook(GH_ClusterHook):
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, target: IGH_Param): ...
    def ClearPlaceholderData(self) -> None: ...
    def CreateAttributes(self) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def ObjID() -> Guid: ...
    def SetPlaceholderData(self, data: GH_Structure) -> None: ...


class GH_ClusterInputHookAttributes:
    def __init__(self, owner: GH_ClusterInputHook): ...
    @property
    def HasInputGrip(self) -> bool: ...
    @property
    def HasOutputGrip(self) -> bool: ...
    @property
    def OutputGrip(self) -> PointF: ...
    def SetupTooltip(self, canvasPoint: PointF, e: GH_TooltipDisplayEventArgs) -> None: ...


class GH_ClusterOutputHook(GH_ClusterHook):
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, target: IGH_Param): ...
    def CreateAttributes(self) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def ObjID() -> Guid: ...


class GH_ClusterOutputHookAttributes:
    def __init__(self, owner: GH_ClusterOutputHook): ...
    @property
    def HasInputGrip(self) -> bool: ...
    @property
    def HasOutputGrip(self) -> bool: ...
    def SetupTooltip(self, canvasPoint: PointF, e: GH_TooltipDisplayEventArgs) -> None: ...


class GH_ClusterPasswordUndoAction(GH_ObjectUndoAction):
    def __init__(self, cluster: GH_Cluster): ...


class GH_ClusterPreviewDocumentAction(GH_ObjectUndoAction):
    def __init__(self, cluster: GH_Cluster): ...


class GH_ClusterPropertiesUndoAction(GH_ObjectUndoAction):
    def __init__(self, cluster: GH_Cluster): ...


class GH_ClusterProtection:
    Unprotected = 0
    Protected = 1


class GH_ClusterReferenceAction(GH_ObjectUndoAction):
    def __init__(self, cluster: GH_Cluster): ...


class GH_ColourPickerAttributes:
    def __init__(self, owner: GH_ColourPickerObject): ...
    @property
    def HasInputGrip(self) -> bool: ...
    @property
    def HasOutputGrip(self) -> bool: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseMove(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseUp(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def SetupTooltip(self, point: PointF, e: GH_TooltipDisplayEventArgs) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_ColourPickerObject:
    def __init__(self): ...
    def CreateAttributes(self) -> None: ...
    @property
    def Colour(self) -> Color: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    @Colour.setter
    def Colour(self, Value: Color) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_ColourSwatch:
    def __init__(self): ...
    def CreateAttributes(self) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def DataType(self) -> GH_ParamData: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def IconCapableUI(self) -> bool: ...
    @property
    def Kind(self) -> GH_ParamKind: ...
    @property
    def SwatchColour(self) -> Color: ...
    def LoadState(self, state: str) -> None: ...
    def PublishRcpItem(self) -> IRcpItem: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def SaveState(self) -> str: ...
    @SwatchColour.setter
    def SwatchColour(self, Value: Color) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_ColourSwatchAttributes:
    def __init__(self, owner: GH_ColourSwatch): ...
    @property
    def HasInputGrip(self) -> bool: ...
    @property
    def TooltipEnabled(self) -> bool: ...
    def RespondToMouseUp(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...


class GH_ColourSwatchPublishProxy:
    def __init__(self, owner: GH_ColourSwatch): ...
    @property
    def DesiredHeight(self) -> int: ...
    def MouseClick(self, e: MouseEventArgs) -> GH_ObjectResponse: ...
    def Render(self, G: Graphics) -> None: ...


class GH_ColourWheel:
    def __init__(self): ...
    def AppendMenuItems(self, menu: ToolStripDropDown) -> bool: ...
    def CreateAttributes(self) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def State(self) -> GH_ColourWheelState: ...
    def LoadState(self, state: str) -> None: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def SaveState(self) -> str: ...
    @State.setter
    def State(self, Value: GH_ColourWheelState) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_ColourWheelAttributes:
    def __init__(self, owner: GH_ColourWheel): ...
    @property
    def AllowMessageBalloon(self) -> bool: ...
    @overload
    def IsPickRegion(self, point: PointF) -> bool: ...
    @overload
    def IsPickRegion(self, box: RectangleF, method: GH_PickBox) -> bool: ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseMove(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseUp(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def SetupTooltip(self, point: PointF, e: GH_TooltipDisplayEventArgs) -> None: ...


class GH_ColourWheelGrip:
    NoGrip = 0
    LowestIndex = 1
    A = 1
    Amin = 2
    Amax = 3
    B = 4
    Bmin = 5
    Bmax = 6
    C = 7
    Cmin = 8
    Cmax = 9
    D = 10
    Dmin = 11
    Dmax = 12
    SatMin = 13
    SatMax = 14
    LumMin = 15
    LumMax = 16
    HighestIndex = 16


class GH_ColourWheelState:
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, other: GH_ColourWheelState): ...
    @overload
    def BeginGripDrag(self, cursor: PointF) -> bool: ...
    @overload
    def BeginGripDrag(self, cursor: Point3d) -> bool: ...
    @overload
    def ContinueGripDrag(self, cursor: PointF) -> bool: ...
    @overload
    def ContinueGripDrag(self, cursor: Point3d) -> bool: ...
    def CreatePalette(self, seed: int, count: int) -> List: ...
    def EndGripDrag(self) -> None: ...
    @property
    def Dragging(self) -> bool: ...
    @property
    def LuminanceMax(self) -> float: ...
    @property
    def LuminanceMin(self) -> float: ...
    @property
    def LuminanceRail(self) -> Arc: ...
    @property
    def SaturationMax(self) -> float: ...
    @property
    def SaturationMin(self) -> float: ...
    @property
    def SaturationRail(self) -> Arc: ...
    @property
    def Style(self) -> GH_ColourWheelStyle: ...
    @property
    def Wheel(self) -> Circle: ...
    def GetGrip(self, grip: GH_ColourWheelGrip) -> Point3d: ...
    @overload
    def GripAtPoint(self, point: Point3d) -> GH_ColourWheelGrip: ...
    @overload
    def GripAtPoint(self, point: PointF) -> GH_ColourWheelGrip: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def RenderWheel(self, graphics: Graphics, alpha: float, selected: bool) -> None: ...
    @LuminanceMax.setter
    def LuminanceMax(self, Value: float) -> None: ...
    @LuminanceMin.setter
    def LuminanceMin(self, Value: float) -> None: ...
    @SaturationMax.setter
    def SaturationMax(self, Value: float) -> None: ...
    @SaturationMin.setter
    def SaturationMin(self, Value: float) -> None: ...
    @Style.setter
    def Style(self, Value: GH_ColourWheelStyle) -> None: ...
    @Wheel.setter
    def Wheel(self, Value: Circle) -> None: ...
    def SetDefault(self, style: GH_ColourWheelStyle) -> None: ...
    def SetGrip(self, grip: GH_ColourWheelGrip, position: Point3d) -> bool: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_ColourWheelStyle:
    Monochromatic = 10
    Bichromatic = 20
    Complementary = 21
    Trichromatic = 30
    Triad = 31
    Tetrachromatic = 40
    Tetrad = 41


class GH_ConstantObject:
    def __init__(self): ...
    def CreateAttributes(self) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def Kind(self) -> GH_ParamKind: ...


class GH_ConstantObjectAttributes(GH_FloatingParamAttributes):
    def __init__(self, owner: GH_ConstantObject): ...
    @property
    def HasOutputGrip(self) -> bool: ...


class GH_DataRecorder:
    def __init__(self): ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    def CreateAttributes(self) -> None: ...
    def DestroyRecordedData(self) -> None: ...
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def DataLimit(self) -> int: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def Hidden(self) -> bool: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    @property
    def RecordData(self) -> bool: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    @DataLimit.setter
    def DataLimit(self, Value: int) -> None: ...
    @Hidden.setter
    def Hidden(self, Value: bool) -> None: ...
    @RecordData.setter
    def RecordData(self, Value: bool) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_DataRecorderAttributes:
    def __init__(self, owner: GH_DataRecorder): ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseMove(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def SetupTooltip(self, canvasPoint: PointF, e: GH_TooltipDisplayEventArgs) -> None: ...


class GH_DialKnob:
    def __init__(self): ...
    def Angle(self) -> float: ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    def CreateAttributes(self) -> None: ...
    def DisplaySettingsWindow(self) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Decimals(self) -> int: ...
    @property
    def DisplayFormat(self) -> str: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def Limit(self) -> bool: ...
    @property
    def Maximum(self) -> Decimal: ...
    @property
    def Minimum(self) -> Decimal: ...
    @property
    def Range(self) -> Decimal: ...
    @property
    def Value(self) -> Decimal: ...
    def LoadState(self, state: str) -> None: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def RepairValue(self) -> None: ...
    def SaveState(self) -> str: ...
    @Decimals.setter
    def Decimals(self, Value: int) -> None: ...
    @DisplayFormat.setter
    def DisplayFormat(self, Value: str) -> None: ...
    @Limit.setter
    def Limit(self, Value: bool) -> None: ...
    @Maximum.setter
    def Maximum(self, Value: Decimal) -> None: ...
    @Minimum.setter
    def Minimum(self, Value: Decimal) -> None: ...
    @Range.setter
    def Range(self, Value: Decimal) -> None: ...
    @Value.setter
    def Value(self, Value: Decimal) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_DialKnobAttributes:
    def __init__(self, owner: GH_DialKnob): ...
    @property
    def AllowMessageBalloon(self) -> bool: ...
    @property
    def HasInputGrip(self) -> bool: ...
    @property
    def HasOutputGrip(self) -> bool: ...
    @overload
    def IsPickRegion(self, point: PointF) -> bool: ...
    @overload
    def IsPickRegion(self, box: RectangleF, method: GH_PickBox) -> bool: ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseMove(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseUp(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def SetupTooltip(self, point: PointF, e: GH_TooltipDisplayEventArgs) -> None: ...


class GH_DigitScroller:
    def __init__(self): ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    def CreateAttributes(self) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def DataType(self) -> GH_ParamData: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def IconCapableUI(self) -> bool: ...
    @property
    def ImpliedNickName(self) -> str: ...
    @property
    def InstanceDescription(self) -> str: ...
    @property
    def Kind(self) -> GH_ParamKind: ...
    @property
    def Scroller(self) -> GH_DigitScrollerBase: ...
    @property
    def TypeName(self) -> str: ...
    def LoadState(self, state: str) -> None: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def SaveState(self) -> str: ...
    def SetInitCode(self, code: str) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_DigitScrollerAttributes:
    def __init__(self, nOwner: GH_DigitScroller): ...
    def ExpireLayout(self) -> None: ...
    @property
    def HasInputGrip(self) -> bool: ...
    @property
    def ScrollerBox(self) -> RectangleF: ...
    @property
    def TooltipEnabled(self) -> bool: ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseMove(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseUp(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...


class GH_GeometryCache:
    def __init__(self): ...
    def AppendMenuItems(self, menu: ToolStripDropDown) -> bool: ...
    def CreateAttributes(self) -> None: ...
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def Hidden(self) -> bool: ...
    @property
    def IconCapableUI(self) -> bool: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    @property
    def TypeName(self) -> str: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def ReadGeometryCache(self) -> None: ...
    def RegisterRemoteIDs(self, table: GH_GuidTable) -> None: ...
    @Hidden.setter
    def Hidden(self, AutoPropertyValue: bool) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...
    def WriteGeometryCache(self) -> None: ...


class GH_GeometryCacheAttributes:
    def __init__(self, owner: GH_GeometryCache): ...
    def ExpireLayout(self) -> None: ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseMove(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def SetupTooltip(self, canvasPoint: PointF, e: GH_TooltipDisplayEventArgs) -> None: ...


class GH_GeometryPipeline:
    def __init__(self): ...
    def AddedToDocument(self, document: GH_Document) -> None: ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    def AppendMenuItems(self, menu: ToolStripDropDown) -> bool: ...
    def CreateAttributes(self) -> None: ...
    def DocumentContextChanged(self, document: GH_Document, context: GH_DocumentContext) -> None: ...
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    def ExpireSolution(self, recompute: bool) -> None: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def GroupByLayer(self) -> bool: ...
    @property
    def GroupByType(self) -> bool: ...
    @property
    def Hidden(self) -> bool: ...
    @property
    def IncludeHidden(self) -> bool: ...
    @property
    def IncludeLocked(self) -> bool: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    @property
    def LayerFilter(self) -> str: ...
    @property
    def Locked(self) -> bool: ...
    @property
    def NameFilter(self) -> str: ...
    @property
    def TypeFilter(self) -> ObjectType: ...
    @property
    def TypeName(self) -> str: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def RemovedFromDocument(self, document: GH_Document) -> None: ...
    @GroupByLayer.setter
    def GroupByLayer(self, Value: bool) -> None: ...
    @GroupByType.setter
    def GroupByType(self, Value: bool) -> None: ...
    @Hidden.setter
    def Hidden(self, Value: bool) -> None: ...
    @IncludeHidden.setter
    def IncludeHidden(self, Value: bool) -> None: ...
    @IncludeLocked.setter
    def IncludeLocked(self, Value: bool) -> None: ...
    @LayerFilter.setter
    def LayerFilter(self, Value: str) -> None: ...
    @Locked.setter
    def Locked(self, Value: bool) -> None: ...
    @NameFilter.setter
    def NameFilter(self, Value: str) -> None: ...
    @TypeFilter.setter
    def TypeFilter(self, Value: ObjectType) -> None: ...
    def ToggleTypeFilter(self, filter: ObjectType) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_GeometryPipelineAttributes:
    def __init__(self, owner: GH_GeometryPipeline): ...
    def ExpireLayout(self) -> None: ...
    @property
    def HasInputGrip(self) -> bool: ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def SetupTooltip(self, point: PointF, e: GH_TooltipDisplayEventArgs) -> None: ...


class GH_GradientControl(GH_Component):
    def __init__(self): ...
    def AppendMenuItems(self, menu: ToolStripDropDown) -> bool: ...
    def CreateAttributes(self) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def DefaultGradient() -> GH_Gradient: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def Gradient(self) -> GH_Gradient: ...
    @property
    def GradientPresets() -> List: ...
    def LoadState(self, state: str) -> None: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def SaveState(self) -> str: ...
    @DefaultGradient.setter
    def DefaultGradient(Value: GH_Gradient) -> None: ...
    @Gradient.setter
    def Gradient(self, Value: GH_Gradient) -> None: ...
    @GradientPresets.setter
    def GradientPresets(Value: List) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_GradientControlAttributes:
    def __init__(self, gradient: GH_GradientControl): ...
    def AppendToAttributeTree(self, attributes: List) -> None: ...
    @property
    def PathName(self) -> str: ...
    def GradientRectangle(self) -> Rectangle: ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseMove(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseUp(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...


class GH_GraphMapper:
    def __init__(self): ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    def CreateAttributes(self) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Container(self) -> GH_GraphContainer: ...
    @property
    def Description(self) -> str: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def Graph(self) -> IGH_Graph: ...
    @property
    def IconCapableUI(self) -> bool: ...
    @property
    def InstanceDescription(self) -> str: ...
    @property
    def TypeName(self) -> str: ...
    def LoadState(self, state: str) -> None: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def SaveState(self) -> str: ...
    @Container.setter
    def Container(self, Value: GH_GraphContainer) -> None: ...
    @Description.setter
    def Description(self, Value: str) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_GraphMapperAttributes:
    def __init__(self, owner: GH_GraphMapper): ...
    @property
    def DrawDomainTags(self) -> bool: ...
    @property
    def PathName(self) -> str: ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseMove(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseUp(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    @DrawDomainTags.setter
    def DrawDomainTags(self, Value: bool) -> None: ...


class GH_Group(GH_DocumentObject):
    def __init__(self): ...
    def AddObject(self, id: Guid) -> None: ...
    def AppendMenuItems(self, menu: ToolStripDropDown) -> bool: ...
    def ContentBoxes(self) -> List: ...
    def CreateAttributes(self) -> None: ...
    def ExpireCaches(self) -> None: ...
    @property
    def Border(self) -> GH_GroupBorder: ...
    @property
    def Colour(self) -> Color: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def EditMode(self) -> bool: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def GroupID() -> Guid: ...
    @property
    def ObjectIDs(self) -> List: ...
    def InstanceGuidsChanged(self, map: SortedDictionary) -> None: ...
    def Objects(self) -> List: ...
    def ObjectsRecursive(self) -> List: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def RemoveObject(self, id: Guid) -> None: ...
    @Border.setter
    def Border(self, Value: GH_GroupBorder) -> None: ...
    @Colour.setter
    def Colour(self, AutoPropertyValue: Color) -> None: ...
    @EditMode.setter
    def EditMode(self, AutoPropertyValue: bool) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_GroupAttributes:
    def __init__(self, owner: GH_Group): ...
    def AppendToAttributeTree(self, attributes: List) -> None: ...
    def ExpireLayout(self) -> None: ...
    @property
    def AllowMessageBalloon(self) -> bool: ...
    @property
    def Bounds(self) -> RectangleF: ...
    @property
    def DocObject(self) -> IGH_DocumentObject: ...
    @property
    def GetTopLevel(self) -> IGH_Attributes: ...
    @property
    def HasInputGrip(self) -> bool: ...
    @property
    def HasOutputGrip(self) -> bool: ...
    @property
    def InputGrip(self) -> PointF: ...
    @property
    def InstanceGuid(self) -> Guid: ...
    @property
    def IsTopLevel(self) -> bool: ...
    @property
    def OutputGrip(self) -> PointF: ...
    @property
    def Parent(self) -> IGH_Attributes: ...
    @property
    def PathName(self) -> str: ...
    @property
    def Pivot(self) -> PointF: ...
    @property
    def Selected(self) -> bool: ...
    @property
    def TooltipEnabled(self) -> bool: ...
    def InvalidateCanvas(self, canvas: GH_Canvas, e: GH_CanvasMouseEvent) -> bool: ...
    def IsMenuRegion(self, point: PointF) -> bool: ...
    @overload
    def IsPickRegion(self, point: PointF) -> bool: ...
    @overload
    def IsPickRegion(self, box: RectangleF, method: GH_PickBox) -> bool: ...
    def IsTooltipPoint(self, point: PointF) -> bool: ...
    def Layout(self) -> None: ...
    @overload
    def NewInstanceGuid(self) -> None: ...
    @overload
    def NewInstanceGuid(self, newId: Guid) -> None: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def RenderToCanvas(self, canvas: GH_Canvas, channel: GH_CanvasChannel) -> None: ...
    def RespondToKeyDown(self, sender: GH_Canvas, e: KeyEventArgs) -> GH_ObjectResponse: ...
    def RespondToKeyUp(self, sender: GH_Canvas, e: KeyEventArgs) -> GH_ObjectResponse: ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseMove(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseUp(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    @Bounds.setter
    def Bounds(self, Value: RectangleF) -> None: ...
    @Parent.setter
    def Parent(self, Value: IGH_Attributes) -> None: ...
    @Pivot.setter
    def Pivot(self, Value: PointF) -> None: ...
    @Selected.setter
    def Selected(self, Value: bool) -> None: ...
    def SetupTooltip(self, canvasPoint: PointF, e: GH_TooltipDisplayEventArgs) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_GroupBorder:
    #None = 0
    Box = 1
    Blob = 2
    Rectangles = 3


class GH_ImageSampler:
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, initial_image: str): ...
    def AcceptableFile(self, path: str) -> bool: ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    def CreateAttributes(self) -> None: ...
    def DisplaySettings(self) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def DisplayImage(self) -> Bitmap: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def IconCapableUI(self) -> bool: ...
    @property
    def Image(self) -> Bitmap: ...
    @property
    def ImageAutoUpdate(self) -> bool: ...
    @property
    def ImageBitsLocked(self) -> bool: ...
    @property
    def ImageFilePath(self) -> str: ...
    @property
    def ImageSaveInFile(self) -> bool: ...
    @property
    def InstanceDescription(self) -> str: ...
    @property
    def Kind(self) -> GH_ParamKind: ...
    @property
    def SamplerDomain(self) -> UVInterval: ...
    @property
    def SamplerFilter(self) -> GH_SamplingFilter: ...
    @property
    def SamplerInterpolate(self) -> bool: ...
    @property
    def SamplerWrapMode(self) -> WrapMode: ...
    @property
    def TypeName(self) -> str: ...
    def HandleDrop(self, path: str, mouse_pt: PointF) -> bool: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    @ImageAutoUpdate.setter
    def ImageAutoUpdate(self, Value: bool) -> None: ...
    @ImageFilePath.setter
    def ImageFilePath(self, Value: str) -> None: ...
    @ImageSaveInFile.setter
    def ImageSaveInFile(self, Value: bool) -> None: ...
    @SamplerDomain.setter
    def SamplerDomain(self, Value: UVInterval) -> None: ...
    @SamplerFilter.setter
    def SamplerFilter(self, Value: GH_SamplingFilter) -> None: ...
    @SamplerInterpolate.setter
    def SamplerInterpolate(self, Value: bool) -> None: ...
    @SamplerWrapMode.setter
    def SamplerWrapMode(self, Value: WrapMode) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_ImageSamplerAttributes:
    def __init__(self, owner: GH_ImageSampler): ...
    @property
    def PathName(self) -> str: ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...


class GH_ItemPicker:
    def __init__(self): ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, obj_ids: List) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, att: ObjectAttributes, obj_ids: List) -> None: ...
    def CreateAttributes(self) -> None: ...
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def DataList(self) -> IList: ...
    @property
    def DataTree(self) -> IGH_Structure: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def Hidden(self) -> bool: ...
    @property
    def IsBakeCapable(self) -> bool: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    @property
    def TreeIndex(self) -> int: ...
    @property
    def TreePath(self) -> GH_Path: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    @Hidden.setter
    def Hidden(self, Value: bool) -> None: ...
    @TreeIndex.setter
    def TreeIndex(self, AutoPropertyValue: int) -> None: ...
    @TreePath.setter
    def TreePath(self, AutoPropertyValue: GH_Path) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_ItemPickerAttributes:
    def __init__(self, owner: GH_ItemPicker): ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseMove(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseUp(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def SetupTooltip(self, point: PointF, e: GH_TooltipDisplayEventArgs) -> None: ...


class GH_JumpObject(GH_DocumentObject):
    def __init__(self): ...
    def AppendMenuItems(self, menu: ToolStripDropDown) -> bool: ...
    def CreateAttributes(self) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def JumpGroup(self) -> Guid: ...
    def NextJump(self) -> GH_JumpObject: ...
    def PrevJump(self) -> GH_JumpObject: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    @JumpGroup.setter
    def JumpGroup(self, AutoPropertyValue: Guid) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_JumpObjectAttributes:
    def __init__(self, owner: GH_JumpObject): ...
    @property
    def HasInputGrip(self) -> bool: ...
    @property
    def HasOutputGrip(self) -> bool: ...
    def InvalidateCanvas(self, canvas: GH_Canvas, e: GH_CanvasMouseEvent) -> bool: ...
    @overload
    def IsPickRegion(self, point: PointF) -> bool: ...
    @overload
    def IsPickRegion(self, box: RectangleF, method: GH_PickBox) -> bool: ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def SetupTooltip(self, point: PointF, e: GH_TooltipDisplayEventArgs) -> None: ...


class GH_Legend(GH_Component):
    def __init__(self): ...
    def CreateAttributes(self) -> None: ...
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def LegendType(self) -> GH_LegendType: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    @LegendType.setter
    def LegendType(self, Value: GH_LegendType) -> None: ...
    def SetType(self, type: GH_LegendType) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_LegendAttributes:
    def __init__(self, component: GH_Legend): ...
    def AppendToAttributeTree(self, atts: List) -> None: ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...


class GH_LegendData:
    def __init__(self): ...
    def ClearCachedGeometry(self) -> None: ...
    def DrawViewportMeshes(self, args: GH_PreviewMeshArgs) -> None: ...
    def DrawViewportWires(self, args: GH_PreviewWireArgs) -> None: ...
    @property
    def Bounds2D(self) -> Rectangle: ...
    @property
    def Bounds3D(self) -> Rectangle3d: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    @property
    def Colours(self) -> List: ...
    @property
    def Names(self) -> List: ...
    @property
    def Type(self) -> GH_LegendType: ...
    def Render(self, graphics: Graphics) -> None: ...
    @Bounds2D.setter
    def Bounds2D(self, Value: Rectangle) -> None: ...
    @Bounds3D.setter
    def Bounds3D(self, Value: Rectangle3d) -> None: ...
    @Type.setter
    def Type(self, Value: GH_LegendType) -> None: ...


class GH_LegendType:
    #None = 0
    DiscreteVertical = 1
    DiscreteHorizontal = 2
    SmoothVertical = 101
    SmoothHorizontal = 102


class GH_Markup(GH_DocumentObject):
    def __init__(self): ...
    def AppendMenuItems(self, menu: ToolStripDropDown) -> bool: ...
    def CreateAttributes(self) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def Marks(self) -> GH_MarkupCollection: ...
    def Menu_AttributesClicked(self, sender: Object, e: EventArgs) -> None: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def UpdateAttributeData(self) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_MarkupAttributes:
    def __init__(self, owner: GH_Markup): ...
    @overload
    def AssignDashProperties(iPen: Pen, iPattern: GH_MarkupDashPattern, zoom: Single) -> None: ...
    @overload
    def AssignDashProperties(iPen: Pen, iPattern: GH_MarkupDashPattern, iCanvas: GH_Canvas) -> None: ...
    def ExpireLayout(self) -> None: ...
    @property
    def AllowMessageBalloon(self) -> bool: ...
    @property
    def HasInputGrip(self) -> bool: ...
    @property
    def HasOutputGrip(self) -> bool: ...
    @property
    def PathName(self) -> str: ...
    @property
    def Pen_Disabled(self, iCanvas: GH_Canvas) -> Pen: ...
    @property
    def Pen_Enabled(self, iCanvas: GH_Canvas) -> Pen: ...
    @property
    def Pen_Selected(self) -> Pen: ...
    @property
    def Properties(self) -> GH_MarkupProperties: ...
    @property
    def TooltipEnabled(self) -> bool: ...
    @overload
    def IsPickRegion(self, pt: PointF) -> bool: ...
    @overload
    def IsPickRegion(self, rec: RectangleF, method: GH_PickBox) -> bool: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    @Properties.setter
    def Properties(self, AutoPropertyValue: GH_MarkupProperties) -> None: ...
    def SetDashPattern(self, pattern: int) -> None: ...
    def UpdateUIData(self) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_MarkupCollection:
    def __init__(self): ...
    def Add(self, mark: Polyline) -> None: ...
    def Clear(self) -> None: ...
    @property
    def BoundingBox(self) -> BoundingBox: ...
    @property
    def Count(self) -> int: ...
    @property
    def Item(self, index: int) -> Polyline: ...
    def GetEnumerator(self) -> IEnumerator: ...
    def GetEnumerator1(self) -> IEnumerator: ...
    @Item.setter
    def Item(self, index: int, Value: Polyline) -> None: ...
    def ToGraphicsPath(self) -> GraphicsPath: ...
    def Transform(self, X: Transform) -> None: ...


class GH_MarkupDashPattern:
    Solid = 0
    Dot = 1
    Dash = 2
    DashDot = 3
    DoubleDash = 4


class GH_MarkupProperties:
    @property
    def Colour(self) -> Color: ...
    @property
    def Pattern(self) -> GH_MarkupDashPattern: ...
    @property
    def Width(self) -> Single: ...
    @Colour.setter
    def Colour(self, AutoPropertyValue: Color) -> None: ...
    @Pattern.setter
    def Pattern(self, AutoPropertyValue: GH_MarkupDashPattern) -> None: ...
    @Width.setter
    def Width(self, AutoPropertyValue: Single) -> None: ...
    def SetDefault(self) -> None: ...


class GH_MDSliderMode:
    _2d = 0
    _3d = 1


class GH_MultiDimensionalSlider:
    def __init__(self): ...
    def CreateAttributes(self) -> None: ...
    def DisplaySliderSettings(self) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def Kind(self) -> GH_ParamKind: ...
    @property
    def SliderMode(self) -> GH_MDSliderMode: ...
    @property
    def Value(self) -> Point3d: ...
    @property
    def X(self) -> float: ...
    @property
    def XInterval(self) -> Interval: ...
    @property
    def Y(self) -> float: ...
    @property
    def YInterval(self) -> Interval: ...
    @property
    def Z(self) -> float: ...
    @property
    def ZInterval(self) -> Interval: ...
    def LoadState(self, state: str) -> None: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def SaveState(self) -> str: ...
    @SliderMode.setter
    def SliderMode(self, Value: GH_MDSliderMode) -> None: ...
    @Value.setter
    def Value(self, new_value: Point3d) -> None: ...
    @XInterval.setter
    def XInterval(self, Value: Interval) -> None: ...
    @YInterval.setter
    def YInterval(self, Value: Interval) -> None: ...
    @ZInterval.setter
    def ZInterval(self, Value: Interval) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_MultiDimensionalSliderAttributes:
    def __init__(self, owner: GH_MultiDimensionalSlider): ...
    def ExpireLayout(self) -> None: ...
    @property
    def HasInputGrip(self) -> bool: ...
    @property
    def HasOutputGrip(self) -> bool: ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseMove(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseUp(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...


class GH_NumberSlider:
    def __init__(self): ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    def CreateAttributes(self) -> None: ...
    def FormatNumber(value: Decimal, accuracy: GH_SliderAccuracy, digits: int) -> str: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def CurrentValue(self) -> Decimal: ...
    @property
    def DataType(self) -> GH_ParamData: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def Expression(self) -> str: ...
    @property
    def IconCapableUI(self) -> bool: ...
    @property
    def ImpliedNickName(self) -> str: ...
    @property
    def InstanceDescription(self) -> str: ...
    @property
    def IsExpression(self) -> bool: ...
    @property
    def Kind(self) -> GH_ParamKind: ...
    @property
    def Slider(self) -> GH_SliderBase: ...
    @property
    def SliderGuid() -> Guid: ...
    @property
    def TickCount(self) -> int: ...
    @property
    def TickValue(self) -> int: ...
    @property
    def TypeName(self) -> str: ...
    def HarvestDecimalPlaces(text: str) -> int: ...
    def HarvestRange(text: str) -> Tuple[bool, str, str, str]: ...
    def LoadState(self, state: str) -> None: ...
    def PopupEditor(self) -> None: ...
    def PopupSnappingEditor(self) -> None: ...
    def PublishRcpItem(self) -> IRcpItem: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def ResetCurrentValue(self) -> None: ...
    def SaveState(self) -> str: ...
    @Expression.setter
    def Expression(self, Value: str) -> None: ...
    @TickValue.setter
    def TickValue(self, Value: int) -> None: ...
    def SetInitCode(self, code: str) -> None: ...
    def SetSliderValue(self, val: Decimal) -> None: ...
    def TrySetSliderValue(self, target: Decimal) -> bool: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_NumberSliderAttributes:
    def __init__(self, nOwner: GH_NumberSlider): ...
    @property
    def HasInputGrip(self) -> bool: ...
    @property
    def TooltipEnabled(self) -> bool: ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseMove(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseUp(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...


class GH_NumberSliderPublishProxy:
    def __init__(self, owner: GH_NumberSlider): ...
    @property
    def DesiredHeight(self) -> int: ...
    def MouseDown(self, e: MouseEventArgs) -> GH_ObjectResponse: ...
    def MouseMove(self, e: MouseEventArgs) -> GH_ObjectResponse: ...
    def MouseUp(self, e: MouseEventArgs) -> GH_ObjectResponse: ...
    def Render(self, G: Graphics) -> None: ...


class GH_Panel:
    def __init__(self): ...
    def AppendMenuItems(self, menu: ToolStripDropDown) -> bool: ...
    def CreateAttributes(self) -> None: ...
    def DestroyStreamDestination(self) -> bool: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def InstanceDescription(self) -> str: ...
    @property
    def Kind(self) -> GH_ParamKind: ...
    @property
    def PanelID() -> Guid: ...
    @property
    def Properties(self) -> GH_PanelProperties: ...
    @property
    def ScrollRatio(self) -> float: ...
    @property
    def UserText(self) -> str: ...
    def GetMappingList() -> str: ...
    def PickNewFont(self) -> None: ...
    def PublishRcpItem(self) -> IRcpItem: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    @ScrollRatio.setter
    def ScrollRatio(self, Value: float) -> None: ...
    @UserText.setter
    def UserText(self, Value: str) -> None: ...
    def SetInitCode(self, code: str) -> None: ...
    def SetUserText(self, text: str) -> None: ...
    def ShowEditDialog(self) -> None: ...
    def StreamCurrentContent(self) -> bool: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_PanelAttributes:
    def __init__(self, owner: GH_Panel): ...
    def ExpireLayout(self) -> None: ...
    @property
    def ContentBounds(self) -> Rectangle: ...
    @property
    def IndexBounds(self) -> Rectangle: ...
    @property
    def ItemBounds(self) -> Rectangle: ...
    @property
    def MarginLeft(self) -> int: ...
    @property
    def MarginLeftActual(self) -> int: ...
    @property
    def MarginRight(self) -> int: ...
    @property
    def MarginRightActual(self) -> int: ...
    @property
    def MarginTop(self) -> int: ...
    @property
    def MarginTopActual(self) -> int: ...
    @property
    def PanelBounds(self) -> Rectangle: ...
    @property
    def PathName(self) -> str: ...
    @property
    def ScrollerBounds(self) -> Rectangle: ...
    @property
    def ScrollGripBounds(self) -> Rectangle: ...
    @property
    def ScrollGripControlBounds(self) -> Rectangle: ...
    @property
    def TitleBounds(self) -> Rectangle: ...
    def GetContentAsString(self, includeIndices: bool, includePaths: bool) -> str: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseMove(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseUp(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    @MarginLeft.setter
    def MarginLeft(self, Value: int) -> None: ...
    @MarginRight.setter
    def MarginRight(self, Value: int) -> None: ...
    @MarginTop.setter
    def MarginTop(self, Value: int) -> None: ...
    def SetupTooltip(self, point: PointF, e: GH_TooltipDisplayEventArgs) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_PanelProperties:
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, other: GH_PanelProperties): ...
    def DecreaseFont(self) -> bool: ...
    @property
    def Alignment(self) -> Alignment: ...
    @property
    def Colour(self) -> Color: ...
    @property
    def DrawIndices(self) -> bool: ...
    @property
    def DrawPaths(self) -> bool: ...
    @property
    def Font(self) -> Font: ...
    @property
    def InferredBackColour(self) -> Color: ...
    @property
    def InferredBackColourSelected(self) -> Color: ...
    @property
    def InferredForeColour(self) -> Color: ...
    @property
    def InferredForeColourSelected(self) -> Color: ...
    @property
    def Multiline(self) -> bool: ...
    @property
    def SpecialCodes(self) -> bool: ...
    @property
    def StreamContents(self) -> bool: ...
    @property
    def StreamPath(self) -> str: ...
    @property
    def Wrap(self) -> bool: ...
    def IncreaseFont(self) -> bool: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def ResetToDefault(self) -> None: ...
    @Alignment.setter
    def Alignment(self, Value: Alignment) -> None: ...
    @Colour.setter
    def Colour(self, Value: Color) -> None: ...
    @DrawIndices.setter
    def DrawIndices(self, Value: bool) -> None: ...
    @DrawPaths.setter
    def DrawPaths(self, Value: bool) -> None: ...
    @Font.setter
    def Font(self, Value: Font) -> None: ...
    @Multiline.setter
    def Multiline(self, Value: bool) -> None: ...
    @SpecialCodes.setter
    def SpecialCodes(self, Value: bool) -> None: ...
    @StreamContents.setter
    def StreamContents(self, Value: bool) -> None: ...
    @StreamPath.setter
    def StreamPath(self, Value: str) -> None: ...
    @Wrap.setter
    def Wrap(self, Value: bool) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_PanelPublishProxy:
    def __init__(self, owner: GH_Panel): ...
    @property
    def DesiredHeight(self) -> int: ...
    def Render(self, G: Graphics) -> None: ...


class GH_ParamViewer:
    def __init__(self): ...
    @overload
    def AddSource(self, source: IGH_Param) -> None: ...
    @overload
    def AddSource(self, source: IGH_Param, index: int) -> None: ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    def CreateAttributes(self) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def DisplayGraph(self) -> bool: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def GraphicTree(self) -> GH_GraphicBranch: ...
    @property
    def GraphicTreeArgs(self) -> GH_GraphicTreeDisplayArgs: ...
    @property
    def IconCapableUI(self) -> bool: ...
    @property
    def Kind(self) -> GH_ParamKind: ...
    @property
    def ScrollRatio(self) -> float: ...
    def Menu_ToggleDisplayClicked(self, sender: Object, e: EventArgs) -> None: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    @DisplayGraph.setter
    def DisplayGraph(self, Value: bool) -> None: ...
    @ScrollRatio.setter
    def ScrollRatio(self, Value: float) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_ParamViewerAttributes:
    def __init__(self, owner: GH_ParamViewer): ...
    def AdjustLayout(self) -> None: ...
    def ExpireLayout(self) -> None: ...
    @property
    def PathName(self) -> str: ...
    @property
    def ScrollBarRec(self) -> Rectangle: ...
    @property
    def ScrollGripRec(self) -> Rectangle: ...
    @property
    def StringContentRec(self) -> Rectangle: ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseMove(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseUp(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...


class GH_PathMapper:
    def __init__(self): ...
    def AppendMenuItems(self, menu: ToolStripDropDown) -> bool: ...
    def CreateAttributes(self) -> None: ...
    def CreateDefaultMapping(self) -> None: ...
    def CreateFlattenMapping(self) -> None: ...
    def CreateGraftMapping(self) -> None: ...
    def CreateRenumberMapping(self) -> None: ...
    def CreateReverseMapping(self) -> None: ...
    def CreateTrimMapping(self) -> None: ...
    def DisplayLexerEditor(self) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def InstanceDescription(self) -> str: ...
    @property
    def Kind(self) -> GH_ParamKind: ...
    @property
    def Lexers(self) -> List: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_PathMapperAttributes:
    def __init__(self, owner: GH_PathMapper): ...
    def ExpireLayout(self) -> None: ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...


class GH_PieChart:
    def __init__(self): ...
    def CreateAttributes(self) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def DataSets(self) -> List: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def Kind(self) -> GH_ParamKind: ...


class GH_PieChartAttributes:
    def __init__(self, owner: GH_PieChart): ...
    def ExpireLayout(self) -> None: ...
    @property
    def AllowMessageBalloon(self) -> bool: ...
    @property
    def HasOutputGrip(self) -> bool: ...
    @property
    def Radius(self) -> int: ...
    @overload
    def IsPickRegion(self, pt: PointF) -> bool: ...
    @overload
    def IsPickRegion(self, rec: RectangleF, method: GH_PickBox) -> bool: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseMove(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseUp(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    @Radius.setter
    def Radius(self, Value: int) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_PieChartDataSet:
    def __init__(self): ...
    def AddTag(self, tag: str) -> None: ...
    @property
    def Pairs(self) -> List[GH_PieChartPair]: ...
    @property
    def TotalValence(self) -> int: ...


class GH_PieChartPair:
    def __init__(self, n_tag: str, n_valence: int): ...


class GH_PolylineReductionSetManager:
    def __init__(self, input: List): ...
    @property
    def Reduction(self, index: int) -> List: ...
    @property
    def ReductionExists(self, index: int) -> bool: ...


class GH_QuickGraph:
    def __init__(self): ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    def CreateAttributes(self) -> None: ...
    @property
    def Bundles(self) -> List: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def Kind(self) -> GH_ParamKind: ...
    @property
    def Maximum(self) -> float: ...
    @property
    def Minimum(self) -> float: ...
    @property
    def Mininum(self) -> float: ...
    @property
    def SortOrder(self) -> GH_QuickGraphSortOrder: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    @SortOrder.setter
    def SortOrder(self, AutoPropertyValue: GH_QuickGraphSortOrder) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_QuickGraphAttributes:
    def __init__(self, owner: GH_QuickGraph): ...
    @property
    def HasOutputGrip(self) -> bool: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_QuickGraphBundle:
    def __init__(self, colour: Color, samples: Set(float), minY: float, maxY: float): ...
    @property
    def IsEmpty(self) -> bool: ...
    def IsCoincident(self, point: PointF, frame: GH_QuickGraphFrame) -> bool: ...
    def Render(self, graphics: Graphics, thickness: Single, frame: GH_QuickGraphFrame) -> None: ...
    def RenderTags(self, graphics: Graphics, frame: GH_QuickGraphFrame) -> None: ...


class GH_QuickGraphDot:
    def __init__(self, point: PointF): ...
    @property
    def Point(self) -> PointF: ...
    def Render(self, graphics: Graphics, colour: Color, size: Single, frame: GH_QuickGraphFrame) -> None: ...


class GH_QuickGraphFrame:
    def __init__(self, frame: RectangleF, zoom: Single, min: float, max: float): ...
    def EvaluateY(self, normalisedParameter: Single) -> float: ...
    @property
    def Frame(self) -> RectangleF: ...
    @property
    def Maximum(self) -> float: ...
    @property
    def Minimum(self) -> float: ...
    @property
    def Zoom(self) -> Single: ...
    def Map(self, point: PointF) -> PointF: ...
    def MapX(self, parameter: Single) -> Single: ...
    def MapY(self, parameter: Single) -> Single: ...
    def UnevaluateY(self, normalisedParameter: float) -> Single: ...


class GH_QuickGraphSortOrder:
    #None = 0
    Ascending = 1
    Descending = 2


class GH_QuickGraphTrack:
    def __init__(self, points: Set(PointF)): ...
    def IsCoincident(self, point: PointF, frame: GH_QuickGraphFrame) -> bool: ...
    def Render(self, graphics: Graphics, pen: Pen, frame: GH_QuickGraphFrame) -> None: ...
    def RenderTags(self, graphics: Graphics, frame: GH_QuickGraphFrame) -> None: ...


class GH_Relay:
    def __init__(self): ...
    def AppendMenuItems(self, menu: ToolStripDropDown) -> bool: ...
    def CreateAttributes(self) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def DisplayName(self) -> str: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    def PostProcessData(self) -> None: ...
    def RelinkProxySources(self, document: GH_Document) -> bool: ...
    def ResolveDisplayName(self) -> None: ...
    def SafeDelete(self) -> List: ...
    def SafeDisconnect(self) -> List: ...
    @DisplayName.setter
    def DisplayName(self, AutoPropertyValue: str) -> None: ...


class GH_RelayAttributes:
    def __init__(self, owner: GH_Relay): ...
    @property
    def AllowMessageBalloon(self) -> bool: ...
    @property
    def HasInputGrip(self) -> bool: ...
    @property
    def HasOutputGrip(self) -> bool: ...
    @property
    def PathName(self) -> str: ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def SetupTooltip(self, point: PointF, e: GH_TooltipDisplayEventArgs) -> None: ...


class GH_SamplingFilter:
    none = 0
    col = 1
    R = 10
    G = 11
    B = 12
    A = 13
    hue = 20
    sat = 21
    val = 22


class GH_Scribble(GH_DocumentObject):
    def __init__(self): ...
    def CreateAttributes(self) -> None: ...
    def DisplayProperties(self) -> None: ...
    @property
    def A(self) -> PointF: ...
    @property
    def B(self) -> PointF: ...
    @property
    def C(self) -> PointF: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Corners(self) -> Set(PointF): ...
    @property
    def D(self) -> PointF: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def Font(self) -> Font: ...
    @property
    def ScribbleGuid() -> Guid: ...
    @property
    def Text(self) -> str: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    @Font.setter
    def Font(self, Value: Font) -> None: ...
    @Text.setter
    def Text(self, Value: str) -> None: ...
    def SetInitCode(self, code: str) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_ScribbleAttributes:
    def __init__(self, owner: GH_Scribble): ...
    def ExpireLayout(self) -> None: ...
    @property
    def HasInputGrip(self) -> bool: ...
    @property
    def HasOutputGrip(self) -> bool: ...
    @property
    def Pivot(self) -> PointF: ...
    @property
    def ScribblePath(self) -> GraphicsPath: ...
    @property
    def TooltipEnabled(self) -> bool: ...
    @overload
    def IsPickRegion(self, point: PointF) -> bool: ...
    @overload
    def IsPickRegion(self, box: RectangleF, method: GH_PickBox) -> bool: ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseMove(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseUp(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    @Pivot.setter
    def Pivot(self, Value: PointF) -> None: ...


class GH_SliderAnimator:
    def __init__(self, nOwner: GH_NumberSlider): ...
    def CreateFrame(self) -> Bitmap: ...
    @property
    def DrawTag(self) -> bool: ...
    @property
    def FileTemplate(self) -> str: ...
    @property
    def Folder(self) -> str: ...
    @property
    def FrameCount(self) -> int: ...
    @property
    def Height(self) -> int: ...
    @property
    def TagTemplate(self) -> str: ...
    @property
    def Viewport(self) -> RhinoViewport: ...
    @property
    def Width(self) -> int: ...
    def IsValidFileTemplate(self, iReason: str) -> Tuple[bool, str]: ...
    def RestoreDefaultSettings(self) -> None: ...
    @DrawTag.setter
    def DrawTag(self, Value: bool) -> None: ...
    @FileTemplate.setter
    def FileTemplate(self, Value: str) -> None: ...
    @Folder.setter
    def Folder(self, Value: str) -> None: ...
    @FrameCount.setter
    def FrameCount(self, Value: int) -> None: ...
    @Height.setter
    def Height(self, Value: int) -> None: ...
    @TagTemplate.setter
    def TagTemplate(self, Value: str) -> None: ...
    @Viewport.setter
    def Viewport(self, Value: RhinoViewport) -> None: ...
    @Width.setter
    def Width(self, Value: int) -> None: ...
    def SetupAnimationProperties(self) -> bool: ...
    def StartAnimation(self) -> int: ...
    def StoreSettingsAsDefault(self) -> None: ...


class GH_SuireSimplifyNode:
    def __init__(self): ...
    def AppendMenuItems(self, menu: ToolStripDropDown) -> bool: ...
    def CreateAttributes(self) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...


class GH_SuireStyleNodeAttributes:
    def __init__(self, owner: GH_SuireSimplifyNode): ...
    @property
    def AllowMessageBalloon(self) -> bool: ...
    @property
    def HasInputGrip(self) -> bool: ...
    @property
    def HasOutputGrip(self) -> bool: ...


class GH_Synchronisation:
    Unset = 0
    NotReferenced = 1
    MissingReference = 2
    UpToDate = 3
    OutOfDate = 4


class GH_TextBalloon(GH_DocumentObject):
    def __init__(self): ...
    def CreateAttributes(self) -> None: ...
    @property
    def BalloonAnchor(self) -> Guid: ...
    @property
    def BalloonFont(self) -> Font: ...
    @property
    def BalloonText(self) -> str: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    @BalloonAnchor.setter
    def BalloonAnchor(self, Value: Guid) -> None: ...
    @BalloonFont.setter
    def BalloonFont(self, Value: Font) -> None: ...
    @BalloonText.setter
    def BalloonText(self, Value: str) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_TextBalloonAttributes:
    def __init__(self, owner: GH_TextBalloon): ...
    def ExpireLayout(self) -> None: ...
    @property
    def Pivot(self) -> PointF: ...
    @property
    def TrailGrip(self) -> RectangleF: ...
    def IsMenuRegion(self, pt: PointF) -> bool: ...
    @overload
    def IsPickRegion(self, pt: PointF) -> bool: ...
    @overload
    def IsPickRegion(self, rec: RectangleF, method: GH_PickBox) -> bool: ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseMove(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseUp(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    @Pivot.setter
    def Pivot(self, Value: PointF) -> None: ...


class GH_Timer(GH_ActiveObject):
    def __init__(self): ...
    @overload
    def AddTarget(self, target_object_id: Guid) -> None: ...
    @overload
    def AddTarget(self, target_object: IGH_DocumentObject) -> None: ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    def CleanTargetList(self) -> None: ...
    def ComputeData(self) -> None: ...
    def CreateAttributes(self) -> None: ...
    def DependsOn(self, PotentialSource: IGH_ActiveObject) -> bool: ...
    def DestroyBlockIcon() -> None: ...
    def EnsureBlockIcon() -> None: ...
    def ExpireTargets(self) -> None: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def GlobalTimerBlock() -> bool: ...
    @property
    def IconCapableUI(self) -> bool: ...
    @property
    def InstanceDescription(self) -> str: ...
    @property
    def Interval(self) -> int: ...
    @property
    def IntervalString(self) -> str: ...
    @property
    def IsDataProvider(self) -> bool: ...
    @property
    def TargetCount(self) -> int: ...
    @property
    def Targets(self) -> List: ...
    @property
    def TimerComponentID() -> Guid: ...
    def InstanceGuidsChanged(self, map: SortedDictionary) -> None: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    @overload
    def RemoveTarget(self, target_object: IGH_DocumentObject) -> None: ...
    @overload
    def RemoveTarget(self, target_object_id: Guid) -> None: ...
    @Interval.setter
    def Interval(self, Value: int) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_TimerAttributes:
    def __init__(self, owner: GH_Timer): ...
    @property
    def HasInputGrip(self) -> bool: ...
    @property
    def HasOutputGrip(self) -> bool: ...
    @property
    def PathName(self) -> str: ...
    @overload
    def IsPickRegion(self, point: PointF) -> bool: ...
    @overload
    def IsPickRegion(self, box: RectangleF, method: GH_PickBox) -> bool: ...
    def RenderTimerConnection(g: Graphics, anchor: PointF, box: RectangleF, col: Color) -> None: ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def SetupTooltip(self, point: PointF, e: GH_TooltipDisplayEventArgs) -> None: ...


class GH_TimerTargetInteraction(GH_AbstractInteraction):
    def __init__(self, timer: GH_Timer, canvas: GH_Canvas, e: GH_CanvasMouseEvent): ...
    def Destroy(self) -> None: ...
    def RespondToKeyDown(self, sender: GH_Canvas, e: KeyEventArgs) -> GH_ObjectResponse: ...
    def RespondToMouseMove(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseUp(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...


class GH_ValueList:
    def __init__(self): ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, obj_ids: List) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, att: ObjectAttributes, obj_ids: List) -> None: ...
    def CreateAttributes(self) -> None: ...
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def DisplayName(self) -> str: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def FirstSelectedItem(self) -> GH_ValueListItem: ...
    @property
    def Hidden(self) -> bool: ...
    @property
    def IsBakeCapable(self) -> bool: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    @property
    def ListItems(self) -> List: ...
    @property
    def ListMode(self) -> GH_ValueListMode: ...
    @property
    def SelectedItems(self) -> List: ...
    @property
    def Values(self) -> List: ...
    def LoadState(self, state: str) -> None: ...
    def NextItem(self) -> None: ...
    def PrevItem(self) -> None: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def SaveState(self) -> str: ...
    def SelectItem(self, index: int) -> None: ...
    @Hidden.setter
    def Hidden(self, Value: bool) -> None: ...
    @ListMode.setter
    def ListMode(self, Value: GH_ValueListMode) -> None: ...
    def ShowListEditor(self, owner: IWin32Window) -> None: ...
    def ToggleItem(self, index: int) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_ValueListAttributes:
    def __init__(self, owner: GH_ValueList): ...
    @property
    def AllowMessageBalloon(self) -> bool: ...
    @property
    def HasInputGrip(self) -> bool: ...
    @property
    def HasOutputGrip(self) -> bool: ...
    def RespondToMouseDoubleClick(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...
    def RespondToMouseDown(self, sender: GH_Canvas, e: GH_CanvasMouseEvent) -> GH_ObjectResponse: ...


class GH_ValueListItem:
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, name: str, expression: str): ...
    def ExpireValue(self) -> None: ...
    @property
    def BoxLeft(self) -> RectangleF: ...
    @property
    def BoxName(self) -> RectangleF: ...
    @property
    def BoxRight(self) -> RectangleF: ...
    @property
    def Expression(self) -> str: ...
    @property
    def IsVisible(self) -> bool: ...
    @property
    def Name(self) -> str: ...
    @property
    def Selected(self) -> bool: ...
    @property
    def Value(self) -> IGH_Goo: ...
    @BoxLeft.setter
    def BoxLeft(self, AutoPropertyValue: RectangleF) -> None: ...
    @BoxName.setter
    def BoxName(self, AutoPropertyValue: RectangleF) -> None: ...
    @BoxRight.setter
    def BoxRight(self, AutoPropertyValue: RectangleF) -> None: ...
    @Expression.setter
    def Expression(self, AutoPropertyValue: str) -> None: ...
    @Name.setter
    def Name(self, AutoPropertyValue: str) -> None: ...
    @Selected.setter
    def Selected(self, AutoPropertyValue: bool) -> None: ...


class GH_ValueListMode:
    CheckList = 0
    DropDown = 1
    Sequence = 2
    Cycle = 3


class GH_ValueTimeline(GH_Component):
    def __init__(self): ...
    def CanInsertParameter(self, side: GH_ParameterSide, index: int) -> bool: ...
    def CanRemoveParameter(self, side: GH_ParameterSide, index: int) -> bool: ...
    def CreateParameter(self, side: GH_ParameterSide, index: int) -> IGH_Param: ...
    def DestroyParameter(self, side: GH_ParameterSide, index: int) -> bool: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    def VariableParameterMaintenance(self) -> None: ...


class GH_ValueTracker:
    def __init__(self): ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    def CleanRecording(self) -> None: ...
    def CreateAttributes(self) -> None: ...
    @property
    def AutoDomain(self) -> bool: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Domain(self) -> Interval: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def GraphColour(self) -> Color: ...
    @property
    def Kind(self) -> GH_ParamKind: ...
    @property
    def Period(self) -> int: ...
    @property
    def Recording(self) -> VT_Recording: ...
    @property
    def TypeName(self) -> str: ...
    @property
    def UpdateFrequency(self) -> int: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    @AutoDomain.setter
    def AutoDomain(self, Value: bool) -> None: ...
    @Domain.setter
    def Domain(self, Value: Interval) -> None: ...
    @GraphColour.setter
    def GraphColour(self, Value: Color) -> None: ...
    @Period.setter
    def Period(self, Value: int) -> None: ...
    @UpdateFrequency.setter
    def UpdateFrequency(self, Value: int) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_ValueTrackerAttributes:
    def __init__(self, owner: GH_ValueTracker): ...
    def ExpireLayout(self) -> None: ...


class VT_DataPoint:


class VT_Recording:
    def __init__(self): ...
    def Add(self, values: Set(float)) -> None: ...
    @property
    def Count(self) -> int: ...
    @property
    def Item(self, index: int) -> VT_DataPoint: ...
    @property
    def MaximumValue(self) -> float: ...
    @property
    def MinimumValue(self) -> float: ...
    def RemoveOldestItems(self, N: int) -> None: ...
