__all__ = ['Attributes','Components','Data','Expressions','Geometry','Graphs','Parameters','Sorting','Special','Types','Undo','Utility']
from typing import Tuple, Set, Iterable, List


class AttributesChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: IGH_DocumentObject, e: GH_AttributesChangedEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: IGH_DocumentObject, e: GH_AttributesChangedEventArgs) -> None: ...


class AutoSaveFileFormatChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class ColourEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: GH_ColourPicker, e: GH_ColourPickerEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: GH_ColourPicker, e: GH_ColourPickerEventArgs) -> None: ...


class ConsoleFamilyChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class ContextChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: GH_DocContextEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: GH_DocContextEventArgs) -> None: ...


class DefaultPreviewColourChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, colour: Color, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, colour: Color) -> None: ...


class DefaultSelectedPreviewColourChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, colour: Color, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, colour: Color) -> None: ...


class DisplayExpiredEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: IGH_DocumentObject, e: GH_DisplayExpiredEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: IGH_DocumentObject, e: GH_DisplayExpiredEventArgs) -> None: ...


class DocumentAddedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: GH_DocumentServer, doc: GH_Document, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: GH_DocumentServer, doc: GH_Document) -> None: ...


class DocumentRemovedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: GH_DocumentServer, doc: GH_Document, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: GH_DocumentServer, doc: GH_Document) -> None: ...


class EnableAutoSaveChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class EnabledChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: GH_DocEnabledEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: GH_DocEnabledEventArgs) -> None: ...


class EnableSolutionsChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, state: bool, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, state: bool) -> None: ...


class FileChanged:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: GH_FileWatcher, filename: str, change: WatcherChangeTypes, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: GH_FileWatcher, filename: str, change: WatcherChangeTypes) -> None: ...


class FileChangedSimple:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, filename: str, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, filename: str) -> None: ...


class FileEvent:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, path: str, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, path: str) -> None: ...


class FilePathChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: GH_DocFilePathEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: GH_DocFilePathEventArgs) -> None: ...


class GH_ActiveObject(GH_DocumentObject):
    def AddRuntimeMessage(self, level: GH_RuntimeMessageLevel, text: str) -> None: ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    def AppendMenuItems(self, menu: ToolStripDropDown) -> bool: ...
    def ClearData(self) -> None: ...
    def ClearRuntimeMessages(self) -> None: ...
    def CollectData(self) -> None: ...
    def ComputeData(self) -> None: ...
    def DependsOn(self, PotentialSource: IGH_ActiveObject) -> bool: ...
    def ExpireSolution(self, recompute: bool) -> None: ...
    @property
    def IconCapableUI(self) -> bool: ...
    @property
    def IsDataProvider(self) -> bool: ...
    @property
    def Locked(self) -> bool: ...
    @property
    def MutableNickName(self) -> bool: ...
    @property
    def Phase(self) -> GH_SolutionPhase: ...
    @property
    def ProcessorTime(self) -> TimeSpan: ...
    @property
    def RuntimeMessageLevel(self) -> GH_RuntimeMessageLevel: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def RegisterRemoteIDs(self, id_list: GH_GuidTable) -> None: ...
    def RuntimeMessages(self, level: GH_RuntimeMessageLevel) -> List[str]: ...
    def SDKCompliancy(self, exeVersion: int, exeServiceRelease: int) -> bool: ...
    @Locked.setter
    def Locked(self, Value: bool) -> None: ...
    @MutableNickName.setter
    def MutableNickName(self, Value: bool) -> None: ...
    @Phase.setter
    def Phase(self, Value: GH_SolutionPhase) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_ActiveObjectFilter:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, iObj: IGH_ActiveObject, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> bool: ...
    def Invoke(self, iObj: IGH_ActiveObject) -> bool: ...


class GH_Alias:
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, other: GH_Alias): ...
    @overload
    def __init__(self, alias: str, target: Guid): ...
    def AliasToString(aliases: Iterable[str]) -> str: ...
    def CompareTo(self, other: GH_Alias) -> int: ...
    @property
    def Alias(self) -> str: ...
    @property
    def Target(self) -> Guid: ...
    @Alias.setter
    def Alias(self, AutoPropertyValue: str) -> None: ...
    @Target.setter
    def Target(self, AutoPropertyValue: Guid) -> None: ...
    def StringToAlias(text: str) -> Set(str): ...


class GH_Arrange:
    MoveToFront = 0
    MoveForwards = 1
    MoveToBack = 2
    MoveBackwards = 3


class GH_AssemblyFolderInfo:
    def __init__(self, folder: str, type: GH_PluginFolderType): ...
    @property
    def SearchOption(self) -> SearchOption: ...
    def ToString(self) -> str: ...


class GH_AssemblyInfo:
    @property
    def Assembly(self) -> Assembly: ...
    @property
    def AssemblyDescription(self) -> str: ...
    @property
    def AssemblyIcon(self) -> Bitmap: ...
    @property
    def AssemblyLicense(self) -> GH_LibraryLicense: ...
    @property
    def AssemblyName(self) -> str: ...
    @property
    def AssemblyVersion(self) -> str: ...
    @property
    def AuthorContact(self) -> str: ...
    @property
    def AuthorName(self) -> str: ...
    @property
    def Description(self) -> str: ...
    @property
    def Icon(self) -> Bitmap: ...
    @property
    def Id(self) -> Guid: ...
    @property
    def IsCoreLibrary(self) -> bool: ...
    @property
    def License(self) -> GH_LibraryLicense: ...
    @property
    def LoadingMechanism(self) -> GH_LoadingMechanism: ...
    @property
    def Location(self) -> str: ...
    @property
    def Name(self) -> str: ...
    @property
    def Version(self) -> str: ...


class GH_AssemblyInfoStub(GH_AssemblyInfo):
    def __init__(self, assembly: Assembly): ...
    @property
    def AssemblyName(self) -> str: ...
    @property
    def AssemblyVersion(self) -> str: ...


class GH_AssemblyPriority:
    def PriorityLoad(self) -> GH_LoadingInstruction: ...




class GH_AttributesChangedEventArgs:
    def __init__(self): ...


class GH_Author:
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, other: IGH_Author): ...
    def Clear(self) -> None: ...
    @property
    def Address(self) -> str: ...
    @property
    def AddressReadonly(self) -> str: ...
    @property
    def Company(self) -> str: ...
    @property
    def CompanyReadonly(self) -> str: ...
    @property
    def Copyright(self) -> str: ...
    @property
    def CopyrightReadonly(self) -> str: ...
    @property
    def EMail(self) -> str: ...
    @property
    def EMailReadonly(self) -> str: ...
    @property
    def IsEmpty(self) -> bool: ...
    @property
    def Name(self) -> str: ...
    @property
    def NameReadonly(self) -> str: ...
    @property
    def Phone(self) -> str: ...
    @property
    def PhoneReadonly(self) -> str: ...
    @property
    def Website(self) -> str: ...
    @property
    def WebsiteReadonly(self) -> str: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    @Address.setter
    def Address(self, AutoPropertyValue: str) -> None: ...
    @Company.setter
    def Company(self, AutoPropertyValue: str) -> None: ...
    @Copyright.setter
    def Copyright(self, AutoPropertyValue: str) -> None: ...
    @EMail.setter
    def EMail(self, AutoPropertyValue: str) -> None: ...
    @Name.setter
    def Name(self, AutoPropertyValue: str) -> None: ...
    @Phone.setter
    def Phone(self, AutoPropertyValue: str) -> None: ...
    @Website.setter
    def Website(self, AutoPropertyValue: str) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_AutoSaveSettings:
    def __init__(self): ...
    def add_AutoSaveFileFormatChanged(obj: AutoSaveFileFormatChangedEventHandler) -> None: ...
    def add_EnableAutoSaveChanged(obj: EnableAutoSaveChangedEventHandler) -> None: ...
    def add_SaveOnDataFlatteningChanged(obj: SaveOnDataFlatteningChangedEventHandler) -> None: ...
    def add_SaveOnDocumentUnloadChanged(obj: SaveOnDocumentUnloadChangedEventHandler) -> None: ...
    def add_SaveOnObjectAddedChanged(obj: SaveOnObjectAddedChangedEventHandler) -> None: ...
    def add_SaveOnObjectChangeChanged(obj: SaveOnObjectChangeChangedEventHandler) -> None: ...
    def add_SaveOnObjectRemovedChanged(obj: SaveOnObjectRemovedChangedEventHandler) -> None: ...
    def add_SaveOnWireEventChanged(obj: SaveOnWireEventChangedEventHandler) -> None: ...
    def AutosaveFilter(trigger: GH_AutoSaveTrigger) -> bool: ...
    @property
    def EnableAutoSave() -> bool: ...
    @property
    def SaveOnDataFlattening() -> bool: ...
    @property
    def SaveOnDocumentUnload() -> bool: ...
    @property
    def SaveOnObjectAdded() -> bool: ...
    @property
    def SaveOnObjectChange() -> bool: ...
    @property
    def SaveOnObjectRemoved() -> bool: ...
    @property
    def SaveOnWireEvent() -> bool: ...
    def remove_AutoSaveFileFormatChanged(obj: AutoSaveFileFormatChangedEventHandler) -> None: ...
    def remove_EnableAutoSaveChanged(obj: EnableAutoSaveChangedEventHandler) -> None: ...
    def remove_SaveOnDataFlatteningChanged(obj: SaveOnDataFlatteningChangedEventHandler) -> None: ...
    def remove_SaveOnDocumentUnloadChanged(obj: SaveOnDocumentUnloadChangedEventHandler) -> None: ...
    def remove_SaveOnObjectAddedChanged(obj: SaveOnObjectAddedChangedEventHandler) -> None: ...
    def remove_SaveOnObjectChangeChanged(obj: SaveOnObjectChangeChangedEventHandler) -> None: ...
    def remove_SaveOnObjectRemovedChanged(obj: SaveOnObjectRemovedChangedEventHandler) -> None: ...
    def remove_SaveOnWireEventChanged(obj: SaveOnWireEventChangedEventHandler) -> None: ...
    @EnableAutoSave.setter
    def EnableAutoSave(Value: bool) -> None: ...
    @SaveOnDataFlattening.setter
    def SaveOnDataFlattening(Value: bool) -> None: ...
    @SaveOnDocumentUnload.setter
    def SaveOnDocumentUnload(Value: bool) -> None: ...
    @SaveOnObjectAdded.setter
    def SaveOnObjectAdded(Value: bool) -> None: ...
    @SaveOnObjectChange.setter
    def SaveOnObjectChange(Value: bool) -> None: ...
    @SaveOnObjectRemoved.setter
    def SaveOnObjectRemoved(Value: bool) -> None: ...
    @SaveOnWireEvent.setter
    def SaveOnWireEvent(Value: bool) -> None: ...


class GH_AutoSaveTrigger:
    undefined = 0
    doc_unload = 1
    object_added = 2
    object_removed = 3
    wire_event = 4
    data_matching_event = 5
    data_modification_event = 6
    object_generic = 7


class GH_BakeUtility:
    def __init__(self, document: GH_Document): ...
    def BakeObject(self, obj: Object, att: ObjectAttributes, doc: RhinoDoc) -> bool: ...
    def BakeObjects(self, objects: IEnumerable, att: ObjectAttributes, doc: RhinoDoc) -> int: ...
    @property
    def BakedCount(self) -> int: ...
    @property
    def BakedIds(self) -> Set(Guid): ...
    @property
    def InvalidCount(self) -> int: ...


class GH_BitmapChannel:
    A = 1
    R = 2
    G = 4
    B = 8
    RGB = 14
    ARGB = 15


class GH_CaseInsensitiveStringComparer:
    def __init__(self): ...
    def Compare(self, x: str, y: str) -> int: ...


class GH_ClipboardType:
    System = 0
    Local = 1
    Global = 2


class GH_Component(GH_ActiveObject):
    def AddedToDocument(self, document: GH_Document) -> None: ...
    def AppendAdditionalMenuItems(self, menu: ToolStripDropDown) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, obj_ids: List) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, att: ObjectAttributes, obj_ids: List) -> None: ...
    def ClearData(self) -> None: ...
    def ClearRuntimeMessages(self) -> None: ...
    def CollectData(self) -> None: ...
    def ComputeData(self) -> None: ...
    def CreateAttributes(self) -> None: ...
    def DependsOn(self, potentialSource: IGH_ActiveObject) -> bool: ...
    def DocumentContextChanged(self, document: GH_Document, context: GH_DocumentContext) -> None: ...
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    @property
    def DataComparison(self) -> GH_DataComparison: ...
    @property
    def Hidden(self) -> bool: ...
    @property
    def InConstructor(self) -> bool: ...
    @property
    def InstanceDescription(self) -> str: ...
    @property
    def IsBakeCapable(self) -> bool: ...
    @property
    def IsDataProvider(self) -> bool: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    @property
    def IsValidPrincipalParameterIndex(self) -> bool: ...
    @property
    def Locked(self) -> bool: ...
    @property
    def Message(self) -> str: ...
    @property
    def Params(self) -> GH_ComponentParamServer: ...
    @property
    def PrincipalParameterIndex(self) -> int: ...
    @property
    def ProcessorTime(self) -> TimeSpan: ...
    @property
    def RunCount(self) -> int: ...
    @property
    def RuntimeMessageLevel(self) -> GH_RuntimeMessageLevel: ...
    def IsolateObject(self) -> None: ...
    def MovedBetweenDocuments(self, oldDocument: GH_Document, newDocument: GH_Document) -> None: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def RegisterRemoteIDs(self, table: GH_GuidTable) -> None: ...
    def RemovedFromDocument(self, document: GH_Document) -> None: ...
    def RuntimeMessages(self, level: GH_RuntimeMessageLevel) -> List[str]: ...
    @DataComparison.setter
    def DataComparison(self, Value: GH_DataComparison) -> None: ...
    @Hidden.setter
    def Hidden(self, Value: bool) -> None: ...
    @Locked.setter
    def Locked(self, Value: bool) -> None: ...
    @Message.setter
    def Message(self, Value: str) -> None: ...
    @PrincipalParameterIndex.setter
    def PrincipalParameterIndex(self, AutoPropertyValue: int) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_ComponentParamServer:
    def AccessCount(self, access: GH_ParamAccess) -> int: ...
    def add_ParameterChanged(self, obj: ParameterChangedEventHandler) -> None: ...
    def add_ParameterNickNameChanged(self, obj: ParameterNickNameChangedEventHandler) -> None: ...
    def add_ParameterSourcesChanged(self, obj: ParameterSourcesChangedEventHandler) -> None: ...
    @overload
    def Clear(self) -> None: ...
    @overload
    def Clear(self, isolate: bool) -> None: ...
    def CreateDuplicate(original: IGH_Param) -> IGH_Param: ...
    def EmitSyncObject(self) -> IGH_SyncObject: ...
    def Find(self, id: Guid) -> IGH_Param: ...
    @property
    def Input(self) -> List: ...
    @property
    def InputWidth(self) -> Single: ...
    @property
    def OnlyTreeAndListParameters(self) -> bool: ...
    @property
    def OnlyTreeParameters(self) -> bool: ...
    @property
    def Output(self) -> List: ...
    @property
    def OutputWidth(self) -> Single: ...
    @property
    def Owner(self) -> IGH_Component: ...
    def GetEnumerator(self) -> IEnumerator: ...
    def GetEnumerator1(self) -> IEnumerator: ...
    @overload
    def GetHashCode(self) -> int: ...
    @overload
    def GetHashCode(self, fields: GH_ParamHashFields) -> Guid: ...
    @overload
    def IndexOfInputParam(self, name: str) -> int: ...
    @overload
    def IndexOfInputParam(self, id: Guid) -> int: ...
    @overload
    def IndexOfOutputParam(self, id: Guid) -> int: ...
    @overload
    def IndexOfOutputParam(self, name: str) -> int: ...
    @overload
    def InventUniqueNickname(allowedChars: str, existingNames: Iterable[str]) -> str: ...
    @overload
    def InventUniqueNickname(allowedChars: str, existingNames: Iterable[IGH_Param]) -> str: ...
    def IsInputParam(self, param: IGH_Param) -> bool: ...
    def IsOutputParam(self, param: IGH_Param) -> bool: ...
    def IsParam(self, param: IGH_Param) -> bool: ...
    def OnParametersChanged(self) -> None: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def ReadAllParameterData(self, reader: GH_IReader) -> bool: ...
    @overload
    def RegisterInputParam(self, new_param: IGH_Param) -> bool: ...
    @overload
    def RegisterInputParam(self, new_param: IGH_Param, at_index: int) -> bool: ...
    @overload
    def RegisterOutputParam(self, new_param: IGH_Param) -> bool: ...
    @overload
    def RegisterOutputParam(self, new_param: IGH_Param, at_index: int) -> bool: ...
    def remove_ParameterChanged(self, obj: ParameterChangedEventHandler) -> None: ...
    def remove_ParameterNickNameChanged(self, obj: ParameterNickNameChangedEventHandler) -> None: ...
    def remove_ParameterSourcesChanged(self, obj: ParameterSourcesChangedEventHandler) -> None: ...
    def RepairParamAssociations(self) -> None: ...
    def RepairProxyParams(self, document: GH_Document) -> bool: ...
    @overload
    def SortInput(self, keys: Set(Single)) -> None: ...
    @overload
    def SortInput(self, keys: Set(int)) -> None: ...
    @overload
    def SortInput(self, keys: Set(float)) -> None: ...
    @overload
    def SortOutput(self, keys: Set(Single)) -> None: ...
    @overload
    def SortOutput(self, keys: Set(float)) -> None: ...
    @overload
    def SortOutput(self, keys: Set(int)) -> None: ...
    @overload
    def Sync(self, sync_data: Object) -> None: ...
    @overload
    def Sync(self, sync_data: IGH_SyncObject) -> None: ...
    @overload
    def Sync(self, sync_data: IGH_SyncObject) -> Tuple[int]: ...
    @overload
    def UnregisterInputParameter(self, param: IGH_Param) -> bool: ...
    @overload
    def UnregisterInputParameter(self, param: IGH_Param, isolate: bool) -> bool: ...
    @overload
    def UnregisterOutputParameter(self, param: IGH_Param) -> bool: ...
    @overload
    def UnregisterOutputParameter(self, param: IGH_Param, isolate: bool) -> bool: ...
    @overload
    def UnregisterParameter(self, param: IGH_Param) -> bool: ...
    @overload
    def UnregisterParameter(self, param: IGH_Param, isolate: bool) -> bool: ...
    def Write(self, writer: GH_IWriter) -> bool: ...
    def WriteAllParameterData(self, writer: GH_IWriter) -> bool: ...
    def WriteParamHashData(writer: BinaryWriter, param: IGH_Param, fields: GH_ParamHashFields) -> None: ...


class GH_ComponentServer:
    def __init__(self): ...
    def add_GHAFileLoaded(self, obj: GHAFileLoadedEventHandler) -> None: ...
    def AddAlias(self, alias: str, target: Guid) -> None: ...
    def AddCategoryIcon(self, fullCategoryName: str, icon: Bitmap) -> None: ...
    def AddCategoryShortName(self, fullCategoryName: str, categoryAbbreviation: str) -> None: ...
    def AddCategorySymbolName(self, fullCategoryName: str, symbol: Char) -> None: ...
    def AddProxy(self, proxy: IGH_ObjectProxy) -> bool: ...
    def AddProxyLibraryInfo(self, assemblyInfo: GH_AssemblyInfo) -> bool: ...
    def AliasTargets(self, alias: str) -> List: ...
    def Clear(self) -> None: ...
    def ClearStaleUserObjects(self) -> None: ...
    def CompareProxies(A: IGH_ObjectProxy, B: IGH_ObjectProxy) -> int: ...
    def CopyFileToAppropriateFolder(filepath: str, moveOriginalToBin: bool) -> str: ...
    def DestroyLoadingUI(self) -> None: ...
    def EmitGraph(self, id: Guid) -> IGH_Graph: ...
    def EmitObject(self, id: Guid) -> IGH_DocumentObject: ...
    def EmitObjectIcon(self, id: Guid) -> Bitmap: ...
    def EmitObjectProxy(self, id: Guid) -> IGH_ObjectProxy: ...
    def ExternalFiles(testGrasshopperCollisions: bool, testExternalCollisions: bool) -> List: ...
    def FindAssembly(self, libraryId: Guid) -> GH_AssemblyInfo: ...
    @overload
    def FindAssemblyByObject(self, object: IGH_DocumentObject) -> GH_AssemblyInfo: ...
    @overload
    def FindAssemblyByObject(self, objectId: Guid) -> GH_AssemblyInfo: ...
    def FindObjectByName(self, name: str, ignoreWhiteSpace: bool, ignoreCapitalisation: bool) -> IGH_ObjectProxy: ...
    @overload
    def FindObjects(self, libraryID: Guid) -> List: ...
    @overload
    def FindObjects(self, terms: Set(str), max_hits: int) -> List[IGH_ObjectProxy]: ...
    def FindUpgrader(self, target: Guid) -> IGH_UpgradeObject: ...
    @property
    def Aliases(self) -> List: ...
    @property
    def AllAddOns() -> List: ...
    @property
    def CompleteRibbonLayout(self) -> GH_Layout: ...
    @property
    def DiscardedProxies(self) -> int: ...
    @property
    def GHA_AppDataDirectory() -> str: ...
    @property
    def GHA_Directories() -> List: ...
    @property
    def GHUser_AppDataDirectory() -> str: ...
    @property
    def GraphProxies(self) -> List[GH_GraphProxy]: ...
    @property
    def Libraries(self) -> ReadOnlyCollection: ...
    @property
    def LoadingExceptions(self) -> List: ...
    @property
    def ObjectProxies(self) -> List[IGH_ObjectProxy]: ...
    @property
    def ObjectProxyNames(self) -> AutoCompleteStringCollection: ...
    @property
    def TypeHints(self) -> List[Type]: ...
    @property
    def Upgraders(self) -> List[IGH_UpgradeObject]: ...
    def GetAlias(self, target: Guid) -> str: ...
    def GetCategoryIcon(self, fullName: str) -> Bitmap: ...
    def GetCategoryShortName(self, fullName: str) -> str: ...
    def GetCategorySymbolName(self, fullName: str) -> str: ...
    def IsGraphCached(self, id: Guid) -> bool: ...
    def IsObjectCached(self, id: Guid) -> bool: ...
    def IsUpgrader(self, objs: Iterable[IGH_DocumentObject]) -> bool: ...
    def LoadAliases(self) -> None: ...
    def LoadExternalFiles(self, loadOneByOne: bool) -> bool: ...
    def NewUserObject(obj: IGH_DocumentObject) -> bool: ...
    def remove_GHAFileLoaded(self, obj: GHAFileLoadedEventHandler) -> None: ...
    def RemoveCachedGraph(self, id: Guid) -> bool: ...
    @overload
    def RemoveCachedObject(self, id: Guid) -> bool: ...
    @overload
    def RemoveCachedObject(self, userObjectFilePath: str) -> bool: ...
    def SaveAliases(self) -> None: ...
    def SetAlias(self, alias: str, target: Guid) -> None: ...
    def UpdateRibbonUI() -> None: ...


class GH_ConnectivityDiagram:
    @overload
    def __init__(self, doc: GH_Document): ...
    @overload
    def __init__(self, other: GH_ConnectivityDiagram): ...
    def ContainsID(self, id: Guid) -> bool: ...
    @property
    def Node(self, id: Guid) -> GH_ConnectivityNode: ...
    @property
    def NodeCount(self) -> int: ...
    @property
    def Nodes(self) -> ReadOnlyCollection: ...
    def GetAllInputs(self, id: Guid) -> List: ...
    def GetAllOutputs(self, id: Guid) -> List: ...


class GH_ConnectivityDisparity:
    def __init__(self, topset: GH_ConnectivityDiagram, subset: GH_ConnectivityDiagram): ...
    def ExternalInputs(self, id: Guid) -> List: ...
    def ExternalOutputs(self, id: Guid) -> List: ...
    @property
    def SubNodes(self) -> ReadOnlyCollection: ...
    @property
    def SubSet(self) -> GH_ConnectivityDiagram: ...
    @property
    def TopNodes(self) -> ReadOnlyCollection: ...
    @property
    def TopSet(self) -> GH_ConnectivityDiagram: ...
    def InternalInputs(self, id: Guid) -> List: ...
    def InternalOutputs(self, id: Guid) -> List: ...


class GH_ConnectivityNode:
    def __init__(self, other: GH_ConnectivityNode): ...
    @property
    def NodeID(self) -> Guid: ...
    @property
    def NodeIn(self) -> ReadOnlyCollection: ...
    @property
    def NodeOut(self) -> ReadOnlyCollection: ...


class GH_Conversion:
    Primary = 0
    Secondary = 1
    Both = 2


class GH_Convert:
    def BackSolveExpression(exp: str, variable: str, target: float, minimum: float, maximum: float, steps: int) -> Tuple[bool, float, float]: ...
    def ByteArrayToCommonObject(data: Set(Byte)) -> T: ...
    def CombineDateAndTime(date: DateTime, time: DateTime) -> DateTime: ...
    def CommonObjectToByteArray(data: CommonObject) -> Set(Byte): ...
    def CreatePureDate(date: DateTime) -> DateTime: ...
    @overload
    def CreatePureTime(date: DateTime) -> DateTime: ...
    @overload
    def CreatePureTime(hours: int, minutes: int, seconds: int) -> DateTime: ...
    def FileToHash(path: str) -> Guid: ...
    def FindRhinoObjectByNameAndType(name: str, type: ObjectType) -> RhinoObject: ...
    @property
    def CultureTable() -> SortedDictionary: ...
    def GetBrepFromDocument(doc: RhinoDoc, id: Guid) -> Tuple[bool, Brep]: ...
    def GetClippingPlaneFromDocument(doc: RhinoDoc, id: Guid) -> Tuple[bool, Plane]: ...
    def GetCurveFromDocument(doc: RhinoDoc, id: Guid) -> Tuple[bool, Curve]: ...
    def GetMeshFromDocument(doc: RhinoDoc, id: Guid) -> Tuple[bool, Mesh]: ...
    def GetPointFromDocument(doc: RhinoDoc, id: Guid) -> Tuple[bool, Point3d]: ...
    def GetSubDFromDocument(doc: RhinoDoc, id: Guid) -> Tuple[bool, SubD]: ...
    def GetSurfaceFromDocument(doc: RhinoDoc, id: Guid) -> Tuple[bool, Surface]: ...
    @overload
    def GetTimeKind(time: DateTime) -> GH_TimeKind: ...
    @overload
    def GetTimeKind(A: DateTime, B: DateTime) -> GH_TimeKind: ...
    def IsPureDate(potentialDate: DateTime) -> bool: ...
    def IsPureTime(potentialTime: DateTime) -> bool: ...
    def ObjRefToGeometry(in: ObjRef) -> IGH_GeometricGoo: ...
    def ParseExpression(exp: str, recursive: bool) -> GH_Variant: ...
    def StringToDate(text: str, date: DateTime) -> Tuple[bool, DateTime]: ...
    def StringToGuid(text: str) -> Guid: ...
    def StringToTime(text: str, time: DateTime) -> Tuple[bool, DateTime]: ...
    def To_GH_ClassPrefixTypeName(old_name: str) -> str: ...
    def ToArc_Primary(data: Object, rc: Arc) -> Tuple[bool, Arc]: ...
    def ToArc(data: Object, rc: Arc, conversion_level: GH_Conversion) -> Tuple[bool, Arc]: ...
    def ToArc_Secondary(data: Object, rc: Arc) -> Tuple[bool, Arc]: ...
    def ToBoolean_Primary(data: Object, destination: bool) -> Tuple[bool, bool]: ...
    def ToBoolean(data: Object, conversion_level: GH_Conversion) -> Tuple[bool, bool]: ...
    def ToBoolean_Secondary(data: Object, destination: bool) -> Tuple[bool, bool]: ...
    def ToBoundingBox_Primary(data: Object, rc: BoundingBox) -> Tuple[bool, BoundingBox]: ...
    def ToBox_Primary(data: Object, rc: Box) -> Tuple[bool, Box]: ...
    def ToBrep_Primary(data: Object, rc: Brep) -> Tuple[bool, Brep]: ...
    def ToBrep(data: Object, rc: Brep, conversion_level: GH_Conversion) -> Tuple[bool, Brep]: ...
    def ToBrep_Secondary(data: Object, rc: Brep) -> Tuple[bool, Brep]: ...
    def ToCircle_Primary(data: Object, rc: Circle) -> Tuple[bool, Circle]: ...
    def ToCircle(data: Object, rc: Circle, conversion_level: GH_Conversion) -> Tuple[bool, Circle]: ...
    def ToCircle_Secondary(data: Object, rc: Circle) -> Tuple[bool, Circle]: ...
    def ToColor_Primary(data: Object, destination: Color) -> Tuple[bool, Color]: ...
    def ToColor(data: Object, conversion_level: GH_Conversion) -> Tuple[bool, Color]: ...
    def ToColor_Secondary(data: Object, destination: Color) -> Tuple[bool, Color]: ...
    def ToComplex_Primary(data: Object, destination: Complex) -> Tuple[bool, Complex]: ...
    def ToComplex(data: Object, conversion_level: GH_Conversion) -> Tuple[bool, Complex]: ...
    def ToComplex_Secondary(data: Object, destination: Complex) -> Tuple[bool, Complex]: ...
    def ToCoordinates(data: Object, x: float, y: float, z: float, w: float) -> Tuple[bool, float, float, float, float]: ...
    def ToCulture_Primary(data: Object, destination: CultureInfo) -> Tuple[bool, CultureInfo]: ...
    def ToCulture(data: Object, conversion_level: GH_Conversion) -> Tuple[bool, CultureInfo]: ...
    def ToCulture_Secondary(data: Object, destination: CultureInfo) -> Tuple[bool, CultureInfo]: ...
    def ToCurve_Primary(data: Object, rc: Curve) -> Tuple[bool, Curve]: ...
    def ToCurve(data: Object, rc: Curve, conversion_level: GH_Conversion) -> Tuple[bool, Curve]: ...
    def ToCurve_Secondary(data: Object, rc: Curve) -> Tuple[bool, Curve]: ...
    def ToDate_Primary(data: Object, destination: DateTime) -> Tuple[bool, DateTime]: ...
    def ToDate(data: Object, conversion_level: GH_Conversion) -> Tuple[bool, DateTime]: ...
    def ToDate_Secondary(data: Object, destination: DateTime) -> Tuple[bool, DateTime]: ...
    def ToDouble_Primary(data: Object, destination: float) -> Tuple[bool, float]: ...
    def ToDouble(data: Object, conversion_level: GH_Conversion) -> Tuple[bool, float]: ...
    def ToDouble_Secondary(data: Object, destination: float) -> Tuple[bool, float]: ...
    def ToGeometricGoo(data: Object) -> IGH_GeometricGoo: ...
    def ToGeometryBase(data: Object) -> GeometryBase: ...
    def ToGHArc_Primary(data: Object, target: GH_Arc) -> Tuple[bool, GH_Arc]: ...
    def ToGHArc(data: Object, conversion_level: GH_Conversion, target: GH_Arc) -> Tuple[bool, GH_Arc]: ...
    def ToGHArc_Secondary(data: Object, target: GH_Arc) -> Tuple[bool, GH_Arc]: ...
    def ToGHBoolean_Primary(data: Object, target: GH_Boolean) -> Tuple[bool, GH_Boolean]: ...
    def ToGHBoolean(data: Object, conversion_level: GH_Conversion, target: GH_Boolean) -> Tuple[bool, GH_Boolean]: ...
    def ToGHBoolean_Secondary(data: Object, target: GH_Boolean) -> Tuple[bool, GH_Boolean]: ...
    def ToGHBox_Primary(data: Object, target: GH_Box) -> Tuple[bool, GH_Box]: ...
    def ToGHBox(data: Object, conversion_level: GH_Conversion, target: GH_Box) -> Tuple[bool, GH_Box]: ...
    def ToGHBox_Secondary(data: Object, target: GH_Box) -> Tuple[bool, GH_Box]: ...
    def ToGHBrep_Primary(data: Object, target: GH_Brep) -> Tuple[bool, GH_Brep]: ...
    def ToGHBrep(data: Object, conversion_level: GH_Conversion, target: GH_Brep) -> Tuple[bool, GH_Brep]: ...
    def ToGHBrep_Secondary(data: Object, target: GH_Brep) -> Tuple[bool, GH_Brep]: ...
    def ToGHCircle_Primary(data: Object, target: GH_Circle) -> Tuple[bool, GH_Circle]: ...
    def ToGHCircle(data: Object, conversion_level: GH_Conversion, target: GH_Circle) -> Tuple[bool, GH_Circle]: ...
    def ToGHCircle_Secondary(data: Object, target: GH_Circle) -> Tuple[bool, GH_Circle]: ...
    def ToGHColour_Primary(data: Object, target: GH_Colour) -> Tuple[bool, GH_Colour]: ...
    def ToGHColour(data: Object, conversion_level: GH_Conversion, target: GH_Colour) -> Tuple[bool, GH_Colour]: ...
    def ToGHColour_Secondary(data: Object, target: GH_Colour) -> Tuple[bool, GH_Colour]: ...
    def ToGHComplexNumber_Primary(data: Object, target: GH_ComplexNumber) -> Tuple[bool, GH_ComplexNumber]: ...
    def ToGHComplexNumber(data: Object, conversion_level: GH_Conversion, target: GH_ComplexNumber) -> Tuple[bool, GH_ComplexNumber]: ...
    def ToGHComplexNumber_Secondary(data: Object, target: GH_ComplexNumber) -> Tuple[bool, GH_ComplexNumber]: ...
    def ToGHCurve_Primary(data: Object, target: GH_Curve) -> Tuple[bool, GH_Curve]: ...
    def ToGHCurve(data: Object, conversion_level: GH_Conversion, target: GH_Curve) -> Tuple[bool, GH_Curve]: ...
    def ToGHCurve_Secondary(data: Object, target: GH_Curve) -> Tuple[bool, GH_Curve]: ...
    def ToGHGuid_Primary(data: Object, target: GH_Guid) -> Tuple[bool, GH_Guid]: ...
    def ToGHGuid(data: Object, conversion_level: GH_Conversion, target: GH_Guid) -> Tuple[bool, GH_Guid]: ...
    def ToGHGuid_Secondary(data: Object, target: GH_Guid) -> Tuple[bool, GH_Guid]: ...
    def ToGHInteger_Primary(data: Object, target: GH_Integer) -> Tuple[bool, GH_Integer]: ...
    def ToGHInteger(data: Object, conversion_level: GH_Conversion, target: GH_Integer) -> Tuple[bool, GH_Integer]: ...
    def ToGHInteger_Secondary(data: Object, target: GH_Integer) -> Tuple[bool, GH_Integer]: ...
    def ToGHInterval_Primary(data: Object, target: GH_Interval) -> Tuple[bool, GH_Interval]: ...
    def ToGHInterval(data: Object, conversion_level: GH_Conversion, target: GH_Interval) -> Tuple[bool, GH_Interval]: ...
    def ToGHInterval_Secondary(data: Object, target: GH_Interval) -> Tuple[bool, GH_Interval]: ...
    def ToGHInterval2D_Primary(data: Object, target: GH_Interval2D) -> Tuple[bool, GH_Interval2D]: ...
    def ToGHInterval2D(data: Object, conversion_level: GH_Conversion, target: GH_Interval2D) -> Tuple[bool, GH_Interval2D]: ...
    def ToGHInterval2D_Secondary(data: Object, target: GH_Interval2D) -> Tuple[bool, GH_Interval2D]: ...
    def ToGHLine_Primary(data: Object, target: GH_Line) -> Tuple[bool, GH_Line]: ...
    def ToGHLine(data: Object, conversion_level: GH_Conversion, target: GH_Line) -> Tuple[bool, GH_Line]: ...
    def ToGHLine_Secondary(data: Object, target: GH_Line) -> Tuple[bool, GH_Line]: ...
    def ToGHMatrix_Primary(data: Object, target: GH_Matrix) -> Tuple[bool, GH_Matrix]: ...
    def ToGHMatrix(data: Object, conversion_level: GH_Conversion, target: GH_Matrix) -> Tuple[bool, GH_Matrix]: ...
    def ToGHMatrix_Secondary(data: Object, target: GH_Matrix) -> Tuple[bool, GH_Matrix]: ...
    def ToGHMesh_Primary(data: Object, target: GH_Mesh) -> Tuple[bool, GH_Mesh]: ...
    def ToGHMesh(data: Object, conversion_level: GH_Conversion, target: GH_Mesh) -> Tuple[bool, GH_Mesh]: ...
    def ToGHMesh_Secondary(data: Object, target: GH_Mesh) -> Tuple[bool, GH_Mesh]: ...
    def ToGHMeshFace_Primary(data: Object, target: GH_MeshFace) -> Tuple[bool, GH_MeshFace]: ...
    def ToGHMeshFace(data: Object, conversion_level: GH_Conversion, target: GH_MeshFace) -> Tuple[bool, GH_MeshFace]: ...
    def ToGHMeshFace_Secondary(data: Object, target: GH_MeshFace) -> Tuple[bool, GH_MeshFace]: ...
    def ToGHNumber_Primary(data: Object, target: GH_Number) -> Tuple[bool, GH_Number]: ...
    def ToGHNumber(data: Object, conversion_level: GH_Conversion, target: GH_Number) -> Tuple[bool, GH_Number]: ...
    def ToGHNumber_Secondary(data: Object, target: GH_Number) -> Tuple[bool, GH_Number]: ...
    def ToGHPlane_Primary(data: Object, target: GH_Plane) -> Tuple[bool, GH_Plane]: ...
    def ToGHPlane(data: Object, conversion_level: GH_Conversion, target: GH_Plane) -> Tuple[bool, GH_Plane]: ...
    def ToGHPlane_Secondary(data: Object, target: GH_Plane) -> Tuple[bool, GH_Plane]: ...
    def ToGHPoint_Primary(data: Object, target: GH_Point) -> Tuple[bool, GH_Point]: ...
    def ToGHPoint(data: Object, conversion_level: GH_Conversion, target: GH_Point) -> Tuple[bool, GH_Point]: ...
    def ToGHPoint_Secondary(data: Object, target: GH_Point) -> Tuple[bool, GH_Point]: ...
    def ToGHRectangle_Primary(data: Object, target: GH_Rectangle) -> Tuple[bool, GH_Rectangle]: ...
    def ToGHRectangle(data: Object, conversion_level: GH_Conversion, target: GH_Rectangle) -> Tuple[bool, GH_Rectangle]: ...
    def ToGHRectangle_Secondary(data: Object, target: GH_Rectangle) -> Tuple[bool, GH_Rectangle]: ...
    def ToGHString_Primary(data: Object, target: GH_String) -> Tuple[bool, GH_String]: ...
    def ToGHString(data: Object, conversion_level: GH_Conversion, target: GH_String) -> Tuple[bool, GH_String]: ...
    def ToGHString_Secondary(data: Object, target: GH_String) -> Tuple[bool, GH_String]: ...
    def ToGHSubD_Primary(data: Object, target: GH_SubD) -> Tuple[bool, GH_SubD]: ...
    def ToGHSubD(data: Object, conversion_level: GH_Conversion, target: GH_SubD) -> Tuple[bool, GH_SubD]: ...
    def ToGHSubD_Secondary(data: Object, target: GH_SubD) -> Tuple[bool, GH_SubD]: ...
    def ToGHSurface_Primary(data: Object, target: GH_Surface) -> Tuple[bool, GH_Surface]: ...
    def ToGHSurface(data: Object, conversion_level: GH_Conversion, target: GH_Surface) -> Tuple[bool, GH_Surface]: ...
    def ToGHSurface_Secondary(data: Object, target: GH_Surface) -> Tuple[bool, GH_Surface]: ...
    def ToGHTime_Primary(data: Object, target: GH_Time) -> Tuple[bool, GH_Time]: ...
    def ToGHTime(data: Object, conversion_level: GH_Conversion, target: GH_Time) -> Tuple[bool, GH_Time]: ...
    def ToGHTime_Secondary(data: Object, target: GH_Time) -> Tuple[bool, GH_Time]: ...
    def ToGHVector_Primary(data: Object, target: GH_Vector) -> Tuple[bool, GH_Vector]: ...
    def ToGHVector(data: Object, conversion_level: GH_Conversion, target: GH_Vector) -> Tuple[bool, GH_Vector]: ...
    def ToGHVector_Secondary(data: Object, target: GH_Vector) -> Tuple[bool, GH_Vector]: ...
    def ToGoo(data: Object) -> IGH_Goo: ...
    def ToGUID_Primary(data: Object, destination: Guid) -> Tuple[bool, Guid]: ...
    def ToGUID(data: Object, conversion_level: GH_Conversion) -> Tuple[bool, Guid]: ...
    def ToGUID_Secondary(data: Object, destination: Guid) -> Tuple[bool, Guid]: ...
    def ToInt32_Primary(data: Object, destination: int) -> Tuple[bool, int]: ...
    def ToInt32(data: Object, conversion_level: GH_Conversion) -> Tuple[bool, int]: ...
    def ToInt32_Secondary(data: Object, destination: int) -> Tuple[bool, int]: ...
    def ToInterval_Primary(data: Object, rc: Interval) -> Tuple[bool, Interval]: ...
    def ToInterval(data: Object, rc: Interval, conversion_level: GH_Conversion) -> Tuple[bool, Interval]: ...
    def ToInterval_Secondary(data: Object, rc: Interval) -> Tuple[bool, Interval]: ...
    def ToLine_Primary(data: Object, rc: Line) -> Tuple[bool, Line]: ...
    def ToLine(data: Object, rc: Line, conversion_level: GH_Conversion) -> Tuple[bool, Line]: ...
    def ToLine_Secondary(data: Object, rc: Line) -> Tuple[bool, Line]: ...
    def ToMatrix_Primary(data: Object, rc: Matrix) -> Tuple[bool, Matrix]: ...
    def ToMatrix(data: Object, rc: Matrix, conversion_level: GH_Conversion) -> Tuple[bool, Matrix]: ...
    def ToMatrix_Secondary(data: Object, rc: Matrix) -> Tuple[bool, Matrix]: ...
    def ToMesh_Primary(data: Object, rc: Mesh) -> Tuple[bool, Mesh]: ...
    def ToMesh(data: Object, rc: Mesh, conversion_level: GH_Conversion) -> Tuple[bool, Mesh]: ...
    def ToMesh_Secondary(data: Object, rc: Mesh) -> Tuple[bool, Mesh]: ...
    def ToNextPowerOfTen(num: float) -> float: ...
    def ToPlane_Primary(data: Object, rc: Plane) -> Tuple[bool, Plane]: ...
    def ToPlane(data: Object, rc: Plane, conversion_level: GH_Conversion) -> Tuple[bool, Plane]: ...
    def ToPlane_Secondary(data: Object, rc: Plane) -> Tuple[bool, Plane]: ...
    def ToPlural(singular: str) -> str: ...
    def ToPoint(in: PointF) -> Point: ...
    def ToPoint3d_Primary(data: Object, rc: Point3d) -> Tuple[bool, Point3d]: ...
    def ToPoint3d(data: Object, rc: Point3d, conversion_level: GH_Conversion) -> Tuple[bool, Point3d]: ...
    def ToPoint3d_Secondary(data: Object, rc: Point3d) -> Tuple[bool, Point3d]: ...
    def ToPointF(in: Point3d) -> PointF: ...
    def ToPrevPowerOfTen(num: float) -> float: ...
    def ToRectangle(in: RectangleF) -> Rectangle: ...
    def ToRectangle3d_Primary(data: Object, rc: Rectangle3d) -> Tuple[bool, Rectangle3d]: ...
    def ToRectangle3d(data: Object, rc: Rectangle3d, conversion_level: GH_Conversion) -> Tuple[bool, Rectangle3d]: ...
    def ToRectangle3d_Secondary(data: Object, rc: Rectangle3d) -> Tuple[bool, Rectangle3d]: ...
    def ToSafeRhinoCommonObject(data: Object) -> Object: ...
    @overload
    def ToSHA_Hash(data: Stream) -> Guid: ...
    @overload
    def ToSHA_Hash(data: Set(Byte)) -> Guid: ...
    def ToSize(in: SizeF) -> Size: ...
    def ToString_Primary(data: Object, destination: str) -> Tuple[bool, str]: ...
    @overload
    def ToString(data: Object, conversion_level: GH_Conversion) -> Tuple[bool, str]: ...
    def ToString_Secondary(data: Object, destination: str) -> Tuple[bool, str]: ...
    def ToSubD_Secondary(data: Object, rc: SubD) -> Tuple[bool, SubD]: ...
    def ToSurface_Primary(data: Object, rc: Surface) -> Tuple[bool, Surface]: ...
    def ToSurface(data: Object, rc: Surface, conversion_level: GH_Conversion) -> Tuple[bool, Surface]: ...
    def ToSurface_Secondary(data: Object, rc: Surface) -> Tuple[bool, Surface]: ...
    def ToUVInterval_Primary(data: Object, rc: UVInterval) -> Tuple[bool, UVInterval]: ...
    def ToUVInterval(data: Object, rc: UVInterval, conversion_level: GH_Conversion) -> Tuple[bool, UVInterval]: ...
    def ToUVInterval_Secondary(data: Object, rc: UVInterval) -> Tuple[bool, UVInterval]: ...
    def ToVariableName(compound: str) -> str: ...
    def ToVariant(value: Object) -> GH_Variant: ...
    def ToVector3d_Primary(data: Object, rc: Vector3d) -> Tuple[bool, Vector3d]: ...
    def ToVector3d(data: Object, rc: Vector3d, conversion_level: GH_Conversion) -> Tuple[bool, Vector3d]: ...
    def ToVector3d_Secondary(data: Object, rc: Vector3d) -> Tuple[bool, Vector3d]: ...


class GH_CustomEventServer:
    def __init__(self, consumer: IGH_EventConsumer): ...
    @property
    def Enabled(self) -> bool: ...
    @property
    def GuidTable(self) -> SortedDictionary: ...
    @property
    def GuidTableCount(self) -> int: ...
    @Enabled.setter
    def Enabled(self, Value: bool) -> None: ...


class GH_DataComparison:
    ShortestList = 0
    LongestList = 1
    CrossReference = 2


class GH_DataMapping:
    #None = 0
    Flatten = 1
    Graft = 2


class GH_DebugDescriptionWriter:
    def __init__(self): ...
    def CloseBlock(self) -> None: ...
    def CreateBlock(self, name: str) -> None: ...
    def CreateLog(self) -> str: ...
    @property
    def Depth(self) -> int: ...
    @overload
    def WriteLine(self) -> None: ...
    @overload
    def WriteLine(self, line: str) -> None: ...
    @overload
    def WriteLine(self, line: str, args: Set(Object)) -> None: ...
    def WriteLogToFile(self, path: str) -> bool: ...


class GH_DisplayExpiredEventArgs:
    def __init__(self, eForceRedraw: bool): ...
    @property
    def ForceRedraw(self) -> bool: ...


class GH_DocContextEventArgs:
    @property
    def Context(self) -> GH_DocumentContext: ...
    @property
    def Document(self) -> GH_Document: ...


class GH_DocEnabledEventArgs:
    @property
    def Document(self) -> GH_Document: ...
    @property
    def Enabled(self) -> bool: ...


class GH_DocFilePathEventArgs:
    def __init__(self, document: GH_Document, oldPath: str, newPath: str): ...
    @property
    def Document(self) -> GH_Document: ...
    @property
    def NewFilePath(self) -> str: ...
    @property
    def OldFilePath(self) -> str: ...


class GH_DocModifiedEventArgs:
    @property
    def Document(self) -> GH_Document: ...
    @property
    def Modified(self) -> bool: ...


class GH_DocObjectEventArgs:
    @property
    def Attributes(self) -> List: ...
    @property
    def Document(self) -> GH_Document: ...
    @property
    def Object(self, index: int) -> IGH_DocumentObject: ...
    @property
    def ObjectCount(self) -> int: ...
    @property
    def Objects(self) -> ReadOnlyCollection: ...


class GH_DocSettingsEventArgs:
    @property
    def Document(self) -> GH_Document: ...
    @property
    def Kind(self) -> GH_DocumentSettings: ...


class GH_Document:
    def __init__(self): ...
    def ActiveObjects(self) -> List: ...
    def add_ContextChanged(self, obj: ContextChangedEventHandler) -> None: ...
    def add_DefaultPreviewColourChanged(obj: DefaultPreviewColourChangedEventHandler) -> None: ...
    def add_DefaultSelectedPreviewColourChanged(obj: DefaultSelectedPreviewColourChangedEventHandler) -> None: ...
    def add_EnabledChanged(self, obj: EnabledChangedEventHandler) -> None: ...
    def add_EnableSolutionsChanged(obj: EnableSolutionsChangedEventHandler) -> None: ...
    def add_FilePathChanged(self, obj: FilePathChangedEventHandler) -> None: ...
    def add_ModifiedChanged(self, obj: ModifiedChangedEventHandler) -> None: ...
    def add_ObjectsAdded(self, obj: ObjectsAddedEventHandler) -> None: ...
    def add_ObjectsDeleted(self, obj: ObjectsDeletedEventHandler) -> None: ...
    def add_SettingsChanged(self, obj: SettingsChangedEventHandler) -> None: ...
    def add_SolutionEnd(self, obj: SolutionEndEventHandler) -> None: ...
    def add_SolutionStart(self, obj: SolutionStartEventHandler) -> None: ...
    def add_UndoStateChanged(self, obj: UndoStateChangedEventHandler) -> None: ...
    def AddObject(self, docObject: IGH_DocumentObject, update: bool, index: int) -> bool: ...
    @overload
    def AlignObjects(self, align: GH_Align, distribute: GH_Distribute) -> None: ...
    @overload
    def AlignObjects(self, align: GH_Align, distribute: GH_Distribute, objs: List) -> None: ...
    def AppendToDebugLog(self, writer: GH_DebugDescriptionWriter) -> None: ...
    def ArrangeObject(self, obj: IGH_DocumentObject, motion: GH_Arrange) -> bool: ...
    def ArrangeObjects(self, objs: Iterable[IGH_DocumentObject], motion: GH_Arrange) -> bool: ...
    def AssociateWithRhinoDocument(self) -> None: ...
    def AutoLayoutComponents(self, limitToSelection: bool) -> None: ...
    @overload
    def AutoSave(self, trigger: GH_AutoSaveTrigger) -> bool: ...
    @overload
    def AutoSave(self, trigger: GH_AutoSaveTrigger, id: Guid) -> bool: ...
    def AutoSaveFileName(filename: str) -> str: ...
    def BoundingBox(self, limitToSelection: bool) -> RectangleF: ...
    def BringSelectionToTop(self) -> None: ...
    def ClearIgnoreList(self) -> None: ...
    def ClearReferenceTable(self) -> None: ...
    def CloseAllSubsidiaries(self) -> int: ...
    def ClusterInputHooks(self) -> Set(GH_ClusterInputHook): ...
    def ClusterInstanceCount(self, id: Guid) -> int: ...
    def ClusterOutputHooks(self) -> Set(GH_ClusterOutputHook): ...
    def CompareTo(self, other: GH_Document) -> int: ...
    def ConstructDocumentTree(self) -> GH_DocumentTree: ...
    def ContainsClusterHooks(self) -> bool: ...
    def ConvertFullNamesToNickNames(self) -> None: ...
    def ConvertNickNamesToFullNames(self) -> None: ...
    def CreateAutomaticClusterHooks(self) -> None: ...
    def CreateConnectivityDiagram(self) -> GH_ConnectivityDiagram: ...
    def CreateExpressionParser(self) -> GH_ExpressionParser: ...
    def DefineConstant(self, name: str, value: GH_Variant) -> None: ...
    def DeselectAll(self) -> None: ...
    def DestroyAttributeCache(self) -> None: ...
    def DestroyAutoSaveFiles(self) -> None: ...
    def DestroyObjectTable(self) -> None: ...
    def DestroyPreviewMeshes(self) -> None: ...
    def DestroyProxySources(self) -> None: ...
    def DisabledObjects(self) -> List: ...
    def Dispose(self) -> None: ...
    def DuplicateDocument(doc: GH_Document) -> GH_Document: ...
    def EnabledObjects(self) -> List: ...
    def ExpandSelection(self, Upstream: bool, Downstream: bool, GrowSelection: bool) -> None: ...
    def ExpirePreview(self, redraw: bool) -> None: ...
    def ExpireSolution(self) -> None: ...
    def FilterActive(in: List) -> List: ...
    def FilterDisabled(in: List) -> List: ...
    def FilterEnabled(in: List) -> List: ...
    def FilterInactive(in: List) -> List: ...
    @overload
    def FilterObjects(self, selectedObjects: GH_Filter, enabledObjects: GH_Filter, activeObjects: GH_Filter) -> List: ...
    @overload
    def FilterObjects(in: List, bSelectedObjects: GH_Filter, bEnabledObjects: GH_Filter, bActiveObjects: GH_Filter) -> List: ...
    def FilterSelected(in: List) -> List: ...
    def FilterUnselected(in: List) -> List: ...
    @overload
    def FindAllDownstreamObjects(self, from_: List) -> List: ...
    @overload
    def FindAllDownstreamObjects(self, from_: IGH_ActiveObject) -> List: ...
    @overload
    def FindAllDownstreamObjects(self, from_: List, filter: GH_ActiveObjectFilter) -> List: ...
    @overload
    def FindAllDownstreamObjects(self, from_: IGH_ActiveObject, filter: GH_ActiveObjectFilter) -> List: ...
    @overload
    def FindAttribute(self, id: Guid) -> IGH_Attributes: ...
    @overload
    def FindAttribute(self, pt: PointF, topLevelOnly: bool) -> IGH_Attributes: ...
    @overload
    def FindAttributeByGrip(self, pt: PointF, bLimitToOutside: bool, SearchRadius: int) -> IGH_Attributes: ...
    @overload
    def FindAttributeByGrip(self, pt: PointF, bLimitToOutside: bool, bIncludeInputs: bool, bIncludeOutputs: bool, SearchRadius: int) -> IGH_Attributes: ...
    @overload
    def FindClusters(self, filepath: str) -> List: ...
    @overload
    def FindClusters(self, id: Guid) -> List: ...
    @overload
    def FindComponent(self, pt: Point) -> IGH_Component: ...
    @overload
    def FindComponent(self, id: Guid) -> IGH_Component: ...
    def FindFloatingParameter(self, pt: Point) -> IGH_Param: ...
    def FindInputParameter(self, pt: Point) -> IGH_Param: ...
    @overload
    def FindObject(self, id: Guid, topLevelOnly: bool) -> T: ...
    @overload
    def FindObject(self, pt: PointF, radius: Single) -> IGH_DocumentObject: ...
    @overload
    def FindObject(self, id: Guid, topLevelOnly: bool) -> IGH_DocumentObject: ...
    def FindObjects(self, keys: List, maxCount: int) -> List: ...
    def FindOutputParameter(self, pt: Point) -> IGH_Param: ...
    def FindParameter(self, id: Guid) -> IGH_Param: ...
    def FindWireAt(self, point: PointF, radius: Single, source: IGH_Param, target: IGH_Param) -> Tuple[bool, IGH_Param, IGH_Param]: ...
    @property
    def AbortRequested(self) -> bool: ...
    @property
    def AttributeCount(self) -> int: ...
    @property
    def Attributes(self) -> List[IGH_Attributes]: ...
    @property
    def Author(self) -> IGH_Author: ...
    @property
    def ConstantServer(self) -> SortedDictionary: ...
    @property
    def ContainsCustomPreviewObjects(self) -> bool: ...
    @property
    def ContainsCustomRenderObjects(self) -> bool: ...
    @property
    def Context(self) -> GH_DocumentContext: ...
    @property
    def CustomRenderObjects(self) -> Iterable[GH_CustomPreviewComponent]: ...
    @property
    def DefaultPreviewColour() -> Color: ...
    @property
    def DefaultSelectedPreviewColour() -> Color: ...
    @property
    def DisplayName(self) -> str: ...
    @property
    def DocumentID(self) -> Guid: ...
    @property
    def Enabled(self) -> bool: ...
    @property
    def EnableSolutions() -> bool: ...
    @property
    def EventServer(self) -> GH_DocumentEventServer: ...
    @property
    def FileNameProxy(self) -> str: ...
    @property
    def FilePath(self) -> str: ...
    @property
    def IgnoredCount(self) -> int: ...
    @property
    def IsFilePathDefined(self) -> bool: ...
    @property
    def IsModified(self) -> bool: ...
    @property
    def ModifiedSubsidiaries(self) -> int: ...
    @property
    def Nested(self) -> bool: ...
    @property
    def ObjectCount(self) -> int: ...
    @property
    def Objects(self) -> List[IGH_DocumentObject]: ...
    @property
    def ObjectSpan(self) -> TimeSpan: ...
    @property
    def Owner(self) -> IGH_DocumentOwner: ...
    @property
    def PreviewBoundingBox(self) -> BoundingBox: ...
    @property
    def PreviewColour(self) -> Color: ...
    @property
    def PreviewColourSelected(self) -> Color: ...
    @property
    def PreviewCustomMeshParameters(self) -> MeshingParameters: ...
    @property
    def PreviewFilter(self) -> GH_PreviewFilter: ...
    @property
    def PreviewMeshType(self) -> GH_PreviewMesh: ...
    @property
    def PreviewMode(self) -> GH_PreviewMode: ...
    @property
    def Profiler(self) -> GH_ProfilerMode: ...
    @property
    def Properties(self) -> GH_DocumentProperties: ...
    @property
    def RaiseEvents(self) -> bool: ...
    @property
    def RemotePanelLayout(self) -> RcpLayout: ...
    @property
    def RuntimeID(self) -> UInt64: ...
    @property
    def ScheduleDelay(self) -> int: ...
    @property
    def SelectedCount(self) -> int: ...
    @property
    def SelectionTopology(self) -> GH_SelectionTopology: ...
    @property
    def SolutionDepth(self) -> int: ...
    @property
    def SolutionHistory(self) -> List: ...
    @property
    def SolutionSpan(self) -> TimeSpan: ...
    @property
    def SolutionState(self) -> GH_ProcessStep: ...
    @property
    def StateServer(self) -> GH_StateServer: ...
    @property
    def Thumbnail(self) -> Bitmap: ...
    @property
    def UndoServer(self) -> GH_UndoServer: ...
    @property
    def UndoUtil(self) -> GH_UndoUtil: ...
    def GetAllInstanceIDs(self, topLevelOnly: bool) -> SortedList: ...
    def InactiveObjects(self) -> List: ...
    def InvertSelection(self) -> None: ...
    def IsEscapeKeyDown() -> bool: ...
    def IsRenderMeshPipelineViewport(self, pipeline: DisplayPipeline) -> bool: ...
    @overload
    def MergeDocument(self, other: GH_Document) -> bool: ...
    @overload
    def MergeDocument(self, other: GH_Document, resolveProxies: bool) -> bool: ...
    @overload
    def MergeDocument(self, other: GH_Document, resolveProxies: bool, removeProxies: bool) -> bool: ...
    def Modified(self) -> None: ...
    def MutateAllIds(self) -> None: ...
    @overload
    def NewSolution(self, expireAllObjects: bool) -> None: ...
    @overload
    def NewSolution(self, expireAllObjects: bool, mode: GH_SolutionMode) -> None: ...
    def NonBlankFilter(iObj: IGH_ActiveObject) -> bool: ...
    def NullFilter(iObj: IGH_ActiveObject) -> bool: ...
    def OnContextChanged(self) -> None: ...
    def OnEnabledChanged(self) -> None: ...
    def OnFilePathChanged(self, old: str, new: str) -> None: ...
    def OnModifiedChanged(self) -> None: ...
    def OnObjectAdded(self, doc_object: IGH_DocumentObject) -> None: ...
    def OnObjectDeleted(self, doc_object: IGH_DocumentObject) -> None: ...
    def OnObjectsAdded(self, doc_objects: Iterable[IGH_DocumentObject]) -> None: ...
    def OnObjectsDeleted(self, doc_objects: Iterable[IGH_DocumentObject]) -> None: ...
    def OnSettingsChanged(self, kind: GH_DocumentSettings) -> None: ...
    def OnUndoStateChanged(self, op: GH_UndoOperation, rec: GH_UndoRecord) -> None: ...
    def PreviewCurrentMeshParameters(self) -> MeshingParameters: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def Redo(self) -> bool: ...
    @overload
    def RelevantObjectAtPoint(self, pt: PointF) -> GH_RelevantObjectData: ...
    @overload
    def RelevantObjectAtPoint(self, pt: PointF, searchFilter: GH_RelevantObjectFilter) -> GH_RelevantObjectData: ...
    def remove_ContextChanged(self, obj: ContextChangedEventHandler) -> None: ...
    def remove_DefaultPreviewColourChanged(obj: DefaultPreviewColourChangedEventHandler) -> None: ...
    def remove_DefaultSelectedPreviewColourChanged(obj: DefaultSelectedPreviewColourChangedEventHandler) -> None: ...
    def remove_EnabledChanged(self, obj: EnabledChangedEventHandler) -> None: ...
    def remove_EnableSolutionsChanged(obj: EnableSolutionsChangedEventHandler) -> None: ...
    def remove_FilePathChanged(self, obj: FilePathChangedEventHandler) -> None: ...
    def remove_ModifiedChanged(self, obj: ModifiedChangedEventHandler) -> None: ...
    def remove_ObjectsAdded(self, obj: ObjectsAddedEventHandler) -> None: ...
    def remove_ObjectsDeleted(self, obj: ObjectsDeletedEventHandler) -> None: ...
    def remove_SettingsChanged(self, obj: SettingsChangedEventHandler) -> None: ...
    def remove_SolutionEnd(self, obj: SolutionEndEventHandler) -> None: ...
    def remove_SolutionStart(self, obj: SolutionStartEventHandler) -> None: ...
    def remove_UndoStateChanged(self, obj: UndoStateChangedEventHandler) -> None: ...
    @overload
    def RemoveObject(self, docObject: IGH_DocumentObject, update: bool) -> bool: ...
    @overload
    def RemoveObject(self, attribute: IGH_Attributes, update: bool) -> bool: ...
    def RemoveObjects(self, objectList: Iterable[IGH_DocumentObject], update: bool) -> int: ...
    def RemoveSelection(self, update: bool) -> None: ...
    def RepairProxySources(self) -> bool: ...
    def ReplaceProxySources(self) -> None: ...
    def RequestAbortSolution(self) -> None: ...
    @overload
    def ScheduleSolution(self, delay: int) -> None: ...
    @overload
    def ScheduleSolution(self, delay: int, callback: GH_ScheduleDelegate) -> None: ...
    @overload
    def Select(self, obj_dat: GH_RelevantObjectData) -> GH_SelectionState: ...
    @overload
    def Select(self, obj_dat: GH_RelevantObjectData, bAdd: bool, bRemove: bool) -> GH_SelectionState: ...
    def SelectAll(self) -> None: ...
    def SelectedObjects(self) -> List: ...
    @Context.setter
    def Context(self, Value: GH_DocumentContext) -> None: ...
    @DefaultPreviewColour.setter
    def DefaultPreviewColour(Value: Color) -> None: ...
    @DefaultSelectedPreviewColour.setter
    def DefaultSelectedPreviewColour(Value: Color) -> None: ...
    @Enabled.setter
    def Enabled(self, Value: bool) -> None: ...
    @EnableSolutions.setter
    def EnableSolutions(Value: bool) -> None: ...
    @FilePath.setter
    def FilePath(self, Value: str) -> None: ...
    @IsModified.setter
    def IsModified(self, Value: bool) -> None: ...
    @Nested.setter
    def Nested(self, Value: bool) -> None: ...
    @Owner.setter
    def Owner(self, Value: IGH_DocumentOwner) -> None: ...
    @PreviewColour.setter
    def PreviewColour(self, Value: Color) -> None: ...
    @PreviewColourSelected.setter
    def PreviewColourSelected(self, Value: Color) -> None: ...
    @PreviewCustomMeshParameters.setter
    def PreviewCustomMeshParameters(self, Value: MeshingParameters) -> None: ...
    @PreviewFilter.setter
    def PreviewFilter(self, Value: GH_PreviewFilter) -> None: ...
    @PreviewMeshType.setter
    def PreviewMeshType(self, Value: GH_PreviewMesh) -> None: ...
    @PreviewMode.setter
    def PreviewMode(self, Value: GH_PreviewMode) -> None: ...
    @Profiler.setter
    def Profiler(self, Value: GH_ProfilerMode) -> None: ...
    @RaiseEvents.setter
    def RaiseEvents(self, Value: bool) -> None: ...
    @Thumbnail.setter
    def Thumbnail(self, Value: Bitmap) -> None: ...
    @overload
    def SetEnabledFlags(self, bEnable: bool) -> None: ...
    @overload
    def SetEnabledFlags(self, objects: List, bEnable: bool) -> None: ...
    @overload
    def SetPreviewFlags(self, bPreview: bool) -> None: ...
    @overload
    def SetPreviewFlags(self, objects: List, bPreview: bool) -> None: ...
    def ShowPreviewSettings(self) -> None: ...
    def SolutionProgress(self) -> Tuple[int, int, int]: ...
    @overload
    def ToggleEnabledFlags(self) -> None: ...
    @overload
    def ToggleEnabledFlags(self, objects: List) -> None: ...
    @overload
    def TogglePreviewFlags(self) -> None: ...
    @overload
    def TogglePreviewFlags(self, objects: List) -> None: ...
    def ToString(self) -> str: ...
    def TranslateObjects(self, trXForm: Size, bLimitToSelection: bool) -> None: ...
    def Undo(self) -> bool: ...
    def UnselectedObjects(self) -> List: ...
    def UpdateAllSubsidiaries(self) -> int: ...
    @overload
    def Write(self, writer: GH_IWriter) -> bool: ...
    @overload
    def Write(self, writer: GH_IWriter, objList: List[IGH_DocumentObject]) -> bool: ...


class GH_DocumentAssociations:
    def __init__(self): ...
    def Associate(self, rhinoFile: str, grasshopperFile: str) -> None: ...
    def GetGrasshopperAssociations(self, rhinoFile: str) -> List: ...
    def GetRhinoAssociations(self, grasshopperFile: str) -> List: ...


class GH_DocumentContext:
    Unknown = 0
    #None = 1
    Open = 2
    Close = 3
    Loaded = 4
    Unloaded = 5
    Lock = 6
    Unlock = 7


class GH_DocumentEventServer:
    def __init__(self, document: GH_Document): ...
    def AppendToDebugLog(self, writer: GH_DebugDescriptionWriter) -> None: ...
    def ClearGuidTable(self) -> None: ...
    def CreateGuidTable(self) -> None: ...
    def EnsureGuidTable(self) -> None: ...
    @property
    def Enabled(self) -> bool: ...
    @property
    def GuidTableRefCount(self) -> int: ...
    @Enabled.setter
    def Enabled(self, Value: bool) -> None: ...


class GH_DocumentIO:
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, internal_doc: GH_Document): ...
    def ClearClipboard(self, clipboard: GH_ClipboardType) -> None: ...
    @overload
    def Copy(self, clipboard: GH_ClipboardType) -> bool: ...
    @overload
    def Copy(self, clipboard: GH_ClipboardType, guids: Iterable[Guid]) -> bool: ...
    @overload
    def Copy(self, clipboard: GH_ClipboardType, limitToSelection: bool) -> bool: ...
    @property
    def Document(self) -> GH_Document: ...
    @property
    def IsDocument(self) -> bool: ...
    def GetDocumentThumbnail(filePath: str) -> Bitmap: ...
    @overload
    def Open(self) -> bool: ...
    @overload
    def Open(self, filePath: str) -> bool: ...
    def OpenDocumentDialog(self, path: str, title: str) -> str: ...
    def Paste(self, clipboard: GH_ClipboardType) -> bool: ...
    def Save(self) -> bool: ...
    def SaveAs(self) -> bool: ...
    def SaveAsCopyDocumentDialog(self, path: str) -> str: ...
    def SaveAsDocumentDialog(self, path: str) -> str: ...
    def SaveBackup(self) -> bool: ...
    def SaveDocumentDialog(self, path: str, title: str) -> str: ...
    def SaveQuiet(self, path: str) -> bool: ...
    @Document.setter
    def Document(self, Value: GH_Document) -> None: ...
    @overload
    def SubsidiaryDocumentSavePrompt(document: GH_Document) -> DialogResult: ...
    @overload
    def SubsidiaryDocumentSavePrompt(documentName: str, modified: bool, modifiedSubsidiaries: int) -> DialogResult: ...


class GH_DocumentObject(GH_InstanceDescription):
    def add_AttributesChanged(self, obj: AttributesChangedEventHandler) -> None: ...
    def add_DisplayExpired(self, obj: DisplayExpiredEventHandler) -> None: ...
    def add_ObjectChanged(self, obj: ObjectChangedEventHandler) -> None: ...
    def add_PingDocument(self, obj: PingDocumentEventHandler) -> None: ...
    def add_PreviewExpired(self, obj: PreviewExpiredEventHandler) -> None: ...
    def add_SolutionExpired(self, obj: SolutionExpiredEventHandler) -> None: ...
    def AddedToDocument(self, document: GH_Document) -> None: ...
    def AppendMenuItems(self, menu: ToolStripDropDown) -> bool: ...
    def CreateAttributes(self) -> None: ...
    def DocumentContextChanged(self, document: GH_Document, context: GH_DocumentContext) -> None: ...
    def ExpirePreview(self, redraw: bool) -> None: ...
    def ExpireSolution(self, recompute: bool) -> None: ...
    @property
    def Attributes(self) -> IGH_Attributes: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def Icon_24x24(self) -> Bitmap: ...
    @property
    def Icon_24x24_Locked(self) -> Bitmap: ...
    @property
    def IconDisplayMode(self) -> GH_IconDisplayMode: ...
    @property
    def Obsolete(self) -> bool: ...
    def IsolateObject(self) -> None: ...
    def Menu_AppendColourPicker(menu: ToolStripDropDown, colour: Color, colourChanged: ColourEventHandler) -> GH_ColourPicker: ...
    @overload
    def Menu_AppendCustomItem(menu: ToolStripDropDown, control: Control) -> bool: ...
    @overload
    def Menu_AppendCustomItem(menu: ToolStripDropDown, control: Control, keydown: KeyDownEventHandler) -> bool: ...
    @overload
    def Menu_AppendCustomItem(menu: ToolStripDropDown, control: Control, keydown: KeyDownEventHandler, enabled: bool, width: int, lockOnFocus: bool) -> bool: ...
    def Menu_AppendDigitScrollerItem(menu: ToolStripDropDown, min: Decimal, max: Decimal, value: Decimal, decimals: int) -> GH_DigitScrollerBase: ...
    @overload
    def Menu_AppendItem(menu: ToolStrip, text: str) -> ToolStripMenuItem: ...
    @overload
    def Menu_AppendItem(menu: ToolStrip, text: str, click: EventHandler) -> ToolStripMenuItem: ...
    @overload
    def Menu_AppendItem(menu: ToolStrip, text: str, click: EventHandler, enabled: bool) -> ToolStripMenuItem: ...
    @overload
    def Menu_AppendItem(menu: ToolStrip, text: str, click: EventHandler, icon: Image) -> ToolStripMenuItem: ...
    @overload
    def Menu_AppendItem(menu: ToolStrip, text: str, click: EventHandler, enabled: bool, checked: bool) -> ToolStripMenuItem: ...
    @overload
    def Menu_AppendItem(menu: ToolStrip, text: str, click: EventHandler, icon: Image, tag: Object) -> ToolStripMenuItem: ...
    @overload
    def Menu_AppendItem(menu: ToolStrip, text: str, click: EventHandler, icon: Image, enabled: bool, checked: bool) -> ToolStripMenuItem: ...
    def Menu_AppendSeparator(menu: ToolStrip) -> ToolStripSeparator: ...
    @overload
    def Menu_AppendTextItem(menu: ToolStripDropDown, text: str, keydown: KeyDownEventHandler, textchanged: TextChangedEventHandler, lockOnFocus: bool) -> ToolStripTextBox: ...
    @overload
    def Menu_AppendTextItem(menu: ToolStripDropDown, text: str, keydown: KeyDownEventHandler, textchanged: TextChangedEventHandler, enabled: bool, width: int, lockOnFocus: bool) -> ToolStripTextBox: ...
    @overload
    def Menu_MoveItem(item: ToolStripItem, precedingItems: Set(str)) -> bool: ...
    @overload
    def Menu_MoveItem(item: ToolStripItem, insertBelow: bool, targets: Set(str)) -> bool: ...
    def MovedBetweenDocuments(self, oldDocument: GH_Document, newDocument: GH_Document) -> None: ...
    def OnAttributesChanged(self) -> None: ...
    def OnDisplayExpired(self, redraw: bool) -> None: ...
    @overload
    def OnObjectChanged(self, eventType: GH_ObjectEventType) -> None: ...
    @overload
    def OnObjectChanged(self, customEvent: str) -> None: ...
    @overload
    def OnObjectChanged(self, e: GH_ObjectChangedEventArgs) -> None: ...
    @overload
    def OnObjectChanged(self, eventType: GH_ObjectEventType, tag: Object) -> None: ...
    @overload
    def OnObjectChanged(self, customEvent: str, tag: Object) -> None: ...
    def OnPingDocument(self) -> GH_Document: ...
    def OnPreviewExpired(self, redraw: bool) -> None: ...
    def OnSolutionExpired(self, recompute: bool) -> None: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    @overload
    def RecordUndoEvent(self, undoName: str) -> Guid: ...
    @overload
    def RecordUndoEvent(self, record: GH_UndoRecord) -> None: ...
    @overload
    def RecordUndoEvent(self, undoName: str, action: IGH_UndoAction) -> Guid: ...
    def remove_AttributesChanged(self, obj: AttributesChangedEventHandler) -> None: ...
    def remove_DisplayExpired(self, obj: DisplayExpiredEventHandler) -> None: ...
    def remove_ObjectChanged(self, obj: ObjectChangedEventHandler) -> None: ...
    def remove_PingDocument(self, obj: PingDocumentEventHandler) -> None: ...
    def remove_PreviewExpired(self, obj: PreviewExpiredEventHandler) -> None: ...
    def remove_SolutionExpired(self, obj: SolutionExpiredEventHandler) -> None: ...
    def RemovedFromDocument(self, document: GH_Document) -> None: ...
    @Attributes.setter
    def Attributes(self, Value: IGH_Attributes) -> None: ...
    @IconDisplayMode.setter
    def IconDisplayMode(self, Value: GH_IconDisplayMode) -> None: ...
    def SetIconOverride(self, customIcon: Bitmap) -> None: ...
    @overload
    def TriggerAutoSave(self) -> None: ...
    @overload
    def TriggerAutoSave(self, trigger: GH_AutoSaveTrigger) -> None: ...
    @overload
    def TriggerAutoSave(self, id: Guid) -> None: ...
    @overload
    def TriggerAutoSave(self, trigger: GH_AutoSaveTrigger, id: Guid) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_DocumentProperties:
    def __init__(self): ...
    def DisplayProperties(self) -> None: ...
    @property
    def CopyRight(self) -> str: ...
    @property
    def Date(self) -> DateTime: ...
    @property
    def DateTag(self) -> DateTime: ...
    @property
    def Description(self) -> str: ...
    @property
    def ProjectFileName(self) -> str: ...
    @property
    def Revisions(self) -> List: ...
    @property
    def ViewList(self) -> List: ...
    @property
    def ViewTarget(self) -> Point: ...
    @property
    def ZoomFactor(self) -> Single: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    @CopyRight.setter
    def CopyRight(self, Value: str) -> None: ...
    @DateTag.setter
    def DateTag(self, Value: DateTime) -> None: ...
    @Description.setter
    def Description(self, Value: str) -> None: ...
    @ProjectFileName.setter
    def ProjectFileName(self, Value: str) -> None: ...
    @ViewTarget.setter
    def ViewTarget(self, Value: Point) -> None: ...
    @ZoomFactor.setter
    def ZoomFactor(self, Value: Single) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_DocumentRank:
    Unset = 0
    TopLevel = 1
    Subsidiary = 2


class GH_DocumentRenderMeshProvider:
    def __init__(self): ...
    @overload
    def BoundingBox(self, vp: ViewportInfo, obj: RhinoObject, doc: RhinoDoc, requestingPlugIn: Guid, attrs: DisplayPipelineAttributes) -> BoundingBox: ...
    @overload
    def BuildCustomMeshes(self, vp: ViewportInfo, doc: RhinoDoc, objMeshes: RenderPrimitiveList, requestingPlugIn: Guid, attrs: DisplayPipelineAttributes) -> bool: ...
    @property
    def Name(self) -> str: ...
    @overload
    def WillBuildCustomMeshes(self, vp: ViewportInfo, obj: RhinoObject, doc: RhinoDoc, requestingPlugIn: Guid, attrs: DisplayPipelineAttributes) -> bool: ...


class GH_DocumentServer:
    def __init__(self): ...
    def add_DocumentAdded(self, obj: DocumentAddedEventHandler) -> None: ...
    def add_DocumentRemoved(self, obj: DocumentRemovedEventHandler) -> None: ...
    @overload
    def AddDocument(self, document: GH_Document) -> None: ...
    @overload
    def AddDocument(self, filepath: str, makeActive: bool) -> GH_Document: ...
    def AddNewDocument(self) -> GH_Document: ...
    def Contains(self, doc: GH_Document) -> bool: ...
    @property
    def Document(self, index: int) -> GH_Document: ...
    @property
    def DocumentCount(self) -> int: ...
    @property
    def DocumentNames(self) -> List: ...
    @property
    def ModifiedDocumentCount(self) -> int: ...
    def GetEnumerator(self) -> IEnumerator: ...
    def GetEnumerator_Generic(self) -> IEnumerator: ...
    @overload
    def IndexOf(self, doc: GH_Document) -> int: ...
    @overload
    def IndexOf(self, filepath: str) -> int: ...
    def IndexOfAutoSave(self, autoSavePath: str) -> int: ...
    def NextAvailableDocument(self) -> GH_Document: ...
    def PromoteDocument(self, document: GH_Document) -> None: ...
    def remove_DocumentAdded(self, obj: DocumentAddedEventHandler) -> None: ...
    def remove_DocumentRemoved(self, obj: DocumentRemovedEventHandler) -> None: ...
    def RemoveAllDocuments(self) -> None: ...
    def RemoveDocument(self, document: GH_Document) -> None: ...
    def SafeRemoveDocument(self, document: GH_Document) -> bool: ...


class GH_DocumentSettings:
    Preview = 0
    Properties = 1


class GH_DocumentTree:
    def __init__(self, root: GH_Document): ...
    def AppendToDebugLog(self, writer: GH_DebugDescriptionWriter) -> None: ...
    @property
    def FlatCollection(self) -> Iterable[GH_Document]: ...
    @property
    def Root(self) -> GH_DocumentTreeNode: ...
    @property
    def RootDocument(self) -> GH_Document: ...


class GH_DocumentTreeNode:
    def __init__(self, node: GH_Document): ...
    @property
    def Document(self) -> GH_Document: ...
    @property
    def SubNodes(self) -> List: ...


class GH_DocUndoEventArgs:
    @property
    def Document(self) -> GH_Document: ...
    @property
    def Operation(self) -> GH_UndoOperation: ...
    @property
    def Record(self) -> GH_UndoRecord: ...


class GH_Exposure:
    primary = 2
    secondary = 4
    tertiary = 8
    quarternary = 16
    quinary = 32
    senary = 64
    septenary = 128
    dropdown = 65536
    obscure = 65536
    hidden = -1


class GH_ExternalFile:
    def __init__(self, path: str): ...
    @property
    def FileHash(self) -> Guid: ...
    @property
    def FileName(self) -> str: ...
    @property
    def FilePath(self) -> str: ...
    @property
    def FileSize(self) -> Int64: ...
    @property
    def FileType(self) -> GH_ExternalFileType: ...
    def IsIdenticalTo(self, other: GH_ExternalFile) -> bool: ...


class GH_ExternalFileType:
    Unknown = 0
    Assembly = 1
    UserObject = 2
    Cluster = 3


class GH_FileSystemEventServer:
    def AddWatcher(owner: Object, path: str, callback: FileEvent) -> None: ...
    @property
    def AllPaths() -> Iterable[str]: ...
    @overload
    def RemoveWatcher(owner: Object) -> None: ...
    @overload
    def RemoveWatcher(owner: Object, path: str) -> None: ...


class GH_FileWatcher:
    @overload
    def CreateDirectoryWatcher(folderPath: str, filter: str, events: GH_FileWatcherEvents, delegate: FileChangedSimple) -> GH_FileWatcher: ...
    @overload
    def CreateDirectoryWatcher(folderPath: str, filter: str, events: GH_FileWatcherEvents, delegate: FileChanged) -> GH_FileWatcher: ...
    @overload
    def CreateFileWatcher(filePath: str, events: GH_FileWatcherEvents, delegate: FileChangedSimple) -> GH_FileWatcher: ...
    @overload
    def CreateFileWatcher(filePath: str, events: GH_FileWatcherEvents, delegate: FileChanged) -> GH_FileWatcher: ...
    def Dispose(self) -> None: ...
    @property
    def Active(self) -> bool: ...
    @property
    def Buffer(self) -> TimeSpan: ...
    @property
    def InvokeOnDefaultThread(self) -> bool: ...
    @property
    def IsDisposed(self) -> bool: ...
    @property
    def Path(self) -> str: ...
    @Active.setter
    def Active(self, Value: bool) -> None: ...
    @Buffer.setter
    def Buffer(self, Value: TimeSpan) -> None: ...
    @InvokeOnDefaultThread.setter
    def InvokeOnDefaultThread(self, Value: bool) -> None: ...
    @overload
    def SetCustomUIThread(self, target: Control) -> None: ...
    @overload
    def SetCustomUIThread(self, target: Form) -> None: ...


class GH_FileWatcherEvents:
    #None = 0
    Changed = 1
    Renamed = 2
    Created = 4
    Deleted = 8
    All = 15


class GH_Filter:
    DontCare = 0
    Include = 1
    Exclude = 2


class GH_FontServer:
    def add_ConsoleFamilyChanged(obj: ConsoleFamilyChangedEventHandler) -> None: ...
    def add_ScriptFamilyChanged(obj: ScriptFamilyChangedEventHandler) -> None: ...
    def add_StandardFamilyChanged(obj: StandardFamilyChangedEventHandler) -> None: ...
    def FontToString(font: Font) -> str: ...
    @property
    def Console() -> Font: ...
    @property
    def ConsoleAdjusted() -> Font: ...
    @property
    def ConsoleSmall() -> Font: ...
    @property
    def ConsoleSmallAdjusted() -> Font: ...
    @property
    def FamilyConsole() -> FontFamily: ...
    @property
    def FamilyScript() -> FontFamily: ...
    @property
    def FamilyStandard() -> FontFamily: ...
    @property
    def Large() -> Font: ...
    @property
    def LargeAdjusted() -> Font: ...
    @property
    def Script() -> Font: ...
    @property
    def ScriptSmall() -> Font: ...
    @property
    def Small() -> Font: ...
    @property
    def Standard() -> Font: ...
    @property
    def StandardAdjusted() -> Font: ...
    @property
    def StandardBold() -> Font: ...
    @property
    def StandardItalic() -> Font: ...
    @overload
    def MeasureString(text: str, font: Font) -> Size: ...
    @overload
    def MeasureString(text: str, font: Font, maxwidth: Single) -> Size: ...
    @overload
    def MeasureString(text: str, font: Font, iLayout: SizeF) -> Size: ...
    @overload
    def NewFont(family: FontFamily, size: Single) -> Font: ...
    @overload
    def NewFont(font: Font, style: FontStyle) -> Font: ...
    @overload
    def NewFont(font: Font, size: Single) -> Font: ...
    @overload
    def NewFont(family: str, size: Single, style: FontStyle) -> Font: ...
    @overload
    def NewFont(family: FontFamily, size: Single, style: FontStyle) -> Font: ...
    @overload
    def NewFont(font: Font, size: Single, style: FontStyle) -> Font: ...
    def remove_ConsoleFamilyChanged(obj: ConsoleFamilyChangedEventHandler) -> None: ...
    def remove_ScriptFamilyChanged(obj: ScriptFamilyChangedEventHandler) -> None: ...
    def remove_StandardFamilyChanged(obj: StandardFamilyChangedEventHandler) -> None: ...
    @FamilyConsole.setter
    def FamilyConsole(Value: FontFamily) -> None: ...
    @FamilyScript.setter
    def FamilyScript(Value: FontFamily) -> None: ...
    @FamilyStandard.setter
    def FamilyStandard(Value: FontFamily) -> None: ...
    def StringToFont(text: str) -> Font: ...
    @overload
    def StringWidth(text: str, font: Font) -> int: ...
    @overload
    def StringWidth(text: Iterable[str], font: Font) -> int: ...


class GH_Format:
    def DefaultCulture() -> IFormatProvider: ...
    @overload
    def FormatArc(data: GH_Arc) -> str: ...
    @overload
    def FormatArc(data: Arc) -> str: ...
    def FormatArcValidity(val: Arc, identifier: str) -> str: ...
    @overload
    def FormatBoolean(data: GH_Boolean) -> str: ...
    @overload
    def FormatBoolean(data: bool) -> str: ...
    def FormatBoundingBoxValidity(val: BoundingBox, identifier: str) -> str: ...
    @overload
    def FormatBox(data: Box) -> str: ...
    @overload
    def FormatBox(data: GH_Box) -> str: ...
    def FormatBoxValidity(val: Box, identifier: str) -> str: ...
    @overload
    def FormatBrep(data: GH_Brep) -> str: ...
    @overload
    def FormatBrep(data: Brep) -> str: ...
    def FormatBrepValidity(val: Brep, identifier: str) -> str: ...
    @overload
    def FormatCircle(data: GH_Circle) -> str: ...
    @overload
    def FormatCircle(data: Circle) -> str: ...
    def FormatCircleValidity(val: Circle, identifier: str) -> str: ...
    @overload
    def FormatColour(data: Color) -> str: ...
    @overload
    def FormatColour(data: GH_Colour) -> str: ...
    @overload
    def FormatComplexNumber(num: Complex) -> str: ...
    @overload
    def FormatComplexNumber(data: GH_ComplexNumber) -> str: ...
    def FormatComplexValidity(val: Complex, identifier: str) -> str: ...
    @overload
    def FormatCurve(data: GH_Curve) -> str: ...
    @overload
    def FormatCurve(data: Curve, prefix: str, name: str) -> str: ...
    def FormatCurveValidity(val: Curve, identifier: str) -> str: ...
    @overload
    def FormatDate(data: DateTime) -> str: ...
    @overload
    def FormatDate(data: GH_Time) -> str: ...
    @overload
    def FormatDouble(data: GH_Number) -> str: ...
    @overload
    def FormatDouble(data: float) -> str: ...
    def FormatDoubleValidity(val: float, identifier: str) -> str: ...
    @overload
    def FormatFilePath(path: str, maxLength: int) -> str: ...
    @overload
    def FormatFilePath(path: str, maxWidth: int, font: Font) -> str: ...
    def FormatGeometry(data: IGH_GeometricGoo) -> str: ...
    @overload
    def FormatInteger(data: GH_Integer) -> str: ...
    @overload
    def FormatInteger(data: int) -> str: ...
    @overload
    def FormatInterval(data: GH_Interval) -> str: ...
    @overload
    def FormatInterval(data: Interval) -> str: ...
    @overload
    def FormatInterval(data: GH_Interval2D) -> str: ...
    @overload
    def FormatInterval(t0: float, t1: float) -> str: ...
    def FormatIntervalValidity(val: Interval, identifier: str, testSingleton: bool, testDecreasing: bool) -> str: ...
    def FormatKeys(keys: Keys) -> str: ...
    @overload
    def FormatLine(data: Line) -> str: ...
    @overload
    def FormatLine(data: GH_Line) -> str: ...
    def FormatLineValidity(val: Line, identifier: str) -> str: ...
    @overload
    def FormatMatrix(data: GH_Matrix) -> str: ...
    @overload
    def FormatMatrix(data: Matrix) -> str: ...
    @overload
    def FormatMesh(data: GH_Mesh) -> str: ...
    @overload
    def FormatMesh(data: Mesh, sPrefix: str) -> str: ...
    def FormatMeshFace(data: GH_MeshFace) -> str: ...
    def FormatMeshFaceValidity(val: MeshFace, identifier: str) -> str: ...
    def FormatMeshValidity(val: Mesh, identifier: str) -> str: ...
    @overload
    def FormatPlane(data: GH_Plane) -> str: ...
    @overload
    def FormatPlane(data: Plane) -> str: ...
    def FormatPlaneValidity(val: Plane, identifier: str, testUnitAxes: bool) -> str: ...
    @overload
    def FormatPoint(data: GH_Point) -> str: ...
    @overload
    def FormatPoint(data: Point3d) -> str: ...
    def FormatPointCloud(data: PointCloud) -> str: ...
    def FormatPointValidity(val: Point3d, identifier: str) -> str: ...
    def FormatRectangleValidity(val: Rectangle3d, identifier: str) -> str: ...
    def FormatSingle(data: Single) -> str: ...
    @overload
    def FormatSubD(data: GH_SubD) -> str: ...
    @overload
    def FormatSubD(data: SubD) -> str: ...
    def FormatSubDValidity(val: SubD, identifier: str) -> str: ...
    @overload
    def FormatSurface(data: Brep) -> str: ...
    @overload
    def FormatSurface(data: GH_Surface) -> str: ...
    def FormatSurfaceValidity(val: Surface, identifier: str) -> str: ...
    def FormatTransformValidity(val: Transform, identifier: str) -> str: ...
    @overload
    def FormatVector(data: Vector3d) -> str: ...
    @overload
    def FormatVector(data: GH_Vector) -> str: ...
    def FormatVectorValidity(val: Vector3d, identifier: str, testZero: bool, testUnit: bool) -> str: ...
    def RhinoUnitName() -> str: ...
    def RhinoUnitSymbol() -> str: ...
    def TreatAsCollection(obj: Object) -> bool: ...


class GH_GetterResult:
    accept = 0
    success = 1
    cancel = 2


class GH_GHALoadingEventArgs:
    @property
    def Assembly(self) -> Assembly: ...
    @property
    def FileName(self) -> str: ...
    @property
    def Icon(self) -> Bitmap: ...
    @property
    def Id(self) -> Guid: ...
    @property
    def LoadingMechanism(self) -> GH_LoadingMechanism: ...
    @property
    def Name(self) -> str: ...


class GH_GHXHarvester:
    @overload
    def HarvestBoundingBoxes(file: str) -> List: ...
    @overload
    def HarvestBoundingBoxes(archive: GH_Archive) -> List: ...
    @overload
    def HarvestBoundingBoxes(node: GH_IReader) -> List: ...
    @overload
    def HarvestPivots(file: str) -> List: ...
    @overload
    def HarvestPivots(archive: GH_Archive) -> List: ...
    @overload
    def HarvestPivots(node: GH_IReader) -> List: ...


class GH_GraphProxy:
    def __init__(self, nGraph: IGH_Graph, T: Type): ...
    def CompareTo(self, other: GH_GraphProxy) -> int: ...
    @property
    def Description(self) -> str: ...
    @property
    def GUID(self) -> Guid: ...
    @property
    def Icon(self) -> Image: ...
    @property
    def Name(self) -> str: ...
    @property
    def Type(self) -> Type: ...


class GH_GuidConflictSolution:
    Unset = 0
    Replace = 1
    ReplaceAll = 2
    Skip = 3
    SkipAll = 4


class GH_GuidTable:
    def __init__(self): ...
    def Add(self, id: Guid, obj: IGH_ActiveObject) -> None: ...
    def AllObjects(self) -> List: ...
    def Clear(self) -> None: ...
    def Contains(self, id: Guid) -> bool: ...
    @property
    def Count(self) -> int: ...
    @property
    def IsEmpty(self) -> bool: ...
    def Objects(self, id: Guid) -> List: ...


class GH_IconDisplayMode:
    application = 0
    icon = 1
    name = 2


class GH_IncrementalParamNameConstructor:
    def __init__(self, format_mask: str, start_index: int): ...
    def Current(self) -> str: ...
    @property
    def FormatMask(self) -> str: ...
    def Next(self) -> str: ...
    def Reset(self) -> None: ...
    @FormatMask.setter
    def FormatMask(self, Value: str) -> None: ...


class GH_InstanceDescription:
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, other: IGH_InstanceDescription): ...
    @overload
    def __init__(self, name: str, nickName: str, description: str, category: str): ...
    @overload
    def __init__(self, name: str, nickName: str, description: str, category: str, subCategory: str): ...
    def CopyFrom(self, other: IGH_InstanceDescription) -> None: ...
    @property
    def Category(self) -> str: ...
    @property
    def Description(self) -> str: ...
    @property
    def HasCategory(self) -> bool: ...
    @property
    def HasSubCategory(self) -> bool: ...
    @property
    def InstanceDescription(self) -> str: ...
    @property
    def InstanceGuid(self) -> Guid: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    @property
    def NickName(self) -> str: ...
    @property
    def SubCategory(self) -> str: ...
    @overload
    def NewInstanceGuid(self) -> None: ...
    @overload
    def NewInstanceGuid(self, UUID: Guid) -> None: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def ReadFull(self, reader: GH_IReader) -> bool: ...
    @Category.setter
    def Category(self, Value: str) -> None: ...
    @Description.setter
    def Description(self, Value: str) -> None: ...
    @Name.setter
    def Name(self, Value: str) -> None: ...
    @NickName.setter
    def NickName(self, Value: str) -> None: ...
    @SubCategory.setter
    def SubCategory(self, Value: str) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...
    def WriteFull(self, writer: GH_IWriter) -> bool: ...


class GH_LibraryLicense:
    unset = 0
    expired = 1
    alpha = 2
    beta = 3
    free = 4
    opensource = 5
    trial = 6
    commercial = 7
    educational = 8
    developer = 9
    reseller = 10
    other = 11


class GH_LineParser:
    def ParseLine(self, line: str, action: GH_LineParserAction) -> Tuple[Object, GH_LineParserAction]: ...


class GH_LineParserAction:
    Include = 0
    Ignore = 1
    Abort = 2


class GH_ListUtil:
    def CountNonNullRefs(L: List) -> int: ...
    def CountNullRefs(L: List) -> int: ...
    def EnsureNonNullCount(L: List, N: int) -> bool: ...
    def FirstNonNullItem(L: List) -> int: ...
    def RemoveNullRefs(L: List) -> List: ...


class GH_LoadingAttribute:
    def __init__(self, demand: GH_LoadingDemand): ...


class GH_LoadingDemand:
    Default = 0
    ForceCOFF = 1
    ForceDirect = 2
    #None = -1


class GH_LoadingException:
    @overload
    def __init__(self, name: str, message: str): ...
    @overload
    def __init__(self, name: str, ex: Exception): ...
    @overload
    def __init__(self, name: str, message: str, type: str): ...
    @property
    def Message(self) -> str: ...
    @property
    def Name(self) -> str: ...
    @property
    def Type(self) -> str: ...


class GH_LoadingInstruction:
    Proceed = 0
    Abort = 1


class GH_LoadingMechanism:
    COFF = 1
    Direct = 2
    Unknown = -1


class GH_MarkovChain:
    def __init__(self): ...
    def AppendPattern(self, pattern: GH_MarkovPattern) -> None: ...
    def Clear(self) -> None: ...
    def Description(self) -> str: ...
    def ExtendHistory(self, new_id: Guid) -> None: ...
    @overload
    def FindPattern(self, id: Guid) -> GH_MarkovPattern: ...
    @overload
    def FindPattern(self, id1: Guid, id2: Guid) -> GH_MarkovPattern: ...
    @overload
    def FindPattern(self, id1: Guid, id2: Guid, id3: Guid) -> GH_MarkovPattern: ...
    @property
    def Level1(self) -> List: ...
    @property
    def Level2(self) -> List: ...
    @property
    def Level3(self) -> List: ...
    @property
    def PatternCount(self) -> int: ...
    def ReadFromDisc(self) -> None: ...
    def ReduceDataset(self) -> None: ...
    def SuggestEvents(self) -> Set(Guid): ...
    def WriteToDisc(self) -> None: ...


class GH_MarkovOutcome:
    @overload
    def __init__(self, newId: Guid): ...
    @overload
    def __init__(self, other: GH_MarkovOutcome): ...
    @overload
    def __init__(self, newId: Guid, newValence: Int64): ...
    def DecreaseValence(self) -> None: ...
    @property
    def Id(self) -> Guid: ...
    @property
    def IsInsignificant(self) -> bool: ...
    @property
    def Valence(self) -> Int64: ...
    def IncreaseValence(self) -> None: ...
    @Valence.setter
    def Valence(self, AutoPropertyValue: Int64) -> None: ...


class GH_MarkovPattern:
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, pat: Set(Guid)): ...
    @overload
    def __init__(self, other: GH_MarkovPattern): ...
    @overload
    def AppendOutcome(self, id: Guid) -> None: ...
    @overload
    def AppendOutcome(self, outcome: GH_MarkovOutcome) -> None: ...
    def CompareTo(self, other: GH_MarkovPattern) -> int: ...
    @property
    def Depth(self) -> int: ...
    @property
    def IsInsignificant(self) -> bool: ...
    @property
    def MaximumValence(self) -> Int64: ...
    @property
    def Outcomes(self) -> List: ...
    @property
    def Pattern(self) -> Set(Guid): ...
    def RemoveInsignificantOutcomes(self) -> None: ...
    def Simplify(self) -> None: ...


class GH_MatchLevel:
    #None = 0
    Exact = 1
    Start = 2
    WordExact = 4
    WordStart = 8
    Contains = 16
    AllClean = 31
    Fuzzy = 32
    All = 63


class GH_MatchWeight:
    Fuzzy = 10
    Contains = 10
    WordExact = 100
    Start = 100
    WordStart = 100
    Exact = 100


class GH_MathUtil:
    @overload
    def WrapInteger(X: int, upper: int) -> int: ...
    @overload
    def WrapInteger(number: int, lower: int, upper: int) -> int: ...


class GH_MemoryBitmap:
    @overload
    def __init__(self, bitmap: Bitmap): ...
    @overload
    def __init__(self, bitmap: Bitmap, wrap: WrapMode): ...
    def A(self, x: int, y: int) -> Byte: ...
    def B(self, x: int, y: int) -> Byte: ...
    @overload
    def Colour(self, x: int, y: int) -> Color: ...
    @overload
    def Colour(self, x: int, y: int, col: Color) -> None: ...
    def CopyChannel(self, source: GH_BitmapChannel, target: GH_BitmapChannel) -> None: ...
    def Filter_AlphaEdges(self, padding: Padding, alpha_override: Byte) -> None: ...
    @overload
    def Filter_Blur(self) -> None: ...
    @overload
    def Filter_Blur(self, N: int) -> None: ...
    @overload
    def Filter_Blur(self, interior_weight: int, exterior_weight: int) -> None: ...
    @overload
    def Filter_Blur(self, N: int, interior_weight: int, exterior_weight: int) -> None: ...
    def Filter_BlurAlpha(self, N: int, interior_weight: int, exterior_weight: int) -> None: ...
    def Filter_Contrast(self, channel: GH_BitmapChannel, factor: float) -> None: ...
    def Filter_DitherPattern(self, colour: Color) -> None: ...
    def Filter_DropShadow(self, offset: Size, blur: int, darkness: float) -> None: ...
    def Filter_Dullify(self) -> None: ...
    def Filter_Equalize(self, channel: GH_BitmapChannel, value: Byte) -> None: ...
    @overload
    def Filter_GreyScale(self) -> None: ...
    @overload
    def Filter_GreyScale(self, amount: float) -> None: ...
    def Filter_HueScale(self) -> None: ...
    def Filter_Invert(self, channel: GH_BitmapChannel) -> None: ...
    def Filter_LumScale(self) -> None: ...
    @overload
    def Filter_Multiply(self, channel: GH_BitmapChannel, factor: float) -> None: ...
    @overload
    def Filter_Multiply(self, channel: GH_BitmapChannel, factor: float, anchor: Byte) -> None: ...
    def Filter_SatScale(self) -> None: ...
    def Filter_Shift(self, channel: GH_BitmapChannel, amount: Byte) -> None: ...
    def Filter_SpectrumScale(self) -> None: ...
    def Filter_Tint(self, tint: Color, lum_factor: float, sat_factor: float) -> None: ...
    def G(self, x: int, y: int) -> Byte: ...
    @property
    def HasAlphaChannel(self) -> bool: ...
    @property
    def Height(self) -> int: ...
    @property
    def SizeOf(self) -> int: ...
    @property
    def Width(self) -> int: ...
    def OpaqueArea(self) -> Rectangle: ...
    def PadBitmap(bmp: Image, padding: Padding, padding_color: Color) -> Bitmap: ...
    def R(self, x: int, y: int) -> Byte: ...
    def Release(self, includeChanges: bool) -> None: ...
    @overload
    def Sample(self, x: float, y: float, col: Color) -> Tuple[bool, Color]: ...
    @overload
    def Sample(self, x: int, y: int, col: Color) -> Tuple[bool, Color]: ...
    def ShrinkBitmap(image: Bitmap) -> Bitmap: ...


class GH_NoiseTable:
    def Permutation(N: int) -> int: ...
    def Sample(N: int) -> float: ...


class GH_ObjectChangedEventArgs:
    @overload
    def __init__(self, eSender: IGH_DocumentObject, eType: GH_ObjectEventType): ...
    @overload
    def __init__(self, eSender: IGH_DocumentObject, eCustomDescription: str): ...
    @overload
    def __init__(self, eSender: IGH_DocumentObject, eType: GH_ObjectEventType, eTag: Object): ...
    @overload
    def __init__(self, eSender: IGH_DocumentObject, eCustomDescription: str, eTag: Object): ...
    @property
    def CustomType(self) -> str: ...
    @property
    def Sender(self) -> IGH_DocumentObject: ...
    @property
    def Tag(self) -> Object: ...
    @property
    def Type(self) -> GH_ObjectEventType: ...


class GH_ObjectEventType:
    Unset = 0
    NickName = 1
    NickNameAccepted = 2
    Icon = 3
    IconDisplayMode = 4
    Layout = 5
    Sources = 6
    Selected = 7
    Enabled = 8
    Preview = 9
    PersistentData = 10
    DataMatching = 11
    DataMapping = 12
    Options = 13
    Custom = 2147483647


class GH_ObjectSpecies:
    none = 0
    doc_object = 1
    parameter = 16
    component = 32
    group = 64
    wire = 128
    grip_in = 256
    grip_out = 512
    grip = 768
    balloon = 1024
    any = 4294967295


class GH_ObjectType:
    #None = 0
    CompiledObject = 1
    UserObject = 2




class GH_ParamAccess:
    item = 0
    list = 1
    tree = 2


class GH_ParamData:
    unknown = 0
    void = 1
    local = 2
    remote = 3


class GH_ParameterSide:
    Input = 0
    Output = 1


class GH_ParamHashFields:
    #None = 0
    Input = 1
    Output = 2
    InputAndOutput = 3
    InstanceId = 4
    NickName = 8
    Access = 16
    TypeId = 32
    PersistentData = 64
    Expression = 128
    TypeHint = 256
    Sources = 65536
    Recipients = 131072
    SourcesAndRecipients = 196608
    SerialData = 16777216
    All = 16974335


class GH_ParamKind:
    unknown = 0
    floating = 1
    input = 2
    output = 3


class GH_ParamServerEventArgs:
    @property
    def OriginalArguments(self) -> GH_ObjectChangedEventArgs: ...
    @property
    def Parameter(self) -> IGH_Param: ...
    @property
    def ParameterIndex(self) -> int: ...
    @property
    def ParameterSide(self) -> GH_ParameterSide: ...
    @property
    def Server(self) -> GH_ComponentParamServer: ...


class GH_ParamWireDisplay:
    default = 0
    faint = 1
    hidden = 2






class GH_PickBox:
    Window = 0
    Crossing = 1


class GH_PingDocumentEventArgs:
    def __init__(self): ...
    @property
    def Document(self) -> GH_Document: ...
    @Document.setter
    def Document(self, Value: GH_Document) -> None: ...


class GH_PluginFolderType:
    Core = 0
    Default = 1
    RhiFolder = 2
    UserFolder = 3


class GH_PreviewArgs:
    @property
    def DefaultCurveThickness(self) -> int: ...
    @property
    def Display(self) -> DisplayPipeline: ...
    @property
    def Document(self) -> GH_Document: ...
    @property
    def MeshingParameters(self) -> MeshingParameters: ...
    @property
    def ShadeMaterial(self) -> DisplayMaterial: ...
    @property
    def ShadeMaterial_Selected(self) -> DisplayMaterial: ...
    @property
    def Viewport(self) -> RhinoViewport: ...
    @property
    def WireColour(self) -> Color: ...
    @property
    def WireColour_Selected(self) -> Color: ...


class GH_PreviewExpiredEventArgs:
    def __init__(self, eForceRedraw: bool): ...
    @property
    def ForceRedraw(self) -> bool: ...


class GH_PreviewFilter:
    #None = 0
    Selected = 1


class GH_PreviewMesh:
    #None = 0
    LowQuality = 1
    HighQuality = 2
    Document = 3
    Custom = 4


class GH_PreviewMeshArgs:
    def __init__(self, vp: RhinoViewport, pl: DisplayPipeline, mat: DisplayMaterial, meshParams: MeshingParameters): ...
    @property
    def Material(self) -> DisplayMaterial: ...
    @property
    def MeshingParameters(self) -> MeshingParameters: ...
    @property
    def Pipeline(self) -> DisplayPipeline: ...
    @property
    def Viewport(self) -> RhinoViewport: ...


class GH_PreviewMode:
    Disabled = 0
    Wireframe = 1
    Shaded = 2


class GH_PreviewUtil:
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, enable: bool): ...
    def AddBox(self, box: Box) -> None: ...
    def AddBrep(self, brep: Brep) -> None: ...
    def AddCurve(self, curve: Curve) -> None: ...
    def AddLine(self, line: Line) -> None: ...
    def AddMesh(self, mesh: Mesh) -> None: ...
    def AddPlane(self, plane: Plane) -> None: ...
    def AddPoint(self, point: Point3d) -> None: ...
    def AddVector(self, vector: Line) -> None: ...
    def Clear(self) -> None: ...
    def Dispose(self) -> None: ...
    @property
    def Enabled(self) -> bool: ...
    @property
    def WireColour(self) -> Color: ...
    def Redraw(self) -> None: ...
    @Enabled.setter
    def Enabled(self, Value: bool) -> None: ...
    @WireColour.setter
    def WireColour(self, Value: Color) -> None: ...


class GH_PreviewWireArgs:
    def __init__(self, vp: RhinoViewport, pl: DisplayPipeline, col: Color, thickness: int): ...
    @property
    def Color(self) -> Color: ...
    @property
    def Pipeline(self) -> DisplayPipeline: ...
    @property
    def Thickness(self) -> int: ...
    @property
    def Viewport(self) -> RhinoViewport: ...


class GH_PrincipalState:
    CannotBePrincipal = 0
    IsPrincipal = 1
    IsNotPrincipal = 2


class GH_Process:
    @property
    def Handle() -> IntPtr: ...
    @property
    def HandleCount() -> int: ...
    @property
    def HasExited() -> bool: ...
    @property
    def MaxWorkingSet() -> Int64: ...
    @property
    def Name() -> str: ...
    @property
    def PeakPrivateBytes() -> Int64: ...
    @property
    def PrivateBytes() -> Int64: ...
    @property
    def WorkingSet() -> Int64: ...


class GH_ProcessForm:
    def __init__(self): ...
    def FormatBytes(B: Int64) -> str: ...


class GH_ProcessStep:
    PreProcess = 0
    Process = 1
    PostProcess = 2
    Aborted = 3


class GH_ProfilerMode:
    #None = 0
    Processor = 1
    Memory = 2


class GH_RelevantObjectData:
    def __init__(self, pt: PointF): ...
    def CreateBalloonData(self, obj: IGH_DocumentObject) -> None: ...
    def CreateGripData(self, obj: IGH_DocumentObject, is_input: bool) -> None: ...
    def CreateGroupData(self, group: GH_Group) -> None: ...
    def CreateObjectData(self, obj: IGH_DocumentObject) -> None: ...
    def CreateWireData(self) -> None: ...
    @property
    def Attributes(self) -> IGH_Attributes: ...
    @property
    def Group(self) -> GH_Group: ...
    @property
    def IsTopLevelObject(self) -> bool: ...
    @property
    def Object(self) -> IGH_DocumentObject: ...
    @property
    def ObjectType(self) -> GH_ObjectSpecies: ...
    @property
    def Parameter(self) -> IGH_Param: ...
    @property
    def Point(self) -> PointF: ...
    @property
    def TopLevelObject(self) -> IGH_DocumentObject: ...


class GH_RelevantObjectFilter:
    #None = 0
    Groups = 1
    InputGrips = 2
    OutputGrips = 4
    Grips = 6
    Attributes = 8
    Wires = 1024
    All = 2147483647


class GH_RenderArgs:
    @overload
    def __init__(self, doc: RhinoDoc, vp: ViewportInfo, geometry: RenderPrimitiveList, id: Guid): ...
    @overload
    def __init__(self, doc: RhinoDoc, vp: ViewportInfo, geometry: RenderPrimitiveList, id: Guid, matNormal: RenderMaterial, matSelected: RenderMaterial): ...
    @property
    def Document(self) -> RhinoDoc: ...
    @property
    def Geomety(self) -> RenderPrimitiveList: ...
    @property
    def MaterialNormal(self) -> RenderMaterial: ...
    @property
    def MaterialSelected(self) -> RenderMaterial: ...
    @property
    def PluginId(self) -> Guid: ...
    @property
    def Viewport(self) -> ViewportInfo: ...


class GH_Revision:
    def __init__(self): ...
    @property
    def Date(self) -> DateTime: ...
    @property
    def DateTag(self) -> DateTime: ...
    @property
    def Description(self) -> str: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    @DateTag.setter
    def DateTag(self, Value: DateTime) -> None: ...
    @Description.setter
    def Description(self, Value: str) -> None: ...
    def ToString(self) -> str: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_RuntimeMessage:
    def __init__(self, nMessage: str, nType: GH_RuntimeMessageLevel, nSource: str): ...
    @property
    def Event(self) -> DateTime: ...
    @property
    def HasSource(self) -> bool: ...
    @property
    def Message(self) -> str: ...
    @property
    def Source(self) -> str: ...
    @property
    def Type(self) -> GH_RuntimeMessageLevel: ...


class GH_RuntimeMessageLevel:
    Blank = 0
    Warning = 10
    Error = 20
    Remark = 255


class GH_ScheduleDelegate:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, doc: GH_Document, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, doc: GH_Document) -> None: ...


class GH_ScriptComponentUtilities:
    def FindAllNameSpaces(asm: Assembly) -> List: ...
    def FindTopLevelNameSpaces(asm: Assembly) -> List: ...
    @overload
    def ReflectType_CS(obj: Object) -> str: ...
    @overload
    def ReflectType_CS(obj: Object, method_name: str) -> str: ...
    @overload
    def ReflectType_VB(obj: Object) -> str: ...
    @overload
    def ReflectType_VB(obj: Object, method_name: str) -> str: ...


class GH_ScriptInstance:
    def AfterRunScript(self) -> None: ...
    def BeforeRunScript(self) -> None: ...
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    @property
    def Hidden(self) -> bool: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    def InvokeRunScript(self, owner: IGH_Component, rhinoDocument: Object, iteration: int, inputs: List, DA: IGH_DataAccess) -> None: ...
    @Hidden.setter
    def Hidden(self, Value: bool) -> None: ...


class GH_SearchHit:
    def __init__(self, obj: IGH_DocumentObject, weight: int): ...
    def CompareTo(self, other: GH_SearchHit) -> int: ...
    @property
    def Object(self) -> IGH_DocumentObject: ...
    @property
    def Weight(self) -> int: ...


class GH_SelectionState:
    Changed = 0
    Unchanged = 1


class GH_SelectionTopology:
    #None = 0
    Convex = 1
    Concave = 2


class GH_SettingsServer:
    @overload
    def __init__(self, databaseName: str): ...
    @overload
    def __init__(self, databaseName: str, loadSettings: bool): ...
    def Clear(self) -> None: ...
    def ConstainsEntry(self, name: str) -> bool: ...
    def DeleteValue(self, key: str) -> None: ...
    def EntryNames(self) -> List: ...
    def EntryType(self, name: str) -> GH_SettingsType: ...
    @property
    def Count(self) -> int: ...
    @property
    def DatabaseName(self) -> str: ...
    @overload
    def GetValue(self, key: str, default: Byte) -> Byte: ...
    @overload
    def GetValue(self, key: str, default: int) -> int: ...
    @overload
    def GetValue(self, key: str, default: float) -> float: ...
    @overload
    def GetValue(self, key: str, default: DateTime) -> DateTime: ...
    @overload
    def GetValue(self, key: str, default: str) -> str: ...
    @overload
    def GetValue(self, key: str, default: Size) -> Size: ...
    @overload
    def GetValue(self, key: str, default: Point) -> Point: ...
    @overload
    def GetValue(self, key: str, default: Rectangle) -> Rectangle: ...
    @overload
    def GetValue(self, key: str, default: bool) -> bool: ...
    @overload
    def GetValue(self, key: str, default: Color) -> Color: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    @overload
    def SetValue(self, key: str) -> None: ...
    @overload
    def SetValue(self, key: str, value: Color) -> None: ...
    @overload
    def SetValue(self, key: str, value: Size) -> None: ...
    @overload
    def SetValue(self, key: str, value: Point) -> None: ...
    @overload
    def SetValue(self, key: str, value: DateTime) -> None: ...
    @overload
    def SetValue(self, key: str, value: str) -> None: ...
    @overload
    def SetValue(self, key: str, value: float) -> None: ...
    @overload
    def SetValue(self, key: str, value: int) -> None: ...
    @overload
    def SetValue(self, key: str, value: Byte) -> None: ...
    @overload
    def SetValue(self, key: str, value: bool) -> None: ...
    @overload
    def SetValue(self, key: str, value: Rectangle) -> None: ...
    def ShowSettingsBrowser(self, parent: IWin32Window) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...
    def WritePersistentSettings(self) -> None: ...


class GH_SettingsType:
    _null = 0
    _boolean = 1
    _byte = 2
    _integer = 3
    _double = 4
    _string = 6
    _date = 7
    _color = 8
    _point = 9
    _size = 10
    _rectangle = 11
    _unknown = -1


class GH_SolutionEventArgs:
    @property
    def Document(self) -> GH_Document: ...
    @property
    def Duration(self) -> TimeSpan: ...
    @property
    def EndTime(self) -> DateTime: ...
    @property
    def StartTime(self) -> DateTime: ...


class GH_SolutionExpiredEventArgs:
    def __init__(self, eRecompute: bool): ...
    @property
    def Recompute(self) -> bool: ...


class GH_SolutionMode:
    Default = 0
    CommandLine = 1
    Silent = 2


class GH_SolutionPhase:
    Blank = 0
    Collecting = 1
    Collected = 2
    Computing = 3
    Computed = 4
    Failed = 10


class GH_SolutionSpan:
    def __init__(self, t0: DateTime, t1: DateTime): ...
    @property
    def EndTime(self) -> DateTime: ...
    @property
    def StartTime(self) -> DateTime: ...


class GH_State:
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, other: GH_State): ...
    def AddStateObject(self, obj: IGH_StateAwareObject, obj_id: Guid) -> None: ...
    def ClearStates(self) -> None: ...
    def CreateStateFromDocument(self, doc: GH_Document) -> int: ...
    @property
    def Data(self, id: Guid) -> str: ...
    @property
    def Data(self, index: int) -> str: ...
    @property
    def LastModified(self) -> DateTime: ...
    @property
    def Name(self) -> str: ...
    @property
    def StateCount(self) -> int: ...
    @property
    def StateData(self) -> SortedList: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def RemoveStateObject(self, obj_id: Guid) -> None: ...
    @Name.setter
    def Name(self, Value: str) -> None: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_StateServer:
    def __init__(self, owner: GH_Document): ...
    @property
    def Names(self) -> List: ...
    @property
    def Owner(self) -> GH_Document: ...
    def NewStateFromDocument(self) -> GH_State: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def RemoveState(self, index: int) -> bool: ...
    @overload
    def RestoreState(self, name: str) -> Tuple[bool, int, int]: ...
    @overload
    def RestoreState(self, index: int) -> Tuple[bool, int, int]: ...
    @overload
    def RestoreState(self, index: int, recompute: bool) -> Tuple[bool, int, int]: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_StateTag:
    @property
    def Description(self) -> str: ...
    @property
    def Icon(self) -> Bitmap: ...
    @property
    def Name(self) -> str: ...
    @property
    def Stage(self) -> Rectangle: ...
    @property
    def StateDescription(self) -> str: ...
    def Render(self, graphics: Graphics) -> None: ...
    @Stage.setter
    def Stage(self, Value: Rectangle) -> None: ...
    @StateDescription.setter
    def StateDescription(self, Value: str) -> None: ...


class GH_StateTagLayoutDirection:
    Left = 0
    Right = 1


class GH_StateTagList:
    def __init__(self): ...
    @property
    def BoundingBox(self) -> Rectangle: ...
    @property
    def TooltipEnabled(self) -> bool: ...
    def IsTtipPoint(self, canvas_coordinate: PointF) -> bool: ...
    def Layout(self, box: Rectangle, direction: GH_StateTagLayoutDirection) -> None: ...
    def RenderStateTags(self, G: Graphics) -> None: ...
    def TooltipSetup(self, canvasPoint: PointF, e: GH_TooltipDisplayEventArgs) -> None: ...


class GH_StringMatcher:
    def __init__(self): ...
    @overload
    def ComputeWeight(value: str, key: str, comp: StringComparison) -> int: ...
    @overload
    def ComputeWeight(value: str, key: str, level: GH_MatchLevel, comp: StringComparison) -> int: ...
    def LevenshteinDistance(A: str, B: str) -> int: ...


class GH_StringPattern:
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, char_pool: str): ...
    @overload
    def __init__(self, char_pool: str, depth: int): ...
    def Current(self) -> str: ...
    @property
    def FormatMask(self) -> str: ...
    @property
    def StackDepth(self) -> int: ...
    def Next(self) -> str: ...
    def Reset(self) -> None: ...
    @FormatMask.setter
    def FormatMask(self, Value: str) -> None: ...
    @StackDepth.setter
    def StackDepth(self, Value: int) -> None: ...
    @overload
    def SetCharPool(self, char_pool: str) -> None: ...
    @overload
    def SetCharPool(self, char_pool: Iterable[str]) -> None: ...




class GH_TimeKind:
    Unset = 0
    Mixed = 1
    PureTime = 2
    PureDate = 3
    DateAndTime = 4


class GH_TypeLib:


class GH_UndoOperation:
    ClearUndoStack = 0
    ClearRedoStack = 1
    RecordAdded = 2
    RecordRemoved = 3
    Undo = 4
    Redo = 5


class GH_UndoUtil:
    @overload
    def CreateAddObjectEvent(self, name: str, objs: Iterable[IGH_DocumentObject]) -> GH_UndoRecord: ...
    @overload
    def CreateAddObjectEvent(self, name: str, obj: IGH_DocumentObject) -> GH_UndoRecord: ...
    def CreateAddStateEvent(self, name: str, stateIndex: int, state: GH_State) -> GH_UndoRecord: ...
    def CreateEnabledEvent(self, name: str, obj: IGH_ActiveObject) -> GH_UndoRecord: ...
    def CreateGenericObjectEvent(self, name: str, obj: IGH_DocumentObject) -> GH_UndoRecord: ...
    @overload
    def CreateLayoutEvent(self, name: str, obj: IGH_DocumentObject) -> GH_UndoRecord: ...
    @overload
    def CreateLayoutEvent(self, name: str, objs: Iterable[IGH_DocumentObject]) -> GH_UndoRecord: ...
    def CreateNickNameEvent(self, name: str, obj: IGH_DocumentObject) -> GH_UndoRecord: ...
    def CreatePersistentDataEvent(self, name: str, obj: GH_PersistentParam) -> GH_UndoRecord: ...
    @overload
    def CreatePivotEvent(self, name: str, obj: IGH_DocumentObject) -> GH_UndoRecord: ...
    @overload
    def CreatePivotEvent(self, name: str, objs: Iterable[IGH_DocumentObject]) -> GH_UndoRecord: ...
    def CreatePreviewEvent(self, name: str, obj: IGH_ActiveObject) -> GH_UndoRecord: ...
    @overload
    def CreateRemoveObjectEvent(self, name: str, objs: Iterable[IGH_DocumentObject]) -> GH_UndoRecord: ...
    @overload
    def CreateRemoveObjectEvent(self, name: str, obj: IGH_DocumentObject) -> GH_UndoRecord: ...
    def CreateRemoveStateEvent(self, name: str, stateIndex: int, state: GH_State) -> GH_UndoRecord: ...
    def CreateReplaceStateEvent(self, name: str, stateIndex: int, oldState: GH_State, newState: GH_State) -> GH_UndoRecord: ...
    @overload
    def CreateWireEvent(self, name: str, param: IGH_Param) -> GH_UndoRecord: ...
    @overload
    def CreateWireEvent(self, name: str, params: Iterable[IGH_Param]) -> GH_UndoRecord: ...
    def MergeRecords(self, count: int) -> bool: ...
    @overload
    def RecordAddObjectEvent(self, name: str, obj: IGH_DocumentObject) -> Guid: ...
    @overload
    def RecordAddObjectEvent(self, name: str, objs: Iterable[IGH_DocumentObject]) -> Guid: ...
    def RecordAddStateEvent(self, name: str, stateIndex: int, state: GH_State) -> Guid: ...
    def RecordEnabledEvent(self, name: str, obj: IGH_ActiveObject) -> Guid: ...
    @overload
    def RecordEvent(self, record: GH_UndoRecord) -> Guid: ...
    @overload
    def RecordEvent(self, name: str, actions: Iterable[IGH_UndoAction]) -> Guid: ...
    @overload
    def RecordEvent(self, name: str, action: IGH_UndoAction) -> Guid: ...
    @overload
    def RecordEvent(self, name: str, actions: Set(IGH_UndoAction)) -> Guid: ...
    def RecordGenericObjectEvent(self, name: str, obj: IGH_DocumentObject) -> Guid: ...
    @overload
    def RecordLayoutEvent(self, name: str, objs: Iterable[IGH_DocumentObject]) -> Guid: ...
    @overload
    def RecordLayoutEvent(self, name: str, obj: IGH_DocumentObject) -> Guid: ...
    def RecordNickNameEvent(self, name: str, obj: IGH_DocumentObject) -> Guid: ...
    def RecordPersistentDataEvent(self, name: str, obj: GH_PersistentParam) -> Guid: ...
    @overload
    def RecordPivotEvent(self, name: str, objs: Iterable[IGH_DocumentObject]) -> Guid: ...
    @overload
    def RecordPivotEvent(self, name: str, obj: IGH_DocumentObject) -> Guid: ...
    def RecordPreviewEvent(self, name: str, obj: IGH_ActiveObject) -> Guid: ...
    @overload
    def RecordRemoveObjectEvent(self, name: str, objs: Iterable[IGH_DocumentObject]) -> Guid: ...
    @overload
    def RecordRemoveObjectEvent(self, name: str, obj: IGH_DocumentObject) -> Guid: ...
    def RecordRemoveStateEvent(self, name: str, stateIndex: int, state: GH_State) -> Guid: ...
    def RecordReplaceStateEvent(self, name: str, stateIndex: int, oldState: GH_State, newState: GH_State) -> Guid: ...
    @overload
    def RecordWireEvent(self, name: str, params: Iterable[IGH_Param]) -> Guid: ...
    @overload
    def RecordWireEvent(self, name: str, param: IGH_Param) -> Guid: ...


class GH_UpgradeUtil:
    def __init__(self): ...
    @overload
    def MigrateInputParameters(source: IGH_Component, target: IGH_Component) -> bool: ...
    @overload
    def MigrateInputParameters(source: IGH_Component, target: IGH_Component, index0: Set(int), index1: Set(int)) -> bool: ...
    @overload
    def MigrateOutputParameters(source: IGH_Component, target: IGH_Component) -> bool: ...
    @overload
    def MigrateOutputParameters(source: IGH_Component, target: IGH_Component, index0: Set(int), index1: Set(int)) -> bool: ...
    @overload
    def MigrateRecipients(from_: IGH_Param, to: IGH_Param) -> int: ...
    @overload
    def MigrateRecipients(recipients: Iterable[IGH_Param], target: IGH_Param) -> int: ...
    @overload
    def MigrateSources(from_: IGH_Param, to: IGH_Param) -> int: ...
    @overload
    def MigrateSources(sources: Iterable[IGH_Param], target: IGH_Param) -> int: ...
    def ReplaceInputParameters(source: IGH_Component, target: IGH_Component) -> None: ...
    def ReplaceOutputParameters(source: IGH_Component, target: IGH_Component) -> None: ...
    @overload
    def SwapComponents(oldComponent: IGH_Component, newComponent: IGH_Component) -> bool: ...
    @overload
    def SwapComponents(oldComponent: IGH_Component, newComponentGuid: Guid) -> IGH_Component: ...
    @overload
    def SwapComponents(oldComponent: IGH_Component, newComponent: IGH_Component, migrateParameters: bool) -> bool: ...
    @overload
    def SwapComponents(oldComponent: IGH_Component, newComponentGuid: Guid, migrateParameters: bool) -> IGH_Component: ...


class GH_UserObject:
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, source_file: str): ...
    def Clear(self) -> None: ...
    def CreateDefaultPath(self, avoid_conflict: bool) -> None: ...
    @property
    def BaseGuid(self) -> Guid: ...
    @property
    def Data(self) -> Set(Byte): ...
    @property
    def Description(self) -> GH_InstanceDescription: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def Guid(self) -> Guid: ...
    @property
    def Icon(self) -> Bitmap: ...
    @property
    def Path(self) -> str: ...
    def InstantiateObject(self) -> IGH_DocumentObject: ...
    def ReadFromFile(self) -> None: ...
    def SaveToFile(self) -> bool: ...
    @BaseGuid.setter
    def BaseGuid(self, Value: Guid) -> None: ...
    @Data.setter
    def Data(self, Value: Set(Byte)) -> None: ...
    @Description.setter
    def Description(self, Value: GH_InstanceDescription) -> None: ...
    @Exposure.setter
    def Exposure(self, Value: GH_Exposure) -> None: ...
    @Guid.setter
    def Guid(self, Value: Guid) -> None: ...
    @Icon.setter
    def Icon(self, Value: Bitmap) -> None: ...
    @Path.setter
    def Path(self, Value: str) -> None: ...
    def SetDataFromObject(self, obj: IGH_DocumentObject) -> None: ...




class GH_VarParamEventArgs:
    @overload
    def __init__(self, n_param: IGH_Param, n_side: GH_VarParamSide): ...
    @overload
    def __init__(self, n_param: IGH_Param, n_side: GH_VarParamSide, n_index: int): ...
    @property
    def Index(self) -> int: ...
    @property
    def Param(self) -> IGH_Param: ...
    @property
    def Side(self) -> GH_VarParamSide: ...


class GH_VarParamSide:
    Input = 0
    Output = 1


class GH_WireTopology:
    @overload
    def __init__(self): ...
    @overload
    def __init__(self, source_id: Guid, target_id: Guid): ...
    @overload
    def __init__(self, source: IGH_Param, target: IGH_Param): ...
    @overload
    def __init__(self, target: IGH_Param, index: int): ...
    @overload
    def __init__(self, source_id: Guid, target_id: Guid, source_index: int): ...
    def DestroyConnection(self, doc: GH_Document) -> None: ...
    def EnsureConnection(self, doc: GH_Document) -> None: ...
    @property
    def SourceIndex(self) -> int: ...
    @property
    def SourceParameterID(self) -> Guid: ...
    @property
    def TargetParameterID(self) -> Guid: ...
    @property
    def ValidIndex(self) -> bool: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_WireTopologyDiagram:
    def __init__(self): ...
    @overload
    def Add(self, wire: GH_WireTopology, filter_duplicates: bool) -> None: ...
    @overload
    def AppendDiagram(self, doc: GH_Document) -> None: ...
    @overload
    def AppendDiagram(self, objs: Iterable[IGH_DocumentObject]) -> None: ...
    @overload
    def AppendDiagram(self, obj: IGH_DocumentObject) -> None: ...
    def DestroyConnections(self, doc: GH_Document, throw_exceptions: bool) -> None: ...
    def EnsureConnections(self, doc: GH_Document, throw_exceptions: bool) -> None: ...
    def Read(self, reader: GH_IReader) -> bool: ...
    def Write(self, writer: GH_IWriter) -> bool: ...


class GH_ZuiAction:
    @property
    def Name(self) -> str: ...
    @property
    def TooltipEnabled(self) -> bool: ...
    def IsTooltipRegion(self, canvasPoint: PointF) -> bool: ...
    def Perform(self) -> None: ...
    def SetupTooltip(self, canvasPoint: PointF, e: GH_TooltipDisplayEventArgs) -> None: ...


class GHAFileLoadedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: GH_GHALoadingEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: GH_GHALoadingEventArgs) -> None: ...


class IGH_ActiveObject:
    def AddRuntimeMessage(self, Type: GH_RuntimeMessageLevel, Message: str) -> None: ...
    def ClearData(self) -> None: ...
    def ClearRuntimeMessages(self) -> None: ...
    def CollectData(self) -> None: ...
    def ComputeData(self) -> None: ...
    def DependsOn(self, PotentialSource: IGH_ActiveObject) -> bool: ...
    @property
    def IsDataProvider(self) -> bool: ...
    @property
    def Locked(self) -> bool: ...
    @property
    def MutableNickName(self) -> bool: ...
    @property
    def Phase(self) -> GH_SolutionPhase: ...
    @property
    def ProcessorTime(self) -> TimeSpan: ...
    @property
    def RuntimeMessageLevel(self) -> GH_RuntimeMessageLevel: ...
    def RegisterRemoteIDs(self, id_list: GH_GuidTable) -> None: ...
    def RuntimeMessages(self, level: GH_RuntimeMessageLevel) -> List[str]: ...
    def SDKCompliancy(self, exeVersion: int, exeServiceRelease: int) -> bool: ...
    @Locked.setter
    def Locked(self, Value: bool) -> None: ...
    @MutableNickName.setter
    def MutableNickName(self, Value: bool) -> None: ...
    @Phase.setter
    def Phase(self, Value: GH_SolutionPhase) -> None: ...


class IGH_Attributes:
    def AppendToAttributeTree(self, attributes: List) -> None: ...
    def ExpireLayout(self) -> None: ...
    @property
    def AllowMessageBalloon(self) -> bool: ...
    @property
    def Bounds(self) -> RectangleF: ...
    @property
    def DocObject(self) -> IGH_DocumentObject: ...
    @property
    def GetTopLevel(self) -> IGH_Attributes: ...
    @property
    def HasInputGrip(self) -> bool: ...
    @property
    def HasOutputGrip(self) -> bool: ...
    @property
    def InputGrip(self) -> PointF: ...
    @property
    def InstanceGuid(self) -> Guid: ...
    @property
    def IsTopLevel(self) -> bool: ...
    @property
    def OutputGrip(self) -> PointF: ...
    @property
    def Parent(self) -> IGH_Attributes: ...
    @property
    def PathName(self) -> str: ...
    @property
    def Pivot(self) -> PointF: ...
    @property
    def Selected(self) -> bool: ...
    def InvalidateCanvas(self, canvas: GH_Canvas, e: GH_CanvasMouseEvent) -> bool: ...
    def IsMenuRegion(self, point: PointF) -> bool: ...
    @overload
    def IsPickRegion(self, point: PointF) -> bool: ...
    @overload
    def IsPickRegion(self, box: RectangleF, method: GH_PickBox) -> bool: ...
    @overload
    def NewInstanceGuid(self) -> None: ...
    @overload
    def NewInstanceGuid(self, newID: Guid) -> None: ...
    def PerformLayout(self) -> None: ...
    def RenderToCanvas(self, canvas: GH_Canvas, channel: GH_CanvasChannel) -> None: ...
    @Bounds.setter
    def Bounds(self, Value: RectangleF) -> None: ...
    @Parent.setter
    def Parent(self, Value: IGH_Attributes) -> None: ...
    @Pivot.setter
    def Pivot(self, Value: PointF) -> None: ...
    @Selected.setter
    def Selected(self, Value: bool) -> None: ...


class IGH_Author:
    @property
    def Address(self) -> str: ...
    @property
    def Company(self) -> str: ...
    @property
    def Copyright(self) -> str: ...
    @property
    def Email(self) -> str: ...
    @property
    def IsEmpty(self) -> bool: ...
    @property
    def Name(self) -> str: ...
    @property
    def Phone(self) -> str: ...
    @property
    def Website(self) -> str: ...


class IGH_BakeAwareData:
    def BakeGeometry(self, doc: RhinoDoc, att: ObjectAttributes) -> Tuple[bool, Guid]: ...


class IGH_BakeAwareObject:
    @overload
    def BakeGeometry(self, doc: RhinoDoc, obj_ids: List) -> None: ...
    @overload
    def BakeGeometry(self, doc: RhinoDoc, att: ObjectAttributes, obj_ids: List) -> None: ...
    @property
    def IsBakeCapable(self) -> bool: ...


class IGH_Component:
    @property
    def DataComparison(self) -> GH_DataComparison: ...
    @property
    def InConstructor(self) -> bool: ...
    @property
    def IsValidMasterParameterIndex(self) -> bool: ...
    @property
    def MasterParameterIndex(self) -> int: ...
    @property
    def Message(self) -> str: ...
    @property
    def Params(self) -> GH_ComponentParamServer: ...
    @property
    def RunCount(self) -> int: ...
    @DataComparison.setter
    def DataComparison(self, Value: GH_DataComparison) -> None: ...
    @MasterParameterIndex.setter
    def MasterParameterIndex(self, Value: int) -> None: ...
    @Message.setter
    def Message(self, Value: str) -> None: ...


class IGH_DataAccess:
    def AbortComponentSolution(self) -> None: ...
    def BlitData(self, paramIndex: int, tree: GH_Structure, overwrite: bool) -> bool: ...
    @overload
    def DisableGapLogic(self) -> None: ...
    @overload
    def DisableGapLogic(self, paramIndex: int) -> None: ...
    @property
    def Iteration(self) -> int: ...
    @overload
    def GetData(self, name: str, destination: T) -> Tuple[bool, T]: ...
    @overload
    def GetData(self, index: int, destination: T) -> Tuple[bool, T]: ...
    @overload
    def GetDataList(self, name: str, list: List) -> bool: ...
    @overload
    def GetDataList(self, index: int, list: List) -> bool: ...
    @overload
    def GetDataTree(self, index: int) -> Tuple[bool, GH_Structure]: ...
    @overload
    def GetDataTree(self, name: str) -> Tuple[bool, GH_Structure]: ...
    def IncrementIteration(self) -> None: ...
    def ParameterTargetIndex(self, paramIndex: int) -> int: ...
    def ParameterTargetPath(self, paramIndex: int) -> GH_Path: ...
    @overload
    def SetData(self, paramIndex: int, data: Object) -> bool: ...
    @overload
    def SetData(self, paramName: str, data: Object) -> bool: ...
    @overload
    def SetData(self, paramIndex: int, data: Object, itemIndexOverride: int) -> bool: ...
    @overload
    def SetDataList(self, paramIndex: int, data: IEnumerable) -> bool: ...
    @overload
    def SetDataList(self, paramName: str, data: IEnumerable) -> bool: ...
    @overload
    def SetDataList(self, paramIndex: int, data: IEnumerable, listIndexOverride: int) -> bool: ...
    @overload
    def SetDataTree(self, paramIndex: int, tree: IGH_DataTree) -> bool: ...
    @overload
    def SetDataTree(self, paramIndex: int, tree: IGH_Structure) -> bool: ...
    def Util_CountNonNullRefs(self, L: List) -> int: ...
    def Util_CountNullRefs(self, L: List) -> int: ...
    def Util_EnsureNonNullCount(self, L: List, N: int) -> bool: ...
    def Util_FirstNonNullItem(self, L: List) -> int: ...
    def Util_RemoveNullRefs(self, L: List) -> List: ...


class IGH_DebugDescription:
    def AppendToDebugLog(self, writer: GH_DebugDescriptionWriter) -> None: ...


class IGH_DocumentObject:
    def add_AttributesChanged(self, obj: AttributesChangedEventHandler) -> None: ...
    def add_DisplayExpired(self, obj: DisplayExpiredEventHandler) -> None: ...
    def add_ObjectChanged(self, obj: ObjectChangedEventHandler) -> None: ...
    def add_PingDocument(self, obj: PingDocumentEventHandler) -> None: ...
    def add_PreviewExpired(self, obj: PreviewExpiredEventHandler) -> None: ...
    def add_SolutionExpired(self, obj: SolutionExpiredEventHandler) -> None: ...
    def AddedToDocument(self, document: GH_Document) -> None: ...
    def AppendMenuItems(self, menu: ToolStripDropDown) -> bool: ...
    def CreateAttributes(self) -> None: ...
    def DocumentContextChanged(self, document: GH_Document, context: GH_DocumentContext) -> None: ...
    def ExpirePreview(self, redraw: bool) -> None: ...
    def ExpireSolution(self, recompute: bool) -> None: ...
    @property
    def Attributes(self) -> IGH_Attributes: ...
    @property
    def ComponentGuid(self) -> Guid: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def Icon_24x24(self) -> Bitmap: ...
    @property
    def Icon_24x24_Locked(self) -> Bitmap: ...
    @property
    def IconDisplayMode(self) -> GH_IconDisplayMode: ...
    @property
    def Obsolete(self) -> bool: ...
    def IsolateObject(self) -> None: ...
    def MovedBetweenDocuments(self, oldDocument: GH_Document, newDocument: GH_Document) -> None: ...
    def OnAttributesChanged(self) -> None: ...
    def OnDisplayExpired(self, redraw: bool) -> None: ...
    @overload
    def OnObjectChanged(self, customEvent: str) -> None: ...
    @overload
    def OnObjectChanged(self, e: GH_ObjectChangedEventArgs) -> None: ...
    @overload
    def OnObjectChanged(self, eventType: GH_ObjectEventType) -> None: ...
    @overload
    def OnObjectChanged(self, eventType: GH_ObjectEventType, tag: Object) -> None: ...
    @overload
    def OnObjectChanged(self, customEvent: str, tag: Object) -> None: ...
    def OnPingDocument(self) -> GH_Document: ...
    def OnPreviewExpired(self, redraw: bool) -> None: ...
    def OnSolutionExpired(self, recompute: bool) -> None: ...
    @overload
    def RecordUndoEvent(self, record: GH_UndoRecord) -> None: ...
    @overload
    def RecordUndoEvent(self, undoName: str) -> Guid: ...
    @overload
    def RecordUndoEvent(self, undoName: str, action: IGH_UndoAction) -> Guid: ...
    def remove_AttributesChanged(self, obj: AttributesChangedEventHandler) -> None: ...
    def remove_DisplayExpired(self, obj: DisplayExpiredEventHandler) -> None: ...
    def remove_ObjectChanged(self, obj: ObjectChangedEventHandler) -> None: ...
    def remove_PingDocument(self, obj: PingDocumentEventHandler) -> None: ...
    def remove_PreviewExpired(self, obj: PreviewExpiredEventHandler) -> None: ...
    def remove_SolutionExpired(self, obj: SolutionExpiredEventHandler) -> None: ...
    def RemovedFromDocument(self, document: GH_Document) -> None: ...
    @Attributes.setter
    def Attributes(self, Value: IGH_Attributes) -> None: ...
    @IconDisplayMode.setter
    def IconDisplayMode(self, Value: GH_IconDisplayMode) -> None: ...
    @overload
    def TriggerAutoSave(self) -> None: ...
    @overload
    def TriggerAutoSave(self, trigger: GH_AutoSaveTrigger) -> None: ...
    @overload
    def TriggerAutoSave(self, id: Guid) -> None: ...
    @overload
    def TriggerAutoSave(self, trigger: GH_AutoSaveTrigger, id: Guid) -> None: ...


class IGH_DocumentOwner:
    def DocumentClosed(self, document: GH_Document) -> None: ...
    def DocumentModified(self, document: GH_Document) -> None: ...
    def OwnerDocument(self) -> GH_Document: ...


class IGH_EventConsumer:
    def IsRelevantEvent(self, obj: RhinoObject) -> bool: ...
    def PartialExpiration(self, server: GH_CustomEventServer) -> None: ...
    def TotalExpiration(self, server: GH_CustomEventServer) -> None: ...


class IGH_InitCodeAware:
    def SetInitCode(self, code: str) -> None: ...


class IGH_InstanceDescription:
    @property
    def Category(self) -> str: ...
    @property
    def Description(self) -> str: ...
    @property
    def HasCategory(self) -> bool: ...
    @property
    def HasSubCategory(self) -> bool: ...
    @property
    def InstanceDescription(self) -> str: ...
    @property
    def InstanceGuid(self) -> Guid: ...
    @property
    def Keywords(self) -> Iterable[str]: ...
    @property
    def Name(self) -> str: ...
    @property
    def NickName(self) -> str: ...
    @property
    def SubCategory(self) -> str: ...
    @overload
    def NewInstanceGuid(self) -> None: ...
    @overload
    def NewInstanceGuid(self, UUID: Guid) -> None: ...
    @Category.setter
    def Category(self, Value: str) -> None: ...
    @Description.setter
    def Description(self, Value: str) -> None: ...
    @Name.setter
    def Name(self, Value: str) -> None: ...
    @NickName.setter
    def NickName(self, Value: str) -> None: ...
    @SubCategory.setter
    def SubCategory(self, Value: str) -> None: ...


class IGH_InstanceGuidDependent:
    def InstanceGuidsChanged(self, map: SortedDictionary) -> None: ...


class IGH_ObjectProxy:
    def CreateInstance(self) -> IGH_DocumentObject: ...
    def DuplicateProxy(self) -> IGH_ObjectProxy: ...
    @property
    def Desc(self) -> IGH_InstanceDescription: ...
    @property
    def Exposure(self) -> GH_Exposure: ...
    @property
    def Guid(self) -> Guid: ...
    @property
    def Icon(self) -> Bitmap: ...
    @property
    def Kind(self) -> GH_ObjectType: ...
    @property
    def LibraryGuid(self) -> Guid: ...
    @property
    def Location(self) -> str: ...
    @property
    def Obsolete(self) -> bool: ...
    @property
    def SDKCompliant(self) -> bool: ...
    @property
    def Type(self) -> Type: ...
    @Exposure.setter
    def Exposure(self, Value: GH_Exposure) -> None: ...


class IGH_Param:
    @overload
    def AddSource(self, source: IGH_Param) -> None: ...
    @overload
    def AddSource(self, source: IGH_Param, index: int) -> None: ...
    def AddVolatileData(self, path: GH_Path, index: int, data: Object) -> bool: ...
    def AddVolatileDataList(self, path: GH_Path, list: IEnumerable) -> bool: ...
    def AddVolatileDataTree(self, tree: IGH_Structure) -> bool: ...
    def ClearProxySources(self) -> None: ...
    def CreateProxySources(self) -> None: ...
    @property
    def Access(self) -> GH_ParamAccess: ...
    @property
    def DataMapping(self) -> GH_DataMapping: ...
    @property
    def DataType(self) -> GH_ParamData: ...
    @property
    def HasProxySources(self) -> bool: ...
    @property
    def Kind(self) -> GH_ParamKind: ...
    @property
    def Optional(self) -> bool: ...
    @property
    def ProxySourceCount(self) -> int: ...
    @property
    def Recipients(self) -> List[IGH_Param]: ...
    @property
    def Reverse(self) -> bool: ...
    @property
    def Simplify(self) -> bool: ...
    @property
    def SourceCount(self) -> int: ...
    @property
    def Sources(self) -> List[IGH_Param]: ...
    @property
    def StateTags(self) -> GH_StateTagList: ...
    @property
    def Type(self) -> Type: ...
    @property
    def TypeName(self) -> str: ...
    @property
    def VolatileData(self) -> IGH_Structure: ...
    @property
    def VolatileDataCount(self) -> int: ...
    @property
    def WireDisplay(self) -> GH_ParamWireDisplay: ...
    def RelinkProxySources(self, document: GH_Document) -> bool: ...
    def RemoveAllSources(self) -> None: ...
    def RemoveEffects(self) -> None: ...
    @overload
    def RemoveSource(self, source: IGH_Param) -> None: ...
    @overload
    def RemoveSource(self, source_id: Guid) -> None: ...
    @overload
    def ReplaceSource(self, old_source: IGH_Param, new_source: IGH_Param) -> None: ...
    @overload
    def ReplaceSource(self, old_source_id: Guid, new_source: IGH_Param) -> None: ...
    @Access.setter
    def Access(self, Value: GH_ParamAccess) -> None: ...
    @DataMapping.setter
    def DataMapping(self, Value: GH_DataMapping) -> None: ...
    @Optional.setter
    def Optional(self, Value: bool) -> None: ...
    @Reverse.setter
    def Reverse(self, Value: bool) -> None: ...
    @Simplify.setter
    def Simplify(self, Value: bool) -> None: ...
    @WireDisplay.setter
    def WireDisplay(self, Value: GH_ParamWireDisplay) -> None: ...


class IGH_ParamNameConstructor:
    def Current(self) -> str: ...
    def Next(self) -> str: ...
    def Reset(self) -> None: ...


class IGH_ParamWithPostProcess:
    def PostProcessData(self) -> None: ...


class IGH_PreviewArgs:
    @property
    def DefaultCurveThickness(self) -> int: ...
    @property
    def Display(self) -> DisplayPipeline: ...
    @property
    def Document(self) -> GH_Document: ...
    @property
    def MeshingParameters(self) -> MeshingParameters: ...
    @property
    def ShadeMaterial(self) -> DisplayMaterial: ...
    @property
    def ShadeMaterial_Selected(self) -> DisplayMaterial: ...
    @property
    def Viewport(self) -> RhinoViewport: ...
    @property
    def WireColour(self) -> Color: ...
    @property
    def WireColour_Selected(self) -> Color: ...


class IGH_PreviewData:
    def DrawViewportMeshes(self, args: GH_PreviewMeshArgs) -> None: ...
    def DrawViewportWires(self, args: GH_PreviewWireArgs) -> None: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...


class IGH_PreviewMeshData:
    def DestroyPreviewMeshes(self) -> None: ...
    def GetPreviewMeshes(self) -> Set(Mesh): ...


class IGH_PreviewObject:
    def DrawViewportMeshes(self, args: IGH_PreviewArgs) -> None: ...
    def DrawViewportWires(self, args: IGH_PreviewArgs) -> None: ...
    @property
    def ClippingBox(self) -> BoundingBox: ...
    @property
    def Hidden(self) -> bool: ...
    @property
    def IsPreviewCapable(self) -> bool: ...
    @Hidden.setter
    def Hidden(self, Value: bool) -> None: ...


class IGH_ProxyParameter:
    @property
    def ProxyGuid(self) -> Guid: ...


class IGH_RenderAwareData:
    def AppendRenderGeometry(self, args: GH_RenderArgs, material: RenderMaterial) -> None: ...


class IGH_ScriptInstance:
    def AfterRunScript(self) -> None: ...
    def BeforeRunScript(self) -> None: ...
    def InvokeRunScript(self, owner: IGH_Component, rhinoDocument: Object, iteration: int, inputs: List, DA: IGH_DataAccess) -> None: ...


class IGH_StateAwareObject:
    def LoadState(self, state: str) -> None: ...
    def SaveState(self) -> str: ...


class IGH_StateTag:
    @property
    def Description(self) -> str: ...
    @property
    def Icon(self) -> Bitmap: ...
    @property
    def Name(self) -> str: ...
    @property
    def Stage(self) -> Rectangle: ...
    @property
    def StateDescription(self) -> str: ...
    def Render(self, graphics: Graphics) -> None: ...
    @Stage.setter
    def Stage(self, Value: Rectangle) -> None: ...
    @StateDescription.setter
    def StateDescription(self, Value: str) -> None: ...


class IGH_SyncObject:


class IGH_TaskCapableComponent:
    @property
    def InPreSolve(self) -> bool: ...
    @property
    def UseTasks(self) -> bool: ...
    def RequestTaskCancellation(self) -> None: ...
    @InPreSolve.setter
    def InPreSolve(self, Value: bool) -> None: ...
    @UseTasks.setter
    def UseTasks(self, Value: bool) -> None: ...


class IGH_UpgradeObject:
    @property
    def UpgradeFrom(self) -> Guid: ...
    @property
    def UpgradeTo(self) -> Guid: ...
    @property
    def Version(self) -> DateTime: ...
    def Upgrade(self, target: IGH_DocumentObject, document: GH_Document) -> IGH_DocumentObject: ...


class IGH_UserPromptAware:
    def PromptMenuMultipleItems(self) -> ToolStripMenuItem: ...
    def PromptMenuSingleItem(self) -> ToolStripMenuItem: ...
    def PromptMultipleItems(self) -> IGH_Structure: ...
    def PromptSingleItem(self) -> IGH_Goo: ...


class IGH_ValueProxy:
    def Duplicate(self) -> IGH_ValueProxy: ...
    def FromString(self, in: str) -> bool: ...
    @property
    def IsParsable(self) -> bool: ...
    @property
    def IsValid(self) -> bool: ...
    @property
    def ProxyName(self) -> str: ...
    @property
    def ProxyType(self) -> Type: ...
    @property
    def ProxyValue(self) -> Object: ...
    @property
    def UserString(self) -> str: ...
    def MutateString(self, in: str) -> str: ...
    @UserString.setter
    def UserString(self, Value: str) -> None: ...
    def ToString(self) -> str: ...


class IGH_VariableParameterComponent:
    def CanInsertParameter(self, side: GH_ParameterSide, index: int) -> bool: ...
    def CanRemoveParameter(self, side: GH_ParameterSide, index: int) -> bool: ...
    def CreateParameter(self, side: GH_ParameterSide, index: int) -> IGH_Param: ...
    def DestroyParameter(self, side: GH_ParameterSide, index: int) -> bool: ...
    def VariableParameterMaintenance(self) -> None: ...


class IGH_VarParamComponent:
    def ConstructVariable(self, e: GH_VarParamEventArgs) -> IGH_Param: ...
    @property
    def IsInputVariable(self) -> bool: ...
    @property
    def IsOutputVariable(self) -> bool: ...
    def IsVariableParam(self, e: GH_VarParamEventArgs) -> bool: ...
    def ManagerConstructed(self, side: GH_VarParamSide, manager: GH_VariableParameterManager) -> None: ...
    def ParametersModified(self, side: GH_VarParamSide) -> None: ...


class IGH_ZuiAction:
    @property
    def Name(self) -> str: ...
    def Perform(self) -> None: ...


class IRcpAwareObject:
    def PublishRcpItem(self) -> IRcpItem: ...


class ModifiedChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: GH_DocModifiedEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: GH_DocModifiedEventArgs) -> None: ...


class ObjectChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: IGH_DocumentObject, e: GH_ObjectChangedEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: IGH_DocumentObject, e: GH_ObjectChangedEventArgs) -> None: ...


class ObjectsAddedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: GH_DocObjectEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: GH_DocObjectEventArgs) -> None: ...


class ObjectsDeletedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: GH_DocObjectEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: GH_DocObjectEventArgs) -> None: ...


class ParameterChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: GH_ParamServerEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: GH_ParamServerEventArgs) -> None: ...


class ParameterNickNameChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: GH_ParamServerEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: GH_ParamServerEventArgs) -> None: ...


class ParameterSourcesChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: GH_ParamServerEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: GH_ParamServerEventArgs) -> None: ...


class PingDocumentEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: IGH_DocumentObject, e: GH_PingDocumentEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: IGH_DocumentObject, e: GH_PingDocumentEventArgs) -> None: ...


class PreviewExpiredEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: IGH_DocumentObject, e: GH_PreviewExpiredEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: IGH_DocumentObject, e: GH_PreviewExpiredEventArgs) -> None: ...


class SaveOnDataFlatteningChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class SaveOnDocumentUnloadChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class SaveOnObjectAddedChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class SaveOnObjectChangeChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class SaveOnObjectRemovedChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class SaveOnWireEventChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class ScriptFamilyChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class SettingsChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: GH_DocSettingsEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: GH_DocSettingsEventArgs) -> None: ...


class SolutionEndEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: GH_SolutionEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: GH_SolutionEventArgs) -> None: ...


class SolutionExpiredEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: IGH_DocumentObject, e: GH_SolutionExpiredEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: IGH_DocumentObject, e: GH_SolutionExpiredEventArgs) -> None: ...


class SolutionStartEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: GH_SolutionEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: GH_SolutionEventArgs) -> None: ...


class StandardFamilyChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self) -> None: ...


class UndoStateChangedEventHandler:
    def __init__(self, TargetObject: Object, TargetMethod: IntPtr): ...
    def BeginInvoke(self, sender: Object, e: GH_DocUndoEventArgs, DelegateCallback: AsyncCallback, DelegateAsyncState: Object) -> IAsyncResult: ...
    def EndInvoke(self, DelegateAsyncResult: IAsyncResult) -> None: ...
    def Invoke(self, sender: Object, e: GH_DocUndoEventArgs) -> None: ...
